

if (typeof(show_golf_canada) == 'undefined') {
	var show_golf_canada = false;
}
if (typeof(private_club_gate) == 'undefined') {
	var private_club_gate = false;
}
if (typeof(show_geofencing) == 'undefined') {
	var show_geofencing = false;
}
if (typeof(private_allow_guest) == 'undefined') {
	var private_allow_guest = false;
}
if (typeof(hide_promo_share) == 'undefined') {
	var hide_promo_share = false;
	if (private_club_gate) {
		hide_promo_share = true;
	}
}


setTimeout(function() {
	if (navigator.splashscreen) {
		navigator.splashscreen.hide();
	}
}, 4000);

var app = {

	roundInProgress: false,
    devready: false,
    defaultScoringType: 0,
    powerSavingMode: false,

    caps: {
    	fullscoring: true,
    	advertising: true,
    	friendscoring: true,
    	wearables: true,
    	yourbag: true
    },

    club_cache: { },
    default_club_list: [],
    
    initialize: function() {
    	console.log("INITIALIZE...");
        this.bindEvents();
    },
   
   
    bindEvents: function() {
    	console.log('----------- DEVICE READY -----------');
    //	console.log(navigator.userAgent);
    //	app.onDeviceReady();
      //  return true;
      	if (forceWeb) {
      		isWeb = true;
      	}
      
    	if (navigator.userAgent.match(/(iPhone|iPod|iPad|Android|BlackBerry)/) && !isWeb) {
    	  	document.addEventListener("deviceready", function() {
        					app.devReady = true;
                        	app.onDeviceReady();
                        },
                        false);
            
		} else {
			this.onDeviceReady();
		}
		//this.onDeviceReady();
    },
    
    
    onDeviceReady: function() {
    	console.log("DEVICE READY...");

        ons.ready(function() {
        	
        	console.log("ONS Ready...");

        	if (typeof(device) != 'undefined' && typeof(device.platform) != 'undefined') {
	        	isAndroid = false;
				isIOS = false;
				isBB = false;
				isWeb = false;
				useWebMap = false;

				if (device.platform == "Android") {
					isAndroid = true;
				}
				else if (device.platform == "iOS") {
					isIOS = true;
				}
				else {
					isWeb = true;
					useWebMap = true;
				}
					
			}

	
			setupGeofenceClickListener();
        	initAppleWatch();
        	configBackgroundGeolocation();	// make sure it doesn't start too soon

 
        	initAnalytics();
			myNavigator.on('postpush', function(ev) {
				trackView(ev.enterPage.page);
			});
	
        	
			user.checkAuth(function() {

				console.log("Auth Good...");

				if (is_club_app) {
					if (app.checkPrivateClubGate()) {
						app.getClubAppInfo(function() {
							app.openHome();
						});
					}
					else {
						app.getClubAppInfo();
					}
				}
				else {
					app.openHome();
				}

				setTimeout(function() {
					$('.loading-app').fadeOut();
				}, 600);

				setTimeout(function() {
					if (navigator.splashscreen) {
						navigator.splashscreen.hide();
					}
				}, 10);
			}, 
			function(err) {

				console.log("Auth Err..." + is_club_app);
				if (is_club_app) {
					if (app.checkPrivateClubGate()) {
						app.getClubAppInfo(function() {
							app.openHome();
						});
					}
					else {
						app.getClubAppInfo();
					}
				}
				else {
					console.log("Login Page: " + login_page);
					myNavigator.resetToPage(login_page);
				}

				setTimeout(function() {
					$('.loading-app').fadeOut();
				}, 600);
			
				setTimeout(function() {
					if (navigator.splashscreen) {
						navigator.splashscreen.hide();
					}
				}, 10);

			}, 
			function() {
				// No need for this	
				console.log('Got to a place we should not have.');
			});
		
				// check android versions
			if (typeof(device) != 'undefined') {
				if(device.platform == 'Android') {
					if (parseFloat(device.version) < 4.4) {
						//useWebMap = true;
					}
				}
			}
		
			setTimeout(function() {
				if (isBB || isWeb || useWebMap) {		
					var script = document.createElement('script');
					script.type = 'text/javascript';
					script.src = 'https://maps.googleapis.com/maps/api/js?v=3.exp&key='+GoogleMapsAPI+'&callback=initializeMap';
					document.body.appendChild(script);	
				}
			}, 200);
			
			
			trackOpen();


				// we are going to update the club info every 5 minutes or so when on the home screen
			if (is_club_app) {
				setInterval(function() {
					var currentPage = myNavigator.getCurrentPage();
					if (currentPage.page == 'homecourse.html') {
						app.getClubAppInfo(function() { });
					}
				}, 1000 * 60 * 5);
				//}, 3000);
			}

        });
    },
    
    isOnboarded: function() {
    	var onboarded = false;
		if (window.localStorage['onboarded']) {
			onboarded = window.localStorage['onboarded'];
		}

		return onboarded;
    },
    setOnboarded: function() {
    	window.localStorage['onboarded'] = true;
    },
    
    
    doSignin: function(callback, successCallback) {
    	user.signin(
    			$('#signinEmail').val(), 
    			$('#signinPassword').val(), 
    			function(user) { 
    				callback();

    				if (!app.isOnboarded()) {
    					myNavigator.pushPage('onboarding1.html', { afteronboard: successCallback });
    				}
    				else {
    					app.openHome();
    					if (typeof(successCallback) == 'function') {
    						successCallback();
    					}
    					
    				}
    			}, 
    			function(msg) {
    				callback(); 
    				navigator.notification.alert("We had problems signing you in.  " + msg);
    			}, 
    			function() { 
    			
    			});
    },

	homeActionButton: function(btnIndex) {

		var btn_info = whitelabel.banner_buttons[btnIndex];

		app.appBtnActions(btn_info);

	},

    appBtnActions: function(btn_info) {
    		/*
    		 	btn_info = {
					action: 'match the action below',
					url: 'optional'
    		 	}
    		 */

    	var btnActions = {
    		'link': function(btn_info) {
    			openCustomLink(btn_info.url);
    		},
    		'link-external': function(btn_info) {
    			openCustomLink(btn_info.url, true);
    		},
    		'info': function(btn_info) {
    			myNavigator.pushPage('courseinfo.html', { 
     								label: 'Club Info',
     								onTransitionEnd: function() {
     									
     								}
     							});
    		},
    		'contact': function(btn_info) {
    			myNavigator.pushPage('contact.html', { 
     								label: 'Contact Us',
     								onTransitionEnd: function() {
     									
     								}
     							});
    		},
    		'weather': function(btn_info) {
    			openWindow(whitelabel.weatherURL);
    		},
    		'leaderboard': function(btn_info) {
    			myNavigator.pushPage('leaderboard.html', { 
     								label: 'Leaderboard',
     								club_id: whitelabel.course.club_id,
     								onTransitionEnd: function() {
     									
     								}
     							});
    		},
    		'rounds': function(btn_info) {
    			if (user.isSignedIn()) {
 					myNavigator.pushPage('rounds.html', { 
 								user: user.info,
 								label: 'Rounds',
 								apicall: 'apirounds',
 								onTransitionEnd: function() {
 									
 								}
 							});
 				}
 				else {
 					myNavigator.pushPage(login_page);
 				}
    		},
    		'honours': function(btn_info) {
    			if (user.isSignedIn()) {
 					myNavigator.pushPage('honours.html', { 
 								user: user.info,
 								label: 'Honours',
 								apicall: 'apihonours',
 								onTransitionEnd: function() {
 									
 								}
 							});
 				}
 				else {
 					myNavigator.pushPage(login_page);
 				}
    		},
    		'tour': function(btn_info) {
    			if (user.isSignedIn()) {
 					myNavigator.pushPage('tour.html', { 
 								user: user.info,
 								label: 'Tour',
 								onTransitionEnd: function() {
 									
 								}
 							});
 				}
 				else {
 					myNavigator.pushPage(login_page);
 				}
    		},
    		'gallery': function(btn_info) {
    			if (user.isSignedIn()) {
 					myNavigator.pushPage('gallery.html', { 
 								user: user.info,
 								label: 'Gallery',
 								onTransitionEnd: function() {
 									
 								}
 							});
 				}
 				else {
 					myNavigator.pushPage(login_page);
 				}
    		},
    		'teetime': function(btn_info) {
    			if (!app.isPrivateGuest(true)) {
 					myNavigator.pushPage('teetime.html', { 
 								label: 'Tee Times',
 								onTransitionEnd: function() {
 									
 								}
 							});
 				}
    		},
    		'teetime-themed': function(btn_info) {
    			if (!app.isPrivateGuest(true)) {
 					myNavigator.pushPage('./theme/course/teetimesignin.html', { 
 								label: 'Tee Times',
 								onTransitionEnd: function() {
 									
 								}
 							});
 				}
    		},
    		'food': function(btn_info) {
    			openCustomLink(whitelabel.foodURL);
    		},
    		'proshop': function(btn_info) {
    			openCustomLink(whitelabel.proshopURL);
    		},
    		'profile': function(btn_info) {
    			if (user.isSignedIn()) {
 					myNavigator.pushPage('user.html', { user_obj: user.info });
 				}
 				else {
 					myNavigator.pushPage(login_page);
 				}
    		},
    		'play': function(btn_info) {
    			if (user.isSignedIn()) {
     				if (app.roundInProgress) {
     					myNavigator.resetToPage('play.html', { round_id: app.roundInProgress.Round.id });
     				}
     				else {
	     				myNavigator.pushPage('newround.html', {
     								onTransitionEnd: function() {
     									
     								}
     							});
     				}
     			}
     			else {
 					myNavigator.pushPage(login_page);
 				}
    		},
    		'stats': function(btn_info) {
    			if (user.isSignedIn()) {
 					myNavigator.pushPage('stats.html', { 
 								user: user.info,
 								label: 'Stats',
 								onTransitionEnd: function() {
 									
 								}
 							});
 				}
     			else {
 					myNavigator.pushPage(login_page);
 				}
    		},
    		'promo': function(btn_info) {
    			if (!app.isPrivateGuest(true)) {
 					myNavigator.pushPage('offers.html', { 
 								label: whitelabel.promo_link,
 								onTransitionEnd: function() {
 									
 								}
 							});
 				}
    		},
    		'feed': function(btn_info) {
    			if (user.isSignedIn()) {
 					myNavigator.pushPage('rounds.html', { 
 								user: user.info,
 								label: 'Golf Central',
 								apicall: 'apifeed',
 								onTransitionEnd: function() {
 									
 								}
 							});
 				}
     			else {
 					myNavigator.pushPage(login_page);
 				}
    		},

    	};

    	
    	if (btnActions[btn_info['action']]) {
    		btnActions[btn_info['action']](btn_info);
    	}

    },

    getClubAppInfo: function(callback) {
    	if (typeof(callback) == 'undefined') {
    		callback = function() {};
    	}
    	//whitelabel.course.club_id
    	$.ajax({
				url: APIHOST + '/courses/apiclubappdetails/'+whitelabel.course.club_id+'/',
				method: 'GET',
				cache: false,
				data: { },
				success: function(data) {
					if (data.data) {
						var club = data.data;

						if (club.Club.weather) {
							whitelabel.weatherURL = club.Club.weather;
						}
						whitelabel.contact.phone = club.Club.phone;
						whitelabel.contact.website = club.Club.website;
						whitelabel.contact.facebook = club.Club.facebook;
						if (club.Club.twitter != '') {
							whitelabel.contact.twitter = 'https://twitter.com/' + club.Club.twitter;
						}
						else {
							whitelabel.contact.twitter = false;
						}

						if (club.Club.background) {
							whitelabel.banner = club.Club.background;
						}

						var address_array = [];
						if (club.Club.address.length > 0) {
							address_array.push(club.Club.address);
						}
						if (club.Club.city.length > 0) {
							address_array.push(club.Club.city);
						}
						if (club.Club.state.length > 0) {
							address_array.push(club.Club.state);
						}
						whitelabel.contact.address = address_array.join(', ');

						if (club.Club.teetimephone) {
							whitelabel.teetime.phone = club.Club.teetimephone;
						}
						if (club.Club.teetimepublic) {
							whitelabel.teetime.public = club.Club.teetimepublic;
						}
						if (club.Club.teetimemember) {
							whitelabel.teetime.member = club.Club.teetimemember;
						}
						if (club.Club.teetimeinfo) {
							whitelabel.teetime.info = club.Club.teetimeinfo;
						}
						if (club.Club.infolinks) {
							whitelabel.course.infolinks = club.Club.infolinks;
						}

						whitelabel.course.desc = club.Club.description;

						whitelabel.groups = [];
						if (club.Groups && club.Groups.length > 0) {
								// these are groups that users can sub and unsub from for push
							whitelabel.groups = club.Groups;
						}

						whitelabel.bulletin = club.Club.bulletin;

						app.checkBulletin();
					}
					
					callback();
				},
				error: function() {
					callback();
				}
			});
    },

    cacheClub: function() {
    	console.log("Caching Clubs Nearby");

    	window.localStorage['clubCache'] = JSON.stringify(user.offers);
    	if (typeof(window.localStorage['clubCache']) != 'undefined' && window.localStorage['clubCache'] != "") {
    		app.club_cache = JSON.parse(window.localStorage['clubCache']);   		
    	}
    	if (typeof(window.localStorage['defaultClubList']) != 'undefined' && window.localStorage['defaultClubList'] != "") {
    		app.default_club_list = JSON.parse(window.localStorage['defaultClubList']);
    	}

    	
    	var loadDefaultClubList = function() {
    		console.log("Action Happening");
			var params = {tk: user.tk, uk: user.uk, pk: user.pk};
			
			if (typeof(whitelabel.gps_coords) != 'undefined') {
				var gps_coords = whitelabel.gps_coords.split(',');
				params['lat'] = gps_coords[0];
				params['lng'] = gps_coords[1];
				params['date'] = new Date().toString();
				
				$.ajax({
				   url: APIHOST + '/courses/apifind/page:1/limit:4/',
				   method: 'GET',
				   data: params,
				   success: function(data) {
				   		console.log('loaded');
				   		console.log(data);
				   		var courses = data.data;
				   		$.each(courses, function(i, course) {
				   			if (course.Course.name == course.Club.name) {
				   				courses[i].Course.name = '';
				   			}
				   			courses[i].Club.avatar = getClubAvatar(courses[i]);
				   		});
				   		
						app.default_club_list = courses;
						window.localStorage['defaultClubList'] = JSON.stringify(app.default_club_list);

						$.each(app.default_club_list, function(i, course) {
							
							$.ajax({
									   url: APIHOST + '/courses/apicoursedetails/',
									   method: 'GET',
									   data: {tk: user.tk, uk: user.uk, pk: user.pk, id: course.Course.id},
									   success: function(data) {
											app.default_club_list[i] = data.data;
											window.localStorage['defaultClubList'] = JSON.stringify(app.default_club_list);
									   },
									   error: function() {
								   
									   }
									});
							
						});
				   },
				   error: function() {
						
				   }
				});
			}
		}


		loadDefaultClubList();

    },

	checkPrivateClubGate: function() {

		

		if (private_club_gate === false) {
				// not a private club.  Let them through
			return true;
		}
		else {
			if (typeof(user.privatemember.guest) != 'undefined' && user.privatemember.guest == true) {
				return true;
			}

			if (typeof(user.privatemember.username) != 'undefined') {
				return true;
			}

			if (window.localStorage['privatemember']) {
				try {
					user.privatemember = JSON.parse(window.localStorage['privatemember']);
				}
				catch(err) {

				}

				if (typeof(user.privatemember.username) != 'undefined') {
					return true;
				}
				if (typeof(user.privatemember.guest) != 'undefined' && user.privatemember.guest == true) {
					return true;
				}
			}

				// so, this person has not proved themselves.  Let us challenge them
			myNavigator.pushPage(private_club_gate);
		}
		
		return false;

	},

    openHome: function() {
    	
    	myNavigator.resetToPage(home_page, {
    		onTransitionEnd: function() {
    			

    			var page = myNavigator.getCurrentPage();
    			var pageElm = $(page.element);
    			
    			pageElm.find('.title').html(whitelabel.app_header_title);
    			

    			
    				// set some heights;
    			var w_h = parseInt($(window).height());
    			var w_w = parseInt($(window).width());
    			var tb_h = parseInt(pageElm.find('ons-toolbar').outerHeight());
    			var hc_h = parseInt(pageElm.find('.home-card').outerHeight());
    			var hsb_h = parseInt(pageElm.find('.home-stats-bar').outerHeight());


    				// first let us adjust the home image height
    				// if this seems to be a smaller or wider screen - don't mess with it.
    			var new_homecard_h = w_w * 300 / 587;
    			if (w_h / 2 > new_homecard_h) {		// don't want it to take up the entire screen
    				console.log('hi');
    				pageElm.find('.home-card').height(new_homecard_h);
    				hc_h = parseInt(pageElm.find('.home-card').outerHeight());
    			}


    			var hmm_h = w_h - (tb_h + hc_h + hsb_h);
    			//pageElm.find('.home-main-menu').height(hmm_h);
    			var mi_h = hmm_h / 2 - 5;
    			var mi_w = parseInt(pageElm.find('.home-action-btn').width());
    			
    				// this resize is causing issues with the home screen blanking out.
    			var doResize = false;
				if (mi_h > 120 && mi_h < 320) {
    				doResize = true;
    			}
    			else if (mi_h > 120 && mi_w > mi_h * 0.8) {
    				doResize = true;
    			}

    			if (doResize) {
	    			pageElm.find('div.home-action-btn').each(function() {
						$(this).height(mi_h + "px");
						//$(this).animate({height:mi_h + "px"}, 10);
					});
						// for some reason we need to do this after a timeout again or things dissappear
					setTimeout(function() {
						pageElm.find('div.home-action-btn').each(function() {
							//$(this).height(mi_h + "px");
							$(this).animate({height:mi_h + "px"}, 10);
						});
					}, 350);
				}
    			
    			
    			function updateUserInfo() {
					if (user.info.User.handicap == null) {
						user.info.User.handicap = 36;
					}
				
					pageElm.find('.home-card-rounds .action-icon').html(user.info.User.totalrounds);
					pageElm.find('.home-card-honours .action-icon').html(user.info.User.totalhonours);
					pageElm.find('.home-card-tour .action-icon').html(user.info.User.following);
					pageElm.find('.home-card-gallery .action-icon').html(user.info.User.followers);
					//pageElm.find('.home-card-desc').html('HDCP: '+user.info.User.handicap);
					pageElm.find('.home-card-name').html(user.info.User.name);
					//var role = 'GOLFJET GUEST';
					var role = '';
					if (user.info.Golfjetuser && user.info.Golfjetuser.role) {
						role = 'GOLFJET MEMBER';
					}
					else if (user.info.Golfjetuser && typeof(user.info.Golfjetuser.trialdays) != 'undefined') {
						if (parseInt(user.info.Golfjetuser.trialdays) > 0) {
							//role += ' <span style="font-size:80%;">(Member Trial)</span>';
						}
					}
				
					if (typeof(user.info.Golfjetuser) != 'undefined') {
						pageElm.find('.home-card-sub').show();
						pageElm.find('.home-card-sub').html(role);
					}
					else {
						pageElm.find('.home-card-sub').hide();
					}
					pageElm.find('.home-card-avatar').css({
										'background-image': 'url('+getUserAvatar(user.info)+'?cc='+Math.random()+')'
									});
					pageElm.find('.home-card-background').css({
										'background-image': 'url('+user.info.User.background+'?cc='+Math.random()+')'
									});

				
						// make circle
					pageElm.find('.user-stat-handicap .user-stat_figure span').html(user.info.User.handicap);	
					var num = 36 - user.info.User.handicap;
					var max = 36;
					var canvas = pageElm.find('.user-stat-handicap').get(0).getElementsByTagName('canvas')[0]; 
					//var colors = ['#71F128', '#1CCB5C', '#00A0A5', '#0054E0', '#150F36' ];
					var colors = ['#150F36', '#0054E0', '#00A0A5', '#1CCB5C', '#71F128' ];
					makeCircle(num, max, canvas, colors);

					var points = 0;
					if (user.info.Golfjetuser && user.info.Golfjetuser.points) {
						points = user.info.Golfjetuser.points;
					}
					if (typeof(user.info.Golfjetuser) != 'undefined') {
						pageElm.find('.user-stat-points').show();
					}
					else {
						pageElm.find('.user-stat-points').hide();
					}
					pageElm.find('.user-stat-points .user-stat_figure span').html(points+'<span class="pts">pts</span>');	
					var num = points;
					var max = 1000;
					var canvas = pageElm.find('.user-stat-points').get(0).getElementsByTagName('canvas')[0]; 
					var colors = ['#4F4733', '#A4A4A4', '#E1B159', '#EDF6F6'];
					makeCircle(num, max, canvas, colors);
				
				
					var ball = 0;
					if (user.info.Golfjetuser && user.info.Golfjetuser.ball) {
						ball = user.info.Golfjetuser.ball;
					}
					if (typeof(user.info.Golfjetuser) != 'undefined' && ball != 0) {
						pageElm.find('.user-stat-ball').show();
					}
					else {
						pageElm.find('.user-stat-ball').hide();
					}
					if (ball == 3) {
						pageElm.find('.user-stat-ball .user-stat_figure span').html('<span class="ball" style="display:inline-block;width:38px;height:40px;margin:5px 6px;"><img src="theme/golfjet/img/jet3.svg" style="width:100%;height:100%;" /></span>');	
					}
					else if (ball == 4) {
						pageElm.find('.user-stat-ball .user-stat_figure span').html('<span class="ball" style="display:inline-block;width:38px;height:40px;margin:5px 6px;"><img src="theme/golfjet/img/jet4.svg" style="width:100%;height:100%;" /></span>');	
					}
				
					var num = 0;
					var max = 1;
					var canvas = pageElm.find('.user-stat-ball').get(0).getElementsByTagName('canvas')[0]; 
					var colors = ['#97896C', '#97896C'];
					makeCircle(num, max, canvas, colors);
				
					pageElm.find('.home-action-promo .home-action-label').html(whitelabel.promo_link);
 
	  /*
					pageElm.find('.user-stat-ball .user-stat_figure span').html(ball);	
					var canvas = pageElm.find('.user-stat-points').get(0).getElementsByTagName('canvas')[0]; 
					var colors = ['#947E4E'];
					makeCircle(0, 0, canvas, colors);
	*/
				}
				function updateUserInfoCourse() {
					pageElm.find('.home-action-avatar').css({
										'background-image': 'url('+getUserAvatar(user.info)+'?cc='+ new Date().getTime() +')'
									});
					if (whitelabel.banner) {
						pageElm.find('.home-card-course-bg').css({
										'background-image': 'url('+whitelabel.banner+')'
									});
					}
				}

				if (home_page == 'home.html') {
					updateUserInfo();
				}
				else {
					updateUserInfoCourse();
				}
			
				setTimeout(function() {
					user.refresh(function() {
						if (home_page == 'home.html') {
							updateUserInfo();
						}
						else {
							updateUserInfoCourse();
						}

						if (app.isOnboarded()) {
							setupGeofencing();
						}
					}, function() {
					
					});
				}, 200);
			


				pageElm.find('.home-action-info, .home-card-0').click(function() {
     				app.homeActionButton(0);
     			});
     			pageElm.find('.home-action-info, .home-card-1').click(function() {
     				app.homeActionButton(1);
     			});
     			pageElm.find('.home-action-info, .home-card-2').click(function() {
     				app.homeActionButton(2);
     			});
     			pageElm.find('.home-action-info, .home-card-3').click(function() {
     				app.homeActionButton(3);
     			});


				
     			pageElm.find('.home-card-rounds').click(function() {
     				app.appBtnActions({
     						action: 'rounds'
     					});
     			});
     			pageElm.find('.home-card-honours').click(function() {
     				app.appBtnActions({
     						action: 'honours'
     					});
     			});
     			pageElm.find('.home-card-tour').click(function() {
     				app.appBtnActions({
     						action: 'tour'
     					});
     			});
     			pageElm.find('.home-card-gallery').click(function() {
     				app.appBtnActions({
     						action: 'gallery'
     					});
     			});

     			pageElm.find('.home-card-contact').click(function() {
     				app.appBtnActions({
     						action: 'contact'
     					});
     			});
     			pageElm.find('.home-card-teetime, .home-action-teetime').click(function() {
     				app.appBtnActions({
     						action: 'teetime'
     					});
     			});

     			pageElm.find('.home-card-leaderboard').click(function() {
     				app.appBtnActions({
     						action: 'leaderboard'
     					});
     			});
     			pageElm.find('.home-card-weather').click(function() {
     				app.appBtnActions({
     						action: 'weather'
     					});
     			});

     			pageElm.find('.home-card-food').click(function() {
     				app.appBtnActions({
     						action: 'food'
     					});
     			});
     			pageElm.find('.home-card-proshop').click(function() {
     				app.appBtnActions({
     						action: 'proshop'
     					});
     			});
     			

     			

     			pageElm.find('.home-action-info, .home-card-info').click(function() {
     				app.appBtnActions({
     						action: 'info'
     					});
     			});
     			pageElm.find('.home-action-profile').click(function() {
     				app.appBtnActions({
     						action: 'profile'
     					});
     			});


     			pageElm.find('.home-action-play').click(function() {
     				app.appBtnActions({
     						action: 'play'
     					});
     			});
     			
     			pageElm.find('.home-action-stats').click(function() {
     				app.appBtnActions({
     						action: 'stats'
     					});
     			});
     			
     			pageElm.find('.home-action-promo').click(function() {
     				app.appBtnActions({
     						action: 'promo'
     					});
     			});
     			

     			pageElm.find('.home-action-account').click(function() {
     				app.appBtnActions({
     						action: 'teetime-themed'
     					});
     			});


     			pageElm.find('.home-action-feed').click(function() {
     				app.appBtnActions({
     						action: 'feed'
     					});
     			});
     			

				app.checkRoundInProgress();    

				console.log("Home Page Should be Loaded");			
    		}
    	});
    	
    	
    	
    },

    checkBulletin: function() {
    	
    	var bulletinHtml = "";
    	if (whitelabel.bulletin && whitelabel.bulletin != "") {
    		if ($('.home-card-course-bg .club-bulletin').length > 0) {
    			$('.home-card-course-bg .club-bulletin').html(whitelabel.bulletin);
    		}
    		else {
    			$('.home-card-course-bg').append('<div class="club-bulletin alert alert-warning">' + whitelabel.bulletin + '</div>');
    		}

    		setTimeout(function () {
					$('.home-card-course-bg .club-bulletin a').click(function () {
							var url = $(this).attr('href');
							window.open(encodeURI(url), '_system');
							return false;
					    });
				}, 100);
    	}
    	else {
    		$('.home-card-course-bg .club-bulletin').hide();
    	}
    	
    },
    
    checkRoundInProgress: function() {

    	if (window.localStorage['savedRound'] && window.localStorage['savedRound'] != '') {
    			// something bad happened and we have a round just laying here.  Lets save it.
    		try {
    			oldSavedRound = JSON.parse(window.localStorage['savedRound']);
    			$.ajax({
				   url: APIHOST + '/users/apisaveround/',
				   method: 'POST',
				   data: oldSavedRound,
				   success: function(data) {
				   		window.localStorage['savedRound'] = '';
				   		checkUnfinished();
				   },
				   error: function(err) {
				   		checkUnfinished();
				   }
				});
    		}
    		catch (err) {
    			// nothing
    		}
    	}
    	else {
    		checkUnfinished();
    	}

    	function checkUnfinished() {
    		if (user.isSignedIn()) {
			 	$.ajax({
					url: APIHOST + '/users/apiunfinished/'+user.info.User.username+'/',
					method: 'GET',
					cache: false,
					data: {tk: user.tk, uk: user.uk, pk: user.pk},
					success: function(data) {
						var roundInProgress = data.data;
						if (typeof(roundInProgress.Round) != 'undefined') {
							app.roundInProgress = roundInProgress;
							$('.home-action-play .home-action-label').html('Continue Round');
							$('.home-action-play').addClass('highlight');
						}
						else {
							$('.home-action-play .home-action-label').html(whitelabel.home_labels.play);
							$('.home-action-play').removeClass('highlight');
						}
					},
					error: function(data) {
						$('.home-action-play .home-action-label').html(whitelabel.home_labels.play);
						$('.home-action-play').removeClass('highlight');
					}
				});
			}
		 }


    },
    
    doSignout: function() {
    	user.signout(function() {
    		
    		//myNavigator.resetToPage(login_page);
    		app.openHome();
    		myNavigator.pushPage(login_page);
    	},
    	function() {
    		//myNavigator.resetToPage(login_page);
    		myNavigator.pushPage(login_page);
    	});
    },

    isPrivateGuest(show_login) {
    	if (private_allow_guest && typeof(user.privatemember.guest) !== 'undefined' && user.privatemember.guest == true) {
			if (show_login) {
				myNavigator.pushPage(private_club_gate, { is_guest: true });
			}
			return true;
		}
		return false;
    }
    
   
};




offcourseApp.factory('ParamService', function($rootScope) {
	var parameters = {};
	var changeListeners = {};
	
	var serviceParams = {
		addChangeListener: function(listnrKey, listnrFunc) {
			changeListeners[listnrKey] = listnrFunc;
		},
		removeChangeListener: function(listnrKey) {
			delete changeListeners[listnrKey];
		},
		runChangeListeners: function() {
			$.each(changeListeners, function(i, func) {
				if(typeof(func) == 'function') {
					func(parameters);
				}
			});
		},
		setParams: function(newVars) {
			$.extend(parameters, newVars);
			serviceParams.runChangeListeners();
		},
		getParams: function() {
			return parameters;
		}
	};
	
	return serviceParams;
});



offcourseApp.controller('MenuController', function($scope, $rootScope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);

	$rootScope.is_club_app = is_club_app;
	$rootScope.isWeb = isWeb;
	$rootScope.isSignedIn = user.isSignedIn();
	$scope.enableWearables = app.caps.wearables;
	$scope.showFeedback = showFeedback;
	$rootScope.show_golf_canada = (show_golf_canada === true) ? true : false;

	
	$scope.show_geofence_link = false;
	if ((user.uk == 5 || user.uk == 9) && show_geofencing) {
		$scope.show_geofence_link = true;
	}

	$scope.changePassword = function() {
		if (whitelabel.change_password) {
			window.open(whitelabel.change_password, '_system');
		}
		else {
			myNavigator.pushPage('editpassword.html', { });
		}
	}

	$scope.sendFeedback = function() {
		sendEmail(whitelabel.feedback_title, '', [whitelabel.feedback_email]);
		
	}
	
	$scope.openMyAccount = function() {
		window.open(whitelabel.change_password, '_system');
	}

	$scope.menuSignIn = function() {
		myNavigator.popPage();
		myNavigator.pushPage(login_page);
	}

	$scope.aboutApp = function() {
		myNavigator.pushPage('about.html');
	}

});





offcourseApp.controller('GeofencesController', function($scope, $rootScope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);

	$rootScope.is_club_app = is_club_app;
	$rootScope.isWeb = isWeb;
	$rootScope.isSignedIn = user.isSignedIn();
	
	$scope.geofences = [];
	if (typeof(window.geofence) != 'undefined') {
		window.geofence.getWatched(function (geofencesJson) {
				// at this point we are going to remove any that don't match with the server
			console.log('**** Watched GeoFences ');
			//console.log("The watched geofences", geofencesJson);
		    $scope.geofences = JSON.parse(geofencesJson);
		    
		    $scope.$apply(function() { });
		});
	}
	
	$scope.openMap = function(geofence) {
		setTimeout(function() {	
			//var openAddress = "zoom=12&q=" + geofence.latitude + ',' + geofence.longitude + "";
			var openAddress = "https://www.google.com/maps/place/"+geofence.latitude+","+geofence.longitude+"/@"+geofence.latitude+","+geofence.longitude+",14z/";
			console.log(openAddress);
			openCustomLink(openAddress);

		/*	if (typeof(device) != 'undefined' && device.platform == 'iOS') {
				window.open("http://maps.apple.com/?"+openAddress, '_system');
			}
			else {
				window.open("http://maps.google.com/?"+openAddress, '_system');
			}
			//todo
			*/
		}, 100);
	}
});


offcourseApp.controller('BeaconsController', function($scope, $rootScope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);

	$rootScope.is_club_app = is_club_app;
	$rootScope.isWeb = isWeb;
	$rootScope.isSignedIn = user.isSignedIn();
	
	$scope.beacons = beaconRegions;
	console.log('********* IN BEACONS CONTROLLER ********');
	console.log($scope.beacons);
	beaconChangeListener = function(bRegions) {
		console.log('********* BEACONS CONTROLLER CHANGED ********');
	console.log($scope.beacons);
		$scope.beacons = bRegions;
		$scope.$apply(function() { });
	}

});

offcourseApp.controller('AboutController', function($scope) {
	$scope.visitOffcourse = function() {
		setTimeout(function() {	
			window.open('http://offcourse.golf', '_system');
		}, 100);
	}
	$scope.emailOffcourse = function() {
		setTimeout(function() {	
			sendEmail('info@offcourse.co', '', ['info@offcourse.co']);
		}, 100);
	}
});

offcourseApp.controller('ContactController', function($scope, $rootScope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	
	$scope.address = whitelabel.contact.address;
	$scope.phone = whitelabel.contact.phone;

	$scope.callAction = function() {
		trackTeetime(0);
		setTimeout(function() {	
			phoneCall(whitelabel.contact.phone);
		}, 100);
	}
	$scope.emailAction = function() {
		setTimeout(function() {	
			sendEmail(whitelabel.contact.email, '', [whitelabel.contact.email]);
		}, 100);
	}
	$scope.websiteAction = function() {
		setTimeout(function() {	
			window.open(whitelabel.contact.website, '_system');
		}, 100);
	}
	$scope.facebookAction = function() {
		setTimeout(function() {	
			window.open(whitelabel.contact.facebook, '_system');
		}, 100);
	}
	$scope.twitterAction = function() {
		setTimeout(function() {	
			window.open(whitelabel.contact.twitter, '_system');
		}, 100);
	}
	$scope.addressAction = function() {
		setTimeout(function() {	
			var openAddress = "q=" + whitelabel.contact.address;
			if (whitelabel.contact.mapaddress) {
				openAddress = whitelabel.contact.mapaddress;
			}
			if (typeof(device) != 'undefined' && device.platform == 'iOS') {
				window.open("http://maps.apple.com/?"+openAddress, '_system');
			}
			else {
				window.open("http://maps.google.com/?"+openAddress, '_system');
			}
		}, 100);
	}
});


offcourseApp.controller('TeetimeController', function($scope, $rootScope, $sce) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	

	$scope.info = $sce.trustAsHtml(whitelabel.teetime.info);
	$scope.phone = whitelabel.teetime.phone;

	$scope.callAction = function() {
		trackTeetime(0);
		setTimeout(function() {	
			phoneCall(whitelabel.teetime.phone);
		}, 100);
	}
	$scope.publicAction = function() {
		trackTeetime(1);
		setTimeout(function() {	
			//window.open(whitelabel.teetime.public, '_system');
			openWindow(whitelabel.teetime.public);
		}, 100);
	}
	$scope.memberAction = function() {
		if (typeof(whitelabel.teetime.login_info) != 'undefined'
			 && typeof(whitelabel.teetime.login_info.member) != 'undefined') {
			myNavigator.pushPage('./theme/course/teetimesignin.html');
		}
		else {
			trackTeetime(2);
			setTimeout(function() {	
				//window.open(whitelabel.teetime.member, '_system');
				openWindow(whitelabel.teetime.member);
			}, 100);
		}
		
	}
	
});


offcourseApp.controller('PrivateclubgateController', function($scope, $rootScope, $sce) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);

	
	$rootScope.whitelabel = whitelabel;
	$rootScope.private_allow_guest = private_allow_guest;
	$scope.is_guest = page.options.is_guest;

	$scope.username = '';
	$scope.password = '';
	if (typeof(user.privatemember.username) != 'undefined') {
		$scope.username = user.privatemember.username;
		if (user.privatemember.password) {
			$scope.password = user.privatemember.password;
		}
	}

	if ($(document).height() <= 500) {
		$('.hide-small').hide();
	}

	$scope.scoring_1 = whitelabel.landing_screens.scoring_1;
	$scope.scoring_2 = whitelabel.landing_screens.scoring_2;
	$scope.stats_1 = whitelabel.landing_screens.stats_1;
	$scope.stats_2 = whitelabel.landing_screens.stats_2;
	$scope.tour_1 = whitelabel.landing_screens.tour_1;
	$scope.tour_2 = whitelabel.landing_screens.tour_2;

	
	$('#memberEmail').on('focus', function() {
		$('.landing-all .image-2').hide();
	});
	$('#memberEmail').on('blur', function() {
		$('.landing-all .image-2').show();
	});
	

	$scope.doSignin = function() {

		$scope.loadingLogin = true;

		var username = pageElm.find('#memberEmail').val();
		var password = pageElm.find('#memberPassword').val();

		if (username.length > 0 && password.length > 0) {
			$.ajax({
	               url: APIHOST + whitelabel.privateclub.validate,
	               method: 'POST',
	               data: { username: username, password: password },
	               success: function(data) {
	               		if (data.authorized) {
	               			user.privatemember.guest = false;
	               			user.privatemember.username = username;
	               			user.privatemember.password = password;
	               			window.localStorage['privatemember'] = JSON.stringify(user.privatemember);
		                    
		                    $scope.loadingLogin = false;
		                    $scope.$apply();
		                    //myNavigator.popPage();

		                    app.getClubAppInfo(function() {
								app.openHome();
							});

							setMemberGuestGroup();
	                    }
	                    else {
	                    	$scope.loadingLogin = false;
	                    	$scope.$apply();
	                    	navigator.notification.alert('There was a problem signing you in.  Check your username and password.', function() {} , 'Sign In Error', 'Dismiss');
	                    }
	               },
	               error: function() {
	               		$scope.loadingLogin = false;
	               		$scope.$apply();
	               		navigator.notification.alert('There was a problem signing you in.  Please try again.', function() {} , 'Sign In Error', 'Dismiss');
	               }
	            });
		}
		else {
			$scope.loadingLogin = false;
	        $scope.$apply();
			navigator.notification.alert('Please enter your username and password.', function() {} , 'Sign In Error', 'Dismiss');
		}
	}
	$scope.forgotPassword = function() {
		openWindow(whitelabel.privateclub.forgot);
	}
	$scope.memberRegistration = function() {
		openWindow(whitelabel.privateclub.registration);
		
	}
	$scope.guestLogin = function() {
		if (private_allow_guest) {
			user.privatemember.guest = true;

			window.localStorage['privatemember'] = JSON.stringify(user.privatemember);
            
            $scope.loadingLogin = false;
           
            //myNavigator.popPage();

            app.getClubAppInfo(function() {
				app.openHome();
			});
		}
		else {
			openWindow(whitelabel.privateclub.registration);
		}
	}

});


offcourseApp.controller('TeetimesigninController', function($scope, $rootScope, $sce) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	
	var username = '';
	var password = '';
	if (window.localStorage['teetimeusername']) {
		username = window.localStorage['teetimeusername'];
	}
	if (window.localStorage['teetimepassword']) {
		password = window.localStorage['teetimepassword'];
	}

	if (typeof(user.privatemember.username) != 'undefined' && user.privatemember.username.length > 0) {
		if (username.length == 0) {
			username = user.privatemember.username;
			password = user.privatemember.password;
		}
	}




	pageElm.find('#teetimeEmail').val(username);
	pageElm.find('#teetimePassword').val(password);

	var signin_happened = false;

	$scope.doTeetimeSignin = function() {
		trackTeetime(2);

		username = pageElm.find('#teetimeEmail').val();
		password = pageElm.find('#teetimePassword').val();
		window.localStorage['teetimeusername'] = username;
		window.localStorage['teetimepassword'] = password;

		var ref = {};
		var signincallback = function(event) {
			
			setTimeout(function() {
				if (!signin_happened) {
					if (whitelabel.teetime.login_info.member.username_jquery) {
							// in some cases jquery isn't loaded in the head.  So we need to poll for it to be ready.
						var loadingScript = 
							"var jquerychecker = setInterval(function() { "+
								"if (window.jQuery) { " +
									"clearInterval(jquerychecker); " +
									"jQuery(function() { "+
										"if ("+whitelabel.teetime.login_info.member.username_jquery+".length > 0) { "+
											whitelabel.teetime.login_info.member.username_jquery+".val('"+username+"'); "+
											whitelabel.teetime.login_info.member.password_jquery+".val('"+password+"'); "+
											whitelabel.teetime.login_info.member.loginform_jquery+".click(); "+
										"} " +
									"}); "+
								"} "+
							"}, 100); ";
						//console.log(loadingScript);
						ref.executeScript({code: loadingScript});
						signin_happened = true;
					}
					else if (whitelabel.teetime.login_info.member.username_id) {
						ref.executeScript({code: "document.getElementById('"+whitelabel.teetime.login_info.member.username_id+"').value = '"+username+"';"});
						ref.executeScript({code: "document.getElementById('"+whitelabel.teetime.login_info.member.password_id+"').value = '"+password+"';"});
						ref.executeScript({code: "if (document.getElementById('"+whitelabel.teetime.login_info.member.username_id+"')) { document.getElementById('"+whitelabel.teetime.login_info.member.loginform_id+"').submit(); }"});
						signin_happened = true;
					}
					else {
						ref.executeScript({code: "document.getElementsByName('"+whitelabel.teetime.login_info.member.username+"')[0].value = '"+username+"';"});
						ref.executeScript({code: "document.getElementsByName('"+whitelabel.teetime.login_info.member.password+"')[0].value = '"+password+"';"});
						ref.executeScript({code: "if (document.getElementsByName('"+whitelabel.teetime.login_info.member.username+"').length > 0) { document.getElementById('"+whitelabel.teetime.login_info.member.loginform_id+"').submit(); }"});
						signin_happened = true;
					}
					myNavigator.popPage();
				}
				
				if (whitelabel.teetime.login_info.member.post_login) {
					console.log('Page LOADED: ' + event.url);

					$.each(whitelabel.teetime.login_info.member.post_login, function(i, postlogin) {
						if (event.url.indexOf(postlogin.page) >= 0) {
							console.log('MATCHED: ' + postlogin.page);
							if (postlogin.click) {
								if (postlogin.jquery) {
									var loadingScript = 
										"var jquerychecker = setInterval(function() { "+
											"if (window.jQuery) { " +
												"clearInterval(jquerychecker); " +
												"jQuery(function() { "+
													"if ("+postlogin.click+".length > 0) { "+
														postlogin.click+".click(); "+
													"} " +
												"}); "+
											"} "+
										"}, 100); ";
									console.log(loadingScript);
									ref.executeScript({code: loadingScript});
								}
								else {
									var loadingScript = ' ' +
											postlogin.click+".click(); " +
										' ';
									console.log(loadingScript);
									ref.executeScript({code: loadingScript});
								}
							}
							if (postlogin.goto) {
								var loadingScript = ' document.location.href = "' + postlogin.goto + '"; ';
								console.log(loadingScript);
								ref.executeScript({code: loadingScript});
							}
						}
					});
				}
				
				
				
			}, 200);

		}
		var loadstartcallback = function(event) {
			if (typeof(whitelabel.teetime.login_info.member.openinternal) != 'undefined') {
				// catch this and open in external browser - then go back.
				if (event.url.indexOf(whitelabel.teetime.login_info.member.openinternal) < 0) {
					setTimeout(function() {
						//ref.executeScript({code: "window.history.back();"});
					}, 1);
					setTimeout(function() {
						window.open(event.url, '_system');
					}, 400);
					ref.executeScript({code: "window.stop();"});
					return false;
				}
			}

		}

		if (whitelabel.app_company == 'vipgolf') {
			var theme = {}; 
			$.extend(theme, whitelabel.browsertheme);
			delete theme.backButton;
			ref = openWindow(whitelabel.teetime.member, theme);
		}
		else {
			ref = openWindow(whitelabel.teetime.member);
		}

		ref.addEventListener('loadstop', signincallback);
		ref.addEventListener('loadstart', loadstartcallback);
	}
	$scope.forgotTeetimePassword = function() {
		openWindow(whitelabel.teetime.login_info.member.forgot);
	}

});



offcourseApp.controller('GolfcanadaController', function($scope, $rootScope, $sce) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	
	var club_name = page.options.club_name;
	var club_gc_id = page.options.gckey;
	var score = page.options.score;
	var score_date = page.options.score_date;

	if (window.localStorage['golfcanadausername']) {
		var username = window.localStorage['golfcanadausername'];
	}
	if (window.localStorage['golfcanadapassword']) {
		var password = window.localStorage['golfcanadapassword'];
	}

	$scope.extra_info = 'Use your Golf Canada username and password to manage your Golf Canada Handicap.';

	pageElm.find('#golfcanadaEmail').val(username);
	pageElm.find('#golfcanadaPassword').val(password);

	$scope.doTeetimeSignin = function() {

		username = pageElm.find('#golfcanadaEmail').val();
		password = pageElm.find('#golfcanadaPassword').val();
		window.localStorage['golfcanadausername'] = username;
		window.localStorage['golfcanadapassword'] = password;


		var login_tried = false;
		var score_tried = false;
		var score_entered = false;
		var ref = {};
		var execCallback = function(event) {
			console.log("Code Executed.")
			console.log(JSON.stringify(event));
		}
		var signincallback = function(event) {
			console.log(event.url + " || " + whitelabel.golfcanada.signinUrl);
			if (event.url.match(whitelabel.golfcanada.signinUrl)) {
				console.log(".... DO all the Golf Canada login stuff...");
				if (!login_tried) {
					console.log("Logging User In Now.");

					var exec_code = //"angular.element(document).ready(function () { "+
						//	"if ($('[name="+whitelabel.golfcanada.username+"]')) { "+
							"var exec_login = function() { " + 
								"angular.element($('[name="+whitelabel.golfcanada.username+"]')).data().$ngModelController.$$scope.$ctrl.username = '"+username+"'; " +
								"angular.element($('[name="+whitelabel.golfcanada.username+"]')).data().$ngModelController.$$scope.$apply(); " +
								"angular.element($('[name="+whitelabel.golfcanada.password+"]')).data().$ngModelController.$$scope.$ctrl.password = '"+password+"'; " +
								"angular.element($('[name="+whitelabel.golfcanada.password+"]')).data().$ngModelController.$$scope.$apply(); " +
								//"document.getElementsByName('"+whitelabel.golfcanada.username+"')[0].focus(); "+
								//"document.getElementsByName('"+whitelabel.golfcanada.username+"')[0].value = '"+username+"'; "+
								//"document.getElementsByName('"+whitelabel.golfcanada.password+"')[0].focus(); "+
								//"document.getElementsByName('"+whitelabel.golfcanada.password+"')[0].value = '"+password+"'; "+
								"$('"+whitelabel.golfcanada.submit_btn+"').focus(); " +
								"$('"+whitelabel.golfcanada.submit_btn+"').click(); " +
								//"alert('test'); " +
							"}; " +
							"window.onload = function() { exec_login(); }; " + 
							"setTimeout(function() { exec_login(); }, 3000); ";
						//	" } " +
						//	"});";

					var run_code = " exec_login(); ";

					setTimeout(function() {
						
				/*		ref.executeScript(
								{
									file: "http://app.offcourse.co/golfcanada.js"
								}, function(values) {
									console.log('FILE SCRIPT HAPPENED!!!!!');
							        console.log(JSON.stringify(values));
								});
*/
/*
						ref.executeScript(
								{
									code: "var executable = function(data) { return data; }; executable($('#username') || null);"
								}, function(values) {
									console.log('SCRIPT HAPPENED!!!!!');
							        console.log(JSON.stringify(values));
								});
								*/
/*
[{"$$uibCarouselCss":true,"$$uibTooltipCss":true,"$$uibTimepickerCss":true,"$$uibPositionCss":true,"version":{"full":"1.6.6","minor":6,"major":1,"dot":6,"codeName":"interdimensional-cable"},"$$uibDatepickerCss":true,"$$uibDatepickerpopupCss":true,"$$uibTypeaheadCss":true,"callbacks":{"$$counter":0}}]
*/
						
					}, 5000);
/*
					setTimeout(function() {
						console.log("Injecting Code.  1000");
						console.log(run_code);
						ref.executeScript({code: exec_code}, execCallback);
					}, 1000);

					setTimeout(function() {
						console.log("Injecting Code.  2000");
						console.log(run_code);
						ref.executeScript({code: exec_code}, execCallback);
					}, 2000);

					setTimeout(function() {
						console.log("Injecting Code.  5000");
						console.log(run_code);
						ref.executeScript({code: run_code}, execCallback);
					}, 5000);

					setTimeout(function() {
						console.log("Injecting Code.  10000");
						console.log(run_code);
						ref.executeScript({code: run_code}, execCallback);
					}, 10000);

					setTimeout(function() {
						console.log("Injecting Code.  10000");
						console.log(run_code);
						ref.executeScript({code: run_code}, execCallback);
					}, 20000);
*/
					login_tried = true;
				}
				else if (score && !score_tried) {
					setTimeout(function() {
						ref.executeScript({code: "$(function() { "+
							" "+
								"document.location.href='"+whitelabel.golfcanada.scoreUrl+"'; "+
							"});"}, execCallback);
						score_tried = true;
					}, 100);
				}
			}
			if (event.url.match(whitelabel.golfcanada.scoreUrl)) {
				if (!score_entered) {
					ref.executeScript({code: "angular.element(document).ready(function () { "+
							"if ($('#bigscore').length > 0) { "+
								"$('#total').click(); "+
								"$('#bigscore').val('"+score+"'); "+
								"$('#score_value').val('"+score+"'); "+
								"$('.date').val('"+score_date+"'); "+
								//"jQuery('#club_typeahead_b').focus(); " +
								"$('#club_typeahead_b').val('"+club_name+"'); "+
								"$('#club_typeahead_id').val('"+club_gc_id+"'); "+
								"loadClubTees(); " +
							" } "+
						"});"}, execCallback);
					score_entered = true;
				}
			}
		}
		
		ref = openWindow(whitelabel.golfcanada.signinUrl);
		ref.addEventListener('loadstop', signincallback);
		ref.addEventListener('exit', function() {
			myNavigator.popPage();
			ref.removeEventListener('loadstop', signincallback);
		});
	}
	$scope.forgotTeetimePassword = function() {
		openWindow(whitelabel.golfcanada.forgot);
	}


	// for now we are going to just open the golf canada up to scoreurl.
	// autologin is not working.
	if (score) {
		ref = openWindow(whitelabel.golfcanada.scoreUrl);
		myNavigator.popPage();
	}
	else {
		if (whitelabel.golfcanada.homeUrl) {
			ref = openWindow(whitelabel.golfcanada.homeUrl);
		}
		else {
			ref = openWindow(whitelabel.golfcanada.scoreUrl);
		}
		myNavigator.popPage();
	}
	
});




offcourseApp.controller('CourseinfoController', function($scope, $rootScope, $sce) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	

	$scope.desc = $sce.trustAsHtml(whitelabel.course.desc);
	if (!app.isPrivateGuest(false)) {
		$scope.infolinks = whitelabel.course.infolinks;
	}

	$scope.contactAction = function() {
		myNavigator.pushPage('contact.html');
	}
	$scope.teetimeAction = function() {
		if (!app.isPrivateGuest(true)) {
			myNavigator.pushPage('teetime.html');
		}
	}
	$scope.offersAction = function() {
		if (!app.isPrivateGuest(true)) {
			myNavigator.pushPage('offers.html');
		}
	}
	$scope.weatherAction = function() {
		openWindow(whitelabel.weatherURL);
	}
	$scope.linkAction = function(infolink) {


		openCustomLink(infolink.link, infolink.external);

	}

});


offcourseApp.controller('Onboarding1Controller', function($scope) {
	var page = myNavigator.getCurrentPage();

	var afteronboard = page.options.afteronboard;
	if (typeof(afteronboard) != 'function') {
		afteronboard = function() { };
	}

	$scope.grantPermission = function() {
		setTimeout(function() {
			registerPushNotificationEvents();
		}, 1);
		setTimeout(function() {
			gps.firstPosition();
		}, 2);

		setTimeout(function() {
			app.setOnboarded();
			
			if (whitelabel.groups && whitelabel.groups.length > 0) {
				myNavigator.pushPage('groups.html', { onboarding: true, aftergroups: afteronboard });
			}
			else {
				app.openHome();
				afteronboard();
			}
			
		}, 200);
		
	}
	$scope.refusePermission = function() {
		app.openHome();
		afteronboard();
	}

	$scope.grantLocationPermission = function() {
		setTimeout(function() {
			gps.firstPosition();
		}, 1);
		myNavigator.pushPage('onboarding2.html', { afteronboard: afteronboard });
	}
	
});
offcourseApp.controller('Onboarding2Controller', function($scope) {
	var page = myNavigator.getCurrentPage();

	var afteronboard = page.options.afteronboard;
	if (typeof(afteronboard) != 'function') {
		afteronboard = function() { };
	}

	$scope.grantNotifyPermission = function() {
		setTimeout(function() {
			registerPushNotificationEvents();
			
		}, 1);
		setTimeout(function() {
			app.setOnboarded();
			if (whitelabel.groups && whitelabel.groups.length > 0) {
				myNavigator.pushPage('groups.html', { onboarding: true, aftergroups: afteronboard });
			}
			else {
				app.openHome();
				afteronboard();
			}
			
		}, 2);
	}
	
});


var statsCache = {};
offcourseApp.controller('StatsController', function($scope) {
	$scope.stats = {};
	var userStats = {};
	
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);



	if (statsCache.thisYear) {
		$scope.stats = statsCache.thisYear;
	}
	else {
		statmodal.show();
	}
	$.ajax({
        	url: APIHOST + '/users/apirounds/' + user.info.User.username + '/appstats:1/holes:1/scoringtype:0/',
        	method: 'GET',
        	data: {tk: user.tk, uk: user.uk, pk: user.pk},
        	success: function(data) {
        		statmodal.hide();
        		lastRounds = data.data;
        		
        		userStats = createDashboardStats(lastRounds);
        		statsCache = userStats;
        		
        		$scope.$apply(function(){
        			$scope.stats = userStats.thisYear;
        		});
        		
        	},
        	error: function() {
        		statmodal.hide();
        	}
        });

	$scope.switchToThis = function() {
		$scope.stats = userStats.thisYear;
		pageElm.find('.showThis input').prop('checked', 'checked');
	};
	$scope.switchToLast = function() {
		$scope.stats = userStats.lastYear;
		pageElm.find('.showLast input').prop('checked', 'checked');
	};
	$scope.switchTo20 = function() {
		$scope.stats = userStats.last20;
		pageElm.find('.show20 input').prop('checked', 'checked');
	};
	$scope.switchTo5 = function() {
		$scope.stats = userStats.last5;
		pageElm.find('.show5 input').prop('checked', 'checked');
	};
	
});



offcourseApp.controller('SigninController', function($scope, $rootScope, $cordovaOauth, $http) {

	$rootScope.is_club_app = is_club_app;
	$rootScope.isWeb = isWeb;
	$scope.loadingLogin = false;
	$scope.showMembershipInfo = showMembershipInfo;
	$scope.enableFacebook = enable_facebook;
	$rootScope.whitelabel = whitelabel;
	$rootScope.show_golf_canada = (show_golf_canada === true) ? true : false;

	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);

	var successfulLogin = page.options.success;
	if (typeof(successfulLogin) != 'function') {
		successfulLogin = function() { };
	}

	pageElm.find('ons-toolbar .title').html(whitelabel.app_header_title);

	var topSpacingFactor = 0.24;
	if ($(window).height() <= 500) {
		topSpacingFactor = 0.12;
	}
	pageElm.find('.login-form-top').height($(window).height() * topSpacingFactor);
	
	pageElm.find('.golfjet-pack .top-landing-gap').height($(window).height() * 0.40);
	pageElm.find('.golfjet-ball .top-landing-gap').height($(window).height() * 0.50);
	
	$scope.scoring_1 = whitelabel.landing_screens.scoring_1;
	$scope.scoring_2 = whitelabel.landing_screens.scoring_2;
	$scope.stats_1 = whitelabel.landing_screens.stats_1;
	$scope.stats_2 = whitelabel.landing_screens.stats_2;
	$scope.tour_1 = whitelabel.landing_screens.tour_1;
	$scope.tour_2 = whitelabel.landing_screens.tour_2;
	

	$scope.doSignin = function() {
		$scope.loadingLogin = true;
		app.doSignin(function() {
				// this is after do signin button was pressed
			$scope.$apply(function() {
				$scope.loadingLogin = false;
			});
		}, function() {
				// this is after succesful signin
			successfulLogin();
		});
	};
	
		
	
	
	$scope.doFacebookSignin = function() {
		$scope.loadingFacebook = true;

		if (typeof(facebookConnectPlugin) != 'undefined') {
			facebookConnectPlugin.login(["email", "public_profile"],
			    function(result) {
					user.addFacebookInfo(result.authResponse.accessToken, 
						function() {
							$scope.$apply(function() {
								$scope.loadingFacebook = false;
							});
							if (!app.isOnboarded()) {
		    					myNavigator.pushPage('onboarding1.html', { afteronboard: successfulLogin });
		    				}
		    				else {
		    					app.openHome();
		    					setTimeout(function() {
		    						successfulLogin();
		    					}, 100);
		    					
		    				}
						},
						function() {
							$scope.$apply(function() {
								$scope.loadingFacebook = false;
							});
							navigator.notification.alert("We had problems signing you in. You should try again.");
						});
			    },
			    function (error) { 
			    	console.log('There was a problem logging into facebook');
			    	console.log(error);
			    	$scope.$apply(function() {
						$scope.loadingFacebook = false;
					});
					navigator.notification.alert("We had problems signing you in. You should try again.");
			    }
			);
		}
		else {

			$cordovaOauth.facebook(
						facebook_app_id, 
						["email", "public_profile"], 		// ask for these later: "user_friends", "publish_actions"
						{
							redirect_uri: "http://localhost/callback"
						}
						).then(function(result){
								// result.access_token  <- this is the magic
							
							user.addFacebookInfo(result.access_token, 
								function() {
									$scope.$apply(function() {
										$scope.loadingFacebook = false;
									});
									if (!app.isOnboarded()) {
				    					myNavigator.pushPage('onboarding1.html', { afteronboard: successfulLogin });
				    				}
				    				else {
				    					app.openHome();
				    					setTimeout(function() {
											successfulLogin();
										}, 100);
				    				}
								},
								function() {
									$scope.$apply(function() {
										$scope.loadingFacebook = false;
									});
									navigator.notification.alert("We had problems signing you in. You should try again.");
								});
							
						},  function(error){
							console.log('******* cordovaOauth - error *********');
							console.log("Error -> " + error);

							$scope.loadingFacebook = false;
							
								//alert("Error: " + error);
						});
		}
		
	};
	
	$scope.forgotPassword = function() {
		window.open(whitelabel.forgot_password_url, '_system');
	};
	
	$scope.openStore = function() {
		window.open(whitelabel.store_url, '_system');
	};
	$scope.openBall = function() {
		window.open(whitelabel.ball_url, '_system');
	};
	
	
	
	function createNavDisplay() {
		var cSize = pageElm.find('ons-carousel-item').length;
		var currentIndex = startcarousel.getActiveCarouselItemIndex();
		if (currentIndex == 0) {
			pageElm.find('ons-carousel-cover .cover-label').html('&gt; Swipe to learn more');
		}
		else {
			var coverLabel = '';
			for(i = 0; i < cSize; i++) {
				if (currentIndex == i) {
					coverLabel += '<i class="fa fa-dot-circle-o"></i>';
				}
				else {
					coverLabel += '<i class="fa fa-circle-o"></i>';
				}
			}
			pageElm.find('ons-carousel-cover .cover-label').html(coverLabel);
		}
		
	}
	
	setTimeout(function() {
		
		if (typeof(startcarousel) != 'undefined') {
			startcarousel.on('postchange', function(event) {
				setTimeout(function() {
					createNavDisplay()
				}, 5);
			
			});
			startcarousel.on('overscroll', function(event) {
			
				if (event.direction == 'right') {
					startcarousel.first();
				}
				//if (event.direction == 'left') {
				//	startcarousel.last();
				//}
			
			});
		}
	},200);
	
	
});


offcourseApp.controller('SignupController', function($scope, $cordovaOauth) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	$scope.enableFacebook = enable_facebook;
	
	$scope.doSignup = function() {
		var pk = Math.random();
		var name = $.trim(pageElm.find('.sign-up-name').val());
		var email = $.trim(pageElm.find('.sign-up-email').val());
		var password = pageElm.find('.sign-up-password').val();
		var gender = pageElm.find('.sign-up-gender:checked').val();
		var hand = pageElm.find('.sign-up-gender:checked').val();
		
		user.pk = pk;
		var params = {
    			name: name,
    			email: email,
    			password: password,
    			gender: gender,
    			hand: hand,
    			pk: user.pk,
    			whitelabel: whitelabel.app_company,
    			club_id: 0
    		};


    	if (is_club_app) {
    		params.club_id = whitelabel.course.club_id;
    	}

    	var doReg = true;
    	
    	if (params.name == '') {
    		doReg = false;
    		navigator.notification.alert('To register we are going to need to know your name.', function() {} , 'Sign Up Problem', 'Dismiss');
    	}
    	if (params.email == '') {
    		doReg = false;
    		navigator.notification.alert('To register we are going to need you to enter your email address.', function() {} , 'Sign Up Problem', 'Dismiss');
    	}
    	if (!validateEmail(params.email)) {
    		doReg = false;
    		navigator.notification.alert('Please check your email address to make sure it\'s right.', function() {} , 'Sign Up Problem', 'Dismiss');
    	}
    	if (params.password.length < 8) {
    		doReg = false;
    		navigator.notification.alert('To register we are going to need you to enter a password 8 characters or longer.  It\'s all about security...', function() {} , 'Sign Up Problem', 'Dismiss');
    	}

    	if (doReg) {
    		signupmodal.show();

			$.ajax({
				   url: APIHOST + '/users/apiregister/',
				   method: 'POST',
				   data: params,
				   success: function(data) {
						if (data.User && data.tk) {
							signupmodal.hide();
							
							
							if (data.User && data.tk) {
								user.info = data;
								user.isMetric = user.info.User.metric;
								user.tk = data.tk;
								user.uk = user.info.User.id;
						
								window.localStorage['lastemail'] = user.info.User.email;
								window.localStorage['pk'] = user.pk;
								window.localStorage['tk'] = user.tk;
								window.localStorage['currentUser'] = JSON.stringify(data);
					   
								user.initUserData(function() {
									setMemberGuestGroup();
									if (!app.isOnboarded()) {
				    					myNavigator.pushPage('onboarding1.html');
				    				}
				    				else {
				    					app.openHome();
				    				}
								});

						
							}
							
						}
						else {
							signupmodal.hide();
							navigator.notification.alert(data.error, function() {} , 'Registration Problem', 'Dismiss');
						}
				   },
				   error: function() {
						signupmodal.hide();
						navigator.notification.alert('We ran into a problem registering you.  Please try again.', function() {} , 'Sign Up Problem', 'Dismiss');
				   }
				});
		}
		
	};

	$scope.doFacebookSignin = function() {
		$scope.loadingFacebook = true;
		if (typeof(facebookConnectPlugin) != 'undefined') {
			facebookConnectPlugin.login(["email", "public_profile"],
			    function(result) {
					user.addFacebookInfo(result.authResponse.accessToken, 
						function() {
							$scope.$apply(function() {
								$scope.loadingFacebook = false;
							});
							if (!app.isOnboarded()) {
		    					myNavigator.pushPage('onboarding1.html');
		    				}
		    				else {
		    					app.openHome();
		    				}
						},
						function() {
							$scope.$apply(function() {
								$scope.loadingFacebook = false;
							});
							navigator.notification.alert("We had problems signing you in. You should try again.");
						});
			    },
			    function (error) { 
			    	console.log('There was a problem logging into facebook');
			    	console.log(error);
			    	$scope.$apply(function() {
						$scope.loadingFacebook = false;
					});
					navigator.notification.alert("We had problems signing you in. You should try again.");
			    }
			);
		}
		else {
			$cordovaOauth.facebook(
						facebook_app_id, 
						["email", "public_profile"], 		// ask for these later: "user_friends", "publish_actions"
						{
							redirect_uri: "http://localhost/callback"
						}
						).then(function(result){
								// result.access_token  <- this is the magic
							user.addFacebookInfo(result.access_token, 
								function() {
									$scope.$apply(function() {
										$scope.loadingFacebook = false;
									});
									if (!app.isOnboarded()) {
				    					myNavigator.pushPage('onboarding1.html');
				    				}
				    				else {
				    					app.openHome();
				    				}
								},
								function() {
									$scope.$apply(function() {
										$scope.loadingFacebook = false;
									});
									navigator.notification.alert("We had problems signing you in. You should try again.");
								});
							
						},  function(error){
							
							$scope.loadingFacebook = false;
							
								//alert("Error: " + error);
						});
		}
	};
	


});




offcourseApp.controller('HomeController', function($scope, $rootScope, $sce) {
	
	$rootScope.is_club_app = is_club_app;
	$rootScope.isWeb = isWeb;
	$rootScope.whitelabel = whitelabel;
	$rootScope.isSignedIn = user.isSignedIn();
	$rootScope.show_golf_canada = (show_golf_canada === true) ? true : false;

	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);



	var doWelcomePopover = function() {
		if (!window.localStorage['welcomePopover']) {
			window.localStorage['welcomePopover'] = 1;
			setTimeout(function() {
				
				ons.createPopover('welcomepopover.html')
					.then(function(popover) {
						setTimeout(function() {
							popover.show(
								pageElm.find('.home-action-play')[0],
								{

								}
							);
							popover.on('posthide', function() {
								makePopover2();
							});
						}, 50);
				});
				function makePopover2() {
					ons.createPopover('welcomepopover2.html')
						.then(function(popover) {
							setTimeout(function() {
								popover.show(
									pageElm.find('.home-action-promo')[0],
									{

									}
								);
								popover.on('posthide', function() {
									
								});
							}, 50);
					});
				}
			}, 500);
			
		}
	}

	doWelcomePopover();
	
	cacheOffers($sce);
	setGuestLocks();

	if (app.isOnboarded()) {
		registerPushNotificationEvents();
	}

	if (is_club_app) {
		app.getClubAppInfo(function() { });
	}
	
});




offcourseApp.controller('EditphotoController', function($scope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	
	setTimeout(function() {
		pageElm.find('.profile-photo').css({
    								'background-image': 'url('+getUserAvatar(user.info)+')'
    							});
		pageElm.find('.background-photo').css({
    								'background-image': 'url('+user.info.User.background+')'
    							});
			
	}, 10);
	
	$scope.doProfilePhotoSave = function() {
		
		pageElm.find(".save-profile-btn").html('Saving <i class="fa fa-circle-o-notch fa-spin"></i>');
		
		photo.upload('profilephoto', 
					APIHOST + '/users/apiprofilephoto/',
					{}, 
					function(photoURI, progress) {
							//progress
						pageElm.find(".save-profile-btn").html('Saving '+progress+'% <i class="fa fa-circle-o-notch fa-spin"></i>');
						pageElm.find('.profile-photo').css({
    								'background-image': 'url('+photoURI+'?cc='+ new Date().getTime() +')'
    							});
    					$('.home-page .home-card-avatar').css({
    								'background-image': 'url('+photoURI+'?cc='+ new Date().getTime() + ')'
    							});
    			
					}, 
					function() {
							// Done well
						user.info.User.avatar = user.info.User.avatar + '?cc=' + Math.random();
						user.info.User.picture = user.info.User.picture + '?cc=' + Math.random();

						pageElm.find('.profile-photo').css({
    								'background-image': 'url('+user.info.User.avatar+')'
    							});
    					$('.home-page .home-card-avatar').css({
    								'background-image': 'url('+user.info.User.avatar+')'
    							});
    					$('.home-action-avatar').css({
    								'background-image': 'url('+user.info.User.avatar+')'
    							});

						pageElm.find(".save-profile-btn").html('Change Photo');
					}, 
					function() {
							//error
						navigator.notification.alert('We ran into a problem uploading your photo.  Please try again.', function() {} , 'Photo Problem', 'Dismiss');
						pageElm.find(".save-profile-btn").html('Change Photo');
					});
		
	};
	
	$scope.doBackgroundPhotoSave = function() {
		
		pageElm.find(".save-backgroundphoto-btn").html('Saving <i class="fa fa-circle-o-notch fa-spin"></i>');
		
		photo.upload('profilebackground', 
					APIHOST + '/users/apiprofilephoto/',
					{},
					function(photoURI, progress) {
							//progress
						pageElm.find(".save-backgroundphoto-btn").html('Saving '+progress+'% <i class="fa fa-circle-o-notch fa-spin"></i>');
						pageElm.find('.background-photo').css({
    								'background-image': 'url('+photoURI+')'
    							});
    					$('.home-page .home-card-background').css({
    								'background-image': 'url('+photoURI+')'
    							});
					}, 
					function() {
							// Done well
						user.info.User.background = user.info.User.background + '?cc=' + Math.random();
						pageElm.find(".save-backgroundphoto-btn").html('Change Photo');
					}, 
					function() {
							//error
						navigator.notification.alert('We ran into a problem uploading your photo.  Please try again.', function() {} , 'Photo Problem', 'Dismiss');
						pageElm.find(".save-backgroundphoto-btn").html('Change Photo');
					});
		
	};

});




offcourseApp.controller('EditprofileController', function($scope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	
	$scope.hdcp_type_name = whitelabel.app_name;
	
	setTimeout(function() {
		pageElm.find('.profile-name').val(user.info.User.name);
		pageElm.find('.profile-email').val(user.info.User.email);
		pageElm.find('.profile-location').val(user.info.User.location);
		
		var metric = (user.info.User.metric) ? 1 : 0;
		pageElm.find(".profile-units[value="+metric+"]").prop('checked', true);
		
		var gender = (user.info.User.gender) ? 1 : 0;
		pageElm.find(".profile-gender[value="+gender+"]").prop('checked', true);
		
		var hand = (user.info.User.hand) ? 1 : 0;
		pageElm.find(".profile-hand[value="+hand+"]").prop('checked', true);

		var hdcptype = (user.info.User.hdcptype) ? 1 : 0;
		pageElm.find(".profile-hdcp[value="+hdcptype+"]").prop('checked', true);

		pageElm.find('.profile-handicap').val(user.info.User.handicap);
	}, 10);
	
	$scope.doSave = function() {
		
		pageElm.find(".save-profile-btn").html('Saving <i class="fa fa-circle-o-notch fa-spin"></i>');
		
		var params = {
        			tk: user.tk, uk: user.uk, pk: user.pk,
					name: pageElm.find('.profile-name').val(),
					username: user.info.User.username,
					bio: user.info.User.bio,
					email: pageElm.find('.profile-email').val(),
					location: pageElm.find('.profile-location').val(),
					hand: pageElm.find('.profile-hand:checked').val(),
					gender: pageElm.find('.profile-gender:checked').val(),
					metric: pageElm.find('.profile-units:checked').val(),
					hdcptype: pageElm.find('.profile-hdcp:checked').val(),
					hdcp: pageElm.find('.profile-handicap').val()
				};
				
		
		$.ajax({
			   url: APIHOST + '/users/apieditprofile/',
			   method: 'POST',
			   dataType: 'json',
			   data: params,
			   success: function(data) {
					if (typeof(data.data.User) != 'undefined') {
						user.info = data.data;
						user.isMetric = user.info.User.metric;
				
						if (data.tk) {
								// if email changes we need tp update the token
							user.tk = data.tk;
						}

						$('.home-page .home-card-name').html(user.info.User.name);
				
						pageElm.find(".save-profile-btn").html('Save Changes');
				
						myNavigator.popPage();
					}
			   },
			   error: function() {
			   		pageElm.find(".save-profile-btn").html('Save Changes');
			   }
			});
		
	};

});




offcourseApp.controller('EditpasswordController', function($scope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
		
	$scope.doSave = function() {
		
		pageElm.find(".save-password-btn").html('Saving <i class="fa fa-circle-o-notch fa-spin"></i>');
		
		var params = {
        			tk: user.tk, uk: user.uk, pk: user.pk,
        			currentpassword: pageElm.find('.password-current').val(),
					newpassword: pageElm.find('.password-new').val(),
					repeatpassword: pageElm.find('.password-new2').val()
				};		

		var savePass = true;
		if (params.newpassword != params.repeatpassword) {
			savePass = false;
			navigator.notification.alert('You must retype your new password exactly the same', function() {} , 'Password Not Changed', 'Dismiss');
			pageElm.find(".save-password-btn").html('Save Password');
		}
		else if (params.newpassword.length < 8) {
			savePass = false;
			navigator.notification.alert('Please choose a longer password.', function() {} , 'Password Not Changed', 'Dismiss');
			pageElm.find(".save-password-btn").html('Save Password');
		}
		else {
			$.ajax({
				   url: APIHOST + '/users/apichangepassword/',
				   method: 'POST',
				   dataType: 'json',
				   data: params,
				   success: function(data) {
				   		pageElm.find(".save-password-btn").html('Save Password');
				   		
						if (data.error != '') {
							navigator.notification.alert(data.error, function() {} , 'Password Not Changed', 'Dismiss');
						}
						else if (typeof(data.data.User) != 'undefined') {
							user.info = data.data;
							user.isMetric = user.info.User.metric;
							myNavigator.popPage();
						}
				   },
				   error: function() {
						pageElm.find(".save-password-btn").html('Save Changes');
				   }
				});
		}

	};

});


offcourseApp.controller('EditprivacyController', function($scope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	
	setTimeout(function() {
		$scope.privacySwitch.setChecked((user.info.User.privacy) ? true : false);
	
	}, 10);
	
	$scope.doSave = function() {

		pageElm.find(".save-privacy-btn").html('Saving <i class="fa fa-circle-o-notch fa-spin"></i>');
		
        	
        var newPrivacy = 0;
		if ($scope.privacySwitch.isChecked()) {
			newPrivacy = 1;
		}
		var params = {
				tk: user.tk, uk: user.uk, pk: user.pk,
				privacy: newPrivacy
			};
		$.ajax({
				   url: APIHOST + '/users/apieditprivacy/',
				   method: 'POST',
				   dataType: 'json',
				   data: params,
				   success: function(data) {
				   		if (typeof(data.data.User) != 'undefined') {
							user.info = data.data;
							user.isMetric = user.info.User.metric;
				
							pageElm.find(".save-privacy-btn").html('Save Privacy Changes');
				
							myNavigator.popPage();
						}
				   
				   },
				   error: function() {
						pageElm.find(".save-privacy-btn").html('Save Privacy Changes');
				   }
				});
	}

});


offcourseApp.controller('GroupsController', function($scope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	var onboarding = page.options.onboarding;

	$scope.onboarding = false;
	if (onboarding) {
		$scope.onboarding = true;
	}

	var aftergroups = page.options.aftergroups;
	if (typeof(aftergroups) != 'function') {
		aftergroups = function() { };
	}

	$scope.pushEnabled = true;
	$scope.groups = whitelabel.groups;
	$.each($scope.groups, function(i, group) {
		$scope.groups[i].isChecked = false;
	});


	var modalTimeout = setTimeout(function() {
		modalTimeout = false;
		usermodal.show();
	}, 200);
	

	setTimeout(function() {
		var params = {
				tk: user.tk, uk: user.uk, pk: user.pk
			};
		$.ajax({
				   url: APIHOST + '/users/apigroups/'+whitelabel.course.club_id+'/',
				   method: 'GET',
				   dataType: 'json',
				   data: params,
				   success: function(data) {
				   		if (data) {
					   		var enabled_groups = {};
					   		$.each(data.Group, function(i, group) {
					   			enabled_groups[group.id] = true;
					   		});
					   		
					   		$.each($scope.groups, function(i, group) {
					   			if (enabled_groups[group['Group']['id']]) {
									$scope.groups[i].isChecked = true;
								}
								
							});

							$scope.$apply();
						}
						
						if (modalTimeout) {
							clearTimeout(modalTimeout);
						}
						usermodal.hide();
						

				   },
				   error: function() {
						if (modalTimeout) {
							clearTimeout(modalTimeout);
						}
						usermodal.hide();
						
				   }
				});

	}, 1);
	
	$scope.doSave = function() {

		pageElm.find(".save-interests-btn").html('Saving <i class="fa fa-circle-o-notch fa-spin"></i>');
		
		var groupSend = [];
		$.each($scope.groups, function(i, group) {
			groupSend[i] = { id: group.Group.id, enabled: group.isChecked };
		});

		var params = {
				tk: user.tk, uk: user.uk, pk: user.pk,
				groups: groupSend
			};
		$.ajax({
				   url: APIHOST + '/users/apieditgroups/'+whitelabel.course.club_id+'/',
				   method: 'POST',
				   dataType: 'json',
				   data: params,
				   success: function(data) {
				   		if ($scope.onboarding) {
				   			app.openHome();
				   		}
				   		else {
				   			myNavigator.popPage();
				   		}
				   		aftergroups();
				   },
				   error: function() {
				   		if ($scope.onboarding) {
				   			app.openHome();
				   		}
				   		else {
							pageElm.find(".save-interests-btn").html('Save Interests');
						}
						aftergroups();
				   }
				});
	}


	deviceIsPushRegistered(function(isEnabled) {
		if (!isEnabled && !$scope.onboarding) {
			$scope.pushEnabled = false;
			$scope.$apply();
		}
	});

});



offcourseApp.controller('UserController', function($scope) {
	$scope.user = {
		User: {
			isSelf: true
		}
	};
	$scope.rounds = [];
	$scope.can_see = true;
	$scope.pending_gallery = false;
	
	var modalTimeout = setTimeout(function() {
		modalTimeout = false;
		usermodal.show();
	}, 100);

	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	var user_obj = page.options.user_obj;
	var user_username = page.options.user_username;
	
		
	if (typeof(user_obj) != 'undefined' && typeof(user_obj.User) != 'undefined' && typeof(user_obj.User.username) != 'undefined') {
		var username = user_obj.User.username;
	}
	else {
		var username = user_username;
	}


	$scope.reload = function($done) {
		loadUserInfo($done);
	};

	function loadUserInfo(complete) {
		$scope.rounds = [];

		$.ajax({
			url: APIHOST + '/users/apiuserstats/'+username+'/',
			method: 'GET',
			data: {tk: user.tk, uk: user.uk, pk: user.pk},
			success: function(data) {
				if (modalTimeout) {
					clearTimeout(modalTimeout);
				}
				usermodal.hide();
			
				$scope.$apply(function(){
			
					if (user.isGalleryPendingUser(data.User.id)) {
						$scope.pending_gallery = true;
					}
				
					if (user.isTourPendingUser(data.User.id)) {
						data.User.tourPending = true;
						data.User.onTour = false;
					}
					else {
				
						data.User.tourPending = false;
						data.User.onTour = user.onTour(data.User.id);
					}
			
					data.User.isSelf = false;
					if (user.isSignedIn()) {
						data.User.isSelf = (user.info.User.id == data.User.id);
					}
					$scope.user = data;

					$scope.can_see = user.canSeeUser($scope.user);
				});
			
	    		pageElm.find('.home-card-avatar').css({
	    								'background-image': 'url('+getUserAvatar($scope.user)+'?cc='+Math.random()+')'
	    							});
	    		pageElm.find('.home-card-background').css({
	    								'background-image': 'url('+$scope.user.User.background+'?cc='+Math.random()+')'
	    							});

					// make circle
				var d_hdcp = 'NA';
				var m_hdcp = 36;
				if ($scope.user.User.handicap != '' && $scope.user.User.handicap != null) {
					d_hdcp = $scope.user.User.handicap;
					m_hdcp = $scope.user.User.handicap;
				}
				pageElm.find('.user-stat-handicap .user-stat_figure span').html(d_hdcp);
				var num = 36 - m_hdcp;
				var max = 36;
				var canvas = pageElm.find('.user-stat-handicap').get(0).getElementsByTagName('canvas')[0]; 
				//var colors = ['#71F128', '#1CCB5C', '#00A0A5', '#0054E0', '#150F36' ];
				var colors = ['#150F36', '#0054E0', '#00A0A5', '#1CCB5C', '#71F128' ];
				makeCircle(num, max, canvas, colors);
				

				if ($scope.user.User.isSelf) {
					pageElm.find('.user-stat-more, .user-stat-edit').show();
					pageElm.find('.user-stat-more, .user-stat-handicap').click(function() {
						myNavigator.pushPage('stats.html', { 
     								user: $scope.user,
     								label: 'Stats',
     								onTransitionEnd: function() {
     									
     								}
     							});
					});
					pageElm.find('.user-stat-edit').click(function() {
						myNavigator.pushPage('menu.html', { 
     								user: $scope.user,
     								label: 'Menu',
     								onTransitionEnd: function() {
     									
     								}
     							});
					});
				}
				
				$.ajax({
					   url: APIHOST + '/users/apirounds/'+username+'/',
					   method: 'GET',
					   cache: false,
					   data: {tk: user.tk, uk: user.uk, pk: user.pk},
					   error: function(err) {
					
					   },
					   success: function(data) {
							$scope.$apply(function() {
								
								rounds = data.data;
								$.each(rounds, function(i, round) {
								
									var course_name = '';
									if (round.Round.Course.Club.name != round.Round.Course.name) {
										course_name = round.Round.Course.name;
									}
									var photo = '';
									if (round.Round.Photo && round.Round.Photo[0] && round.Round.Photo[0].medium) {
										photo = "background-image:url("+round.Round.Photo[0].medium+");width:100%;height:150px;position:relative;background-repeat:no-repeat;background-size:cover;background-position:center center;border-radius:4px;margin:5px 0;";
									}
									$scope.rounds.push({
												id: round.Round.id,
												date: toNiceDateTime(parseApiDate(round.Round.date)),
												name: round.User.name,
												club: round.Round.Course.Club.name,
												course: course_name,
												score: round.Round.score,
												holes: round.Round.holes,
												netscore: round.Round.netscore,
												comment: round.Round.comment,
												image: getUserAvatar(round),
												status: round.Round.status,
												photo: photo
											});
								});
							});
						}
					});
				

				$.ajax({
						url: APIHOST + '/users/apiroundinprogress/'+username+'/',
						method: 'GET',
						data: {tk: user.tk, uk: user.uk, pk: user.pk},
						success: function(data) {
							if (data && typeof(data.data.Round) != 'undefined') {
								
								var round = data.data;
									// only add if it's not a finished round
								if (round.Round.status == 1) {
									var course_name = '';
									if (round.Course.Club.name != round.Course.name) {
										course_name = round.Course.name;
									}
									var photo = '';
									if (round.Round.Photo && round.Round.Photo[0] && round.Round.Photo[0].medium) {
										photo = "background-image:url("+round.Round.Photo[0].medium+");width:100%;height:150px;position:relative;background-repeat:no-repeat;background-size:cover;background-position:center center;border-radius:4px;margin:5px 0;";
									}
									$scope.rounds.unshift({
												id: round.Round.id,
												date: toNiceDateTime(parseApiDate(round.Round.date)),
												name: round.User.name,
												club: round.Course.Club.name,
												course: course_name,
												score: round.Round.score,
												holes: round.Round.holes,
												netscore: round.Round.netscore,
												comment: round.Round.comment,
												image: getUserAvatar(round),
												status: round.Round.status,
												photo: photo
											});

									$scope.$apply();
								}
							}
						}
					});


				setTimeout(function() {
					complete();
				}, 500);
			},
			error: function() {
				setTimeout(function() {
					complete();
				}, 500);
			}
		});
	}

	$scope.addTour = function(tourUser) {
		pageElm.find('.on-tour-btn').css('opacity', '0.3');
		$.ajax({
				   url: APIHOST + '/users/apiusertour/',
				   method: 'POST',
				   data: {tk: user.tk, uk: user.uk, pk: user.pk, user_id: tourUser.User.id},
				   success: function(data) {
						if (data.data) {
							if (data.data.User.privacy == 1) {
								user.addTourPendingUser(data.data);
							}
							else {
								user.addTourCache(data.data);
							}
							
							$scope.$apply(function(){
								if (user.isTourPendingUser(data.data.User.id)) {
									$scope.user.User.tourPending = true;
									$scope.user.User.onTour = false;
								}
								else {
									$scope.user.User.tourPending = false;
									$scope.user.User.onTour = user.onTour(data.data.User.id);
								}
								$scope.user.User.isSelf = (user.info.User.id == data.data.User.id);
							});
						}
						pageElm.find('.on-tour-btn').css('opacity', '1');
				   },
				   error: function() {
				   		pageElm.find('.on-tour-btn').css('opacity', '1');
				   }
				});
	};
	
	$scope.removeTour = function(tourUser) {
		pageElm.find('.on-tour-btn').css('opacity', '0.3');
		$.ajax({
				   url: APIHOST + '/users/apiusertour/remove/',
				   method: 'POST',
				   data: {tk: user.tk, uk: user.uk, pk: user.pk, user_id: tourUser.User.id},
				   success: function(data) {
						if (data.data) {
						
							user.removeTourPendingUser(data.data);
							user.removeTourCache(data.data);
						
							$scope.$apply(function(){
								$scope.user.User.tourPending = false;
								$scope.user.User.onTour = user.onTour(data.data.User.id);
								$scope.user.User.isSelf = (user.info.User.id == data.data.User.id);
							});
						}
						pageElm.find('.on-tour-btn').css('opacity', '1');
						
				   },
				   error: function() {
				   		pageElm.find('.on-tour-btn').css('opacity', '1');
				   }
				});
	};
	
	$scope.addGallery = function() {
		var btnActions = function(buttonIndex) {	
			if (buttonIndex == 1) {
				user.approveGalleryUser($scope.user.User.username, function() {
					$scope.$apply(function() {
						$scope.pending_gallery = false;
					});
				});
			}
			if (buttonIndex == 2) {
				user.blockGalleryUser($scope.user.User.username, function() {
					$scope.$apply(function() {
						$scope.pending_gallery = false;
					});
				});
			}
		};
		var options = {
			'title': 'Add to Gallery?',
			'buttonLabels': [
				'Allow in Gallery',
				'Block from Gallery'
			]
		};
		showActionSheet(options, btnActions);
	};
	
	
	loadUserInfo(function() {

	});

});



offcourseApp.controller('CourseController', function($scope, $sce) {
	$scope.club = [];
	$scope.rounds = [];
	$scope.offers = [];
	
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	var course_obj = page.options.course_obj;
	$scope.club = course_obj;

	$scope.club.Club.location = '';
	if ($scope.club.Club.city && $scope.club.Club.state) {
		$scope.club.Club.location = $scope.club.Club.city + ', ' + $scope.club.Club.state;
	}
	else if ($scope.club.Club.city) {
		$scope.club.Club.location = $scope.club.Club.city;
	}
	else if ($scope.club.Club.state) {
		$scope.club.Club.location = $scope.club.Club.state;
	}

	if ($.type($scope.club.Club.description) == 'string') {
		$scope.club.Club.description = $sce.trustAsHtml($scope.club.Club.description);
	}


	if ($.type($scope.club.Club.avatar) == 'string') {	
		pageElm.find('.home-card-avatar').css({
    								'background-image': 'url('+getClubAvatar($scope.club)+')'
    							});
	}
	else {
		pageElm.find('.home-card-avatar').css({
    								'background-image': 'url('+$scope.club.Club.avatar.valueOf()+')'
    							});
	}

    pageElm.find('.home-card-background').css({
    								'background-image': 'url('+$scope.club.Club.background+')'
    							});
	


    if (is_club_app) {
		var callUrl = APIHOST + '/users/apioffers/' + user.cachedLat + '/' + user.cachedLng + '/'+whitelabel.course.club_id+'/types:'+offer_types+'/';
	}
	else {
    	var callUrl = APIHOST + '/users/apioffers/' + user.cachedLat + '/' + user.cachedLng + '/'+$scope.club.Club.id+'/types:'+offer_types+'/';
	}
	$.ajax({
	               url: callUrl,
	               method: 'GET',
	               data: {tk: user.tk, uk: user.uk, pk: user.pk},
	               success: function(data) {
	               		
	               		$.each(data.offers, function(i, offer) {
	               			data.offers[i].Offer.excerpt = $sce.trustAsHtml(data.offers[i].Offer.excerpt);
	               			data.offers[i].Offer.content = $sce.trustAsHtml(data.offers[i].Offer.content);
	               			data.offers[i].Club.avatar = getClubAvatar(data.offers[i]);
	               			data.offers[i].Club.avatar = $sce.trustAsResourceUrl(data.offers[i].Club.avatar);
	               			if (data.offers[i].Offer.photo != '') {
	               				data.offers[i].Offer.photo = $sce.trustAsResourceUrl(data.offers[i].Offer.photo);
	               			}
	               			data.offers[i].isOffer= true;
	               			trackOffer(data.offers[i].Offer.id, 0);
						});               		
	               		$scope.$apply(function(){
							$scope.offers = data.offers;   
						});
						
	               }
	            });


    $.ajax({
				   url: APIHOST + '/courses/apirounds/'+$scope.club.Club.slug+'/',
				   method: 'GET',
				   cache: false,
				   data: {tk: user.tk, uk: user.uk, pk: user.pk},
				   error: function(err) {
				
				   },
				   success: function(data) {
						$scope.$apply(function() {
							
							rounds = data.data;
							$.each(rounds, function(i, round) {
							
								var course_name = '';
								if (round.Round.Course.Club.name != round.Round.Course.name) {
									course_name = round.Round.Course.name;
								}
								var photo = '';
								if (round.Round.Photo && round.Round.Photo[0] && round.Round.Photo[0].medium) {
									photo = "background-image:url("+round.Round.Photo[0].medium+");width:100%;height:150px;position:relative;background-repeat:no-repeat;background-size:cover;background-position:center center;border-radius:4px;margin:5px 0;";
								}
								$scope.rounds.push({
											id: round.Round.id,
											date: toNiceDateTime(parseApiDate(round.Round.date)),
											name: round.User.name,
											club: round.Round.Course.Club.name,
											course: course_name,
											score: round.Round.score,
											holes: round.Round.holes,
											netscore: round.Round.netscore,
											comment: round.Round.comment,
											image: getUserAvatar(round),
											photo: photo
										});
							});
						});
					}
				});





    $scope.phoneClub = function() {
    	trackTeetime(0);
		setTimeout(function() {	
			phoneCall($scope.club.Club.phone);
		}, 100);
    }
    $scope.webClub = function() {
    	setTimeout(function() {	
			window.open($scope.club.Club.website, '_system');
		}, 100);
    }
    $scope.twitterClub = function() {
    	setTimeout(function() {	
			window.open('https://twitter.com/' + $scope.club.Club.twitter, '_system');
		}, 100);
    }
    $scope.facebookClub = function() {
    	setTimeout(function() {	
			window.open($scope.club.Club.facebook, '_system');
		}, 100);
    }


    setTimeout(function() {
		if (pageElm.find('.club-desc').height() > 50) {
	    	pageElm.find('.club-desc').height(50);
	    	pageElm.find('.club-desc-more-area').show();
	    }
    }, 300);
    

});





offcourseApp.controller('RoundListController', function($scope, $sce) {
	$scope._list = [];
	$scope.isLoading = false;
	$scope.isError = false;
	
	$scope.roundCount = 100;
	$scope.currentCount = 0;
	$scope.currentPage = 0;
	$scope.apicall = 'apirounds';
	
	var page = myNavigator.getCurrentPage();
	var currentUser = page.options.user;
	var pageElm = $(page.element);

	var container = pageElm.find('ons-scroller');

	if (currentUser && currentUser.User.id == user.info.User.id) {
		pageElm.find('.navigation-bar .title').html('Your '+ page.options.label);
	}
	else {
		pageElm.find('.navigation-bar .title').html(currentUser.User.name+"'s "+ page.options.label);
	}
	$scope.apicall = page.options.apicall;
	


	$scope.reload = function($done) {
		$scope._list = [];
		$scope.roundCount = 100;
		$scope.currentCount = 0;
		$scope.currentPage = 0;

		$scope.populateRounds($done);
	};


    $scope.canLoadMoreRounds = function() {
    	console.log('canLoadMoreRounds: ' + $scope._list.length +' >= '+ $scope.roundCount);
		return ($scope._list.length >= $scope.roundCount) ? false : true;
	};
	
		/*
			changed lib/onsen/js/onsenui.js to make this work.
			line: 18304
			scrollWrapper = element[0];
			to
			scrollWrapper = element[0].querySelector('.ons-scroller-inner');
		*/
	$scope.populateRounds = function(callback) {
		console.log('populateRounds isLoading: '+ $scope.isLoading);
		if($scope.isLoading) return;
		
		var page = myNavigator.getCurrentPage();
		var currentUser = page.options.user;
		

		$scope.$apply(function(){
			$scope.isLoading = true;
		});
		
		
	
		var callUrl = APIHOST + '/users/'+ $scope.apicall +'/' + currentUser.User.username + '/page:'+($scope.currentPage+1)+'';		
		
		$.ajax({
               url: callUrl,
               method: 'GET',
               data: {tk: user.tk, uk: user.uk, pk: user.pk},
               success: function(data) {
               		
               		$scope.$apply(function(){
               			$scope.isError = false;
						$scope.currentCount = data.page * data.limit;
						$scope.roundCount = data.count;
 						$scope.currentPage = data.page;

						var offers = [];
						if (user.offers.length > 0) {
							offers = user.offers.slice((data.page - 1) * 2, (data.page - 1) * 2 + 2);
						}
						

						if (data.data.length > 0) {
							$.each(data.data, function(i, round) {
							
								if (offers.length > 0) {
									if (i == 4 || i == 8) {
										if (offers.length > 0) {
											var offer = offers.shift();
											
											$scope._list.push({
												id: offer.Offer.id,
												type: 1,
												date: '',
												name: '',
												club: '',
												course: '',
												score: '',
												holes: '',
												netscore: '',
												comment: '',
												image: '',
												photo: '',
												offer: offer
											});

											trackOffer(offer.Offer.id, 0);
										}
									}
								}
							
								var course_name = '';
								if (round.Round.Course.Club.name != round.Round.Course.name) {
									course_name = round.Round.Course.name;
								}
								var photo = '';
								if (round.Round.Photo && round.Round.Photo[0] && round.Round.Photo[0].medium) {
									photo = "background-image:url("+round.Round.Photo[0].medium+");width:100%;height:150px;position:relative;background-repeat:no-repeat;background-size:cover;background-position:center center;border-radius:4px;margin:5px 0;";
								}
								$scope._list.push({
											id: round.Round.id,
											type: 0,
											date: toNiceDateTime(parseApiDate(round.Round.date)),
											name: round.User.name,
											club: round.Round.Course.Club.name,
											course: course_name,
											score: round.Round.score,
											holes: round.Round.holes,
											netscore: round.Round.netscore,
											comment: round.Round.comment,
											image: getUserAvatar(round),
											photo: photo
										});
								
							});
						
						}
						else {
							if (user.info.User.username == currentUser.User.username) {
								$(container).html('<p class="filler-paragraph">You will see all the rounds you have played right here.</p><p class="filler-paragraph">So get out there and golf!</p>');
							}
							else {
								$(container).html('<p class="filler-paragraph">This golfer hasn\'t added any rounds yet.</p>');
							}
						}       		
					
						$scope.isLoading = false;
					});

					if (callback) {
               			callback();
               		}
               },
               error: function() {
               		$scope.isError = true;
               		if (callback) {
               			callback();
               		}
               }
            });	
        return true;
	};
	
	$scope.populateRounds();	
});




offcourseApp.controller('RoundController', function($scope) {
	$scope.canEdit = false;
	$scope.round = {};
	$scope.photos = [];
	$scope.comments = [];
	$scope.playedwith = [];
	$scope.honours = [];
	$scope.showComments = true;
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	var round_id = page.options.round_id;
		


	$scope.reload = function($done) {
		loadRoundDetails($done);
	};

	function loadRoundDetails(complete) {
		$.ajax({
			    url: APIHOST + '/users/apiround/' + round_id + '/',
			    method: 'GET',
			    data: {tk: user.tk, uk: user.uk, pk: user.pk},
			    success: function(data) {
				
					var round = data.data;
					var course_name = '';
					if (round.Course.Club.name == round.Course.name) {
						round.Course.name = '';
					}
					
					if (round.Round.user_id == 0) {
						round.User.name = round.Round.golfername;
						round.User.avatar = getUserAvatar({});
						$scope.$apply(function() {
							$scope.showComments = false;
						});
					}
					
					$scope.$apply(function() {
						$scope.round = round;
					
						$scope.showDetailedScoring = (round.Round.scoringtype == 0) ? true : false;
						$scope.showSimpleScoring = (round.Round.scoringtype == 1) ? true : false;
						$scope.showScoreOnly = (round.Round.scoringtype == 2) ? true : false;
						
						$scope.honours = [];
					});

					if (round.Honour) {
						$.each(round.Honour, function(i, honour) {
							
							honour.Honour = $.extend(true, {}, honour);
							
							honourCache[honour.Details.func] = honour;
							$scope.$apply(function() {
								$scope.honours.push({
										id: honour.Details.func,
										name: honour.Details.name,
										image: APIHOST + honour.Details.img_small,
										image_class: ''
									 });
							});
					
						});
					}
										
					round.Round.date = toNiceDateTime(parseApiDate(round.Round.date));
					
					pageElm.find('.round-card-avatar').css({
											'background-image': 'url('+getUserAvatar(round)+')'
										});
					
					
					
					var parcounts = {
								'par3': {
									'total': 0,
									'count': 0
								},
								'par4': {
									'total': 0,
									'count': 0
								},
								'par5': {
									'total': 0,
									'count': 0
								}
							};
					
					var scrambling = 0;
					var scramblingPotential = 0;
					var scramblingPercent = 0;
					var bounceback = 0;
					var bouncebackPotential = 0;
					var bouncebackPercent = 0;
					var sandsave = 0;
					var sandsavePotential = 0;
					var sandsavePercent = 0;
					
					var roundDetails = '';
					if (round.Round.scoringtype != 2) {
						roundDetails += '<div class="round-view-scorecard-vertical-inner">';
						
							$.each(round.Playedhole, function(index, playedhole) {
					
								var fairwayIcon = '';
								var fairwayClass = '';
								switch (playedhole.fairway) {
									case (-1):
										fairwayIcon = '<i class="fa fa-reply"></i>';
										break;
									case (1):
										fairwayIcon = '<i class="fa fa-share"></i>';
										break;
									case (0):
										fairwayIcon = '<i class="fa fa-check"></i>';
										fairwayClass = 'text-success';
										break
								}
								round.Playedhole[index].fairwayIcon = fairwayIcon;
								round.Playedhole[index].fairwayClass = fairwayClass;
						
								var accIcon = '';
								var accClass = '';
								switch (playedhole.gir) {
									case (0):
										accIcon = '<i class="fa fa-check"></i>';
										accClass = 'text-success';
										break;
									case (1):
										accIcon = '<i class="fa fa-chevron-up"></i>';
										break;
									case (2):
										accIcon = '<i class="fa fa-chevron-right"></i>';
										break
									case (3):
										accIcon = '<i class="fa fa-chevron-down"></i>';
										break
									case (4):
										accIcon = '<i class="fa fa-chevron-left"></i>';
										break
								}
								round.Playedhole[index].accIcon = accIcon;
								round.Playedhole[index].accClass = accClass;
					
								if (playedhole.Hole.par == 3) {
									parcounts.par3.count++;
									parcounts.par3.total += playedhole.score;
								}
								if (playedhole.Hole.par == 4) {
									parcounts.par4.count++;
									parcounts.par4.total += playedhole.score;
								}
								if (playedhole.Hole.par == 5) {
									parcounts.par5.count++;
									parcounts.par5.total += playedhole.score;
								}
						
								var score_height = playedhole.score;
								if (score_height > 10) {
									score_height = 10;
								}
							
								var barClass = 'par';
								if (playedhole.score > playedhole.Hole.par) {
									barClass = 'overpar';
								}
								if (playedhole.score - 1 > playedhole.Hole.par) {
									barClass = 'overpar2';
								}
								if (playedhole.score - 2 > playedhole.Hole.par) {
									barClass = 'overpar3';
								}
								if (playedhole.score < playedhole.Hole.par) {
									barClass = 'underpar';
								}
								if (playedhole.score + 1 < playedhole.Hole.par) {
									barClass = 'underpar2';
								}
							
							
								if (playedhole.Hole.par > 1) {
									if (((playedhole.score - playedhole.putts) <= (playedhole.Hole.par - 2))) {
										// this is GIR
									}
									else {
											// potential for scramble as it's not GIR
										scramblingPotential++;
										if (playedhole.score <= playedhole.Hole.par) {
												// a successful scramble
											scrambling++;
										}
									}					
								}
							
								if(typeof(round.Playedhole[index + 1]) != 'undefined') {
									// figure out the bounceback
									// When you getbirdy or better after a boggie or worse
									if ((playedhole.score) >= (playedhole.Hole.par + 1)) {
											// We have a boogie
										bouncebackPotential++;
										if (round.Playedhole[index + 1].score <= (round.Playedhole[index + 1].Hole.par - 1)) {
											bounceback++;
										}
									}
								} 
							
							
								if (playedhole.sand > 0) {
									sandsavePotential++;
									if (playedhole.score <= playedhole.Hole.par) {
											// a successful sand save
										sandsave++;
									}
								}
							
								round.Playedhole[index].scoreClass = getScoreClass(playedhole.score, playedhole.Hole.par);
						
								roundDetails += '<div class="score-cont">' + 
													'<span class="hole-number">'+playedhole.number+'</span>' +
													'<div class="score-bar score'+score_height+' '+barClass+'">'+
														'<span class="hole-score">'+playedhole.score+'</span>' +
														'<div class="par'+playedhole.Hole.par+'">'+
														'</div>'+
													'</div>'+
												'</div>';
					
							
							});
					
						roundDetails += '</div>';
						pageElm.find('.round-view-scorecard-vertical').html(roundDetails);
					
						var totalWidth = pageElm.width();
						var holeWidth = ((totalWidth - 30) / 18) - 2;
						var holeMargin = 1;
						pageElm.find('.round-view-scorecard-vertical .score-cont').css({width: holeWidth+'px', 'margin-right': holeMargin+'px', 'margin-left': holeMargin+'px'});
					
						var contPad = 14;
						var holeCount = round.Playedhole.length;
						var shift = ((18 - holeCount) / 2) * (holeWidth + holeMargin * 2);
						if (shift > 0) {
							contPad = shift + contPad;
						}
						pageElm.find('.round-view-scorecard-vertical-inner').css({ 'padding-left': contPad+'px' });

					
						var par3s = 0;
						if (parcounts.par3.count > 0) {
							par3s = (parcounts.par3.total / parcounts.par3.count).toFixed(1);
						}
						var par4s = 0;
						if (parcounts.par4.count > 0) {
							par4s = (parcounts.par4.total / parcounts.par4.count).toFixed(1);
						}
						var par5s = 0;
						if (parcounts.par5.count > 0) {
							par5s = (parcounts.par5.total / parcounts.par5.count).toFixed(1);
						}
						round.Round.par3s = par3s;
						round.Round.par4s = par4s;
						round.Round.par5s = par5s;
						
					
						var puttAvg = '-';
						if (round.Playedhole.length > 0) {
							puttAvg = (round.Round.putts / round.Playedhole.length).toFixed(1);
						}
						round.Round.puttingstat = puttAvg;
		
						if (scramblingPotential == 0) {
							scramblingPercent = 'NA';
						}
						else {
							scramblingPercent = scrambling / scramblingPotential * 100;
							scramblingPercent = scramblingPercent.toFixed(0)+'%';
						}
						round.Round.scramblingstat = scramblingPercent;
					
						if (bouncebackPotential == 0) {
							bouncebackPercent = 'NA';
						}
						else {
							bouncebackPercent = bounceback / bouncebackPotential * 100;
							bouncebackPercent = bouncebackPercent.toFixed(0)+'%';
						}
						round.Round.bouncebackstat = bouncebackPercent;
					
					
						if (sandsavePotential == 0) {
							sandsavePercent = 'NA';
						}
						else {
							sandsavePercent = sandsave / sandsavePotential * 100;
							sandsavePercent = sandsavePercent.toFixed(0)+'%';
						}
						round.Round.sandsavestat = sandsavePercent;
					}
				
					$scope.$apply(function() {
					
						if (user.isSignedIn()) {
							$scope.canEdit = (round.User.id == user.info.User.id) ? true : false;
						}
						else {
							$scope.canEdit = false;
						}

						$scope.round = round;
										
						if (round.Activity && round.Activity.Comment) {
							$.each(round.Activity.Comment, function(i, comment) {
								round.Activity.Comment[i]['User']['avatar'] = getUserAvatar(comment);
							});
						}
						
						$scope.comments = round.Activity.Comment;
						
						if (round.Friends) {
							$.each(round.Friends, function(index, friend) {
								if (friend.Round.user_id == 0) {
									friend.User.name = friend.Round.golfername;
									friend.User.avatar = getUserAvatar({});
								}
								else {
									friend.User.avatar = getUserAvatar(friend);
								}
								$scope.playedwith.push(friend);
							});
						}
						if (round.Competition) {
							$.each(round.Competition, function(index, friend) {
								friend.User.avatar = getUserAvatar(friend);
								$scope.playedwith.push(friend);
							});
						}
						
						$scope.score = $scope.round.Round.score;
						$scope.netscore = $scope.round.Round.netscore;
						
					});
					
					
					$.ajax({
					   url: APIHOST + '/users/apiroundphotos/'+round_id+'/',
					   method: 'GET',
					   data: {tk: user.tk, uk: user.uk, pk: user.pk},
					   success: function(data) {
							var photos = data.data;
							if (photos.length > 0) {
								pageElm.find('.round-card-background').css({
											'background-image': 'url('+photos[0].Photo.medium+')'
										});
								$scope.$apply(function() {
									$scope.photos = photos;
								});
								
							}
							else if ($scope.round.Course && $scope.round.Course.Club.background) {
								$scope.$apply(function() {
									pageElm.find('.round-card-background').css({
											'background-image': 'url('+$scope.round.Course.Club.background+')'
										});
									$scope.photos = photos;
								});
							}
							else if ($scope.round.User.background) {
								$scope.$apply(function() {
									pageElm.find('.round-card-background').css({
											'background-image': 'url('+$scope.round.User.background+')'
										});
									$scope.photos = photos;
								});
							}
					   },
					   error: function() {
							
					   }
					});
					
					setTimeout(function() {
							// just a later refresh of the view
						$scope.$apply();
					}, 1000);

					if (complete) {
						complete();
					}
				},
				error: function() {
					if (complete) {
						complete();
					}
				}
				
		});
	}
	
	$scope.postNewComment = function() {
		var newComment = pageElm.find('.new-comment-text').val();
		pageElm.find('.new-comment-text').blur();
		
		if (newComment != '') {
			pageElm.find('.new-comment-btn').html('Posting...');
			pageElm.find('.new-comment-btn').attr('disabled', true);
			
			$.ajax({
				   url: APIHOST + '/users/apicomment/' + $scope.round.Round.id + '/',
				   method: 'POST',
				   data: {tk: user.tk, uk: user.uk, pk: user.pk, comment: newComment},
				   success: function(data) {
						try {
							if (data.data.Comment) {
								var comment = data.data.Comment; 
								comment['User'] = data.data.User;
								comment['User']['avatar'] = getUserAvatar(comment);
								
								$scope.$apply(function() {
									if (typeof($scope.comments) == 'object') {
										$scope.comments.push(comment);
									}
									else {
										$scope.comments = [ comment ];
									}
								});
								
							}
						}
						catch(err) {
							console.log('comment error');
							console.log(err);
						}
						pageElm.find('.new-comment-text').val('');
						pageElm.find('.new-comment-btn').html('Post It');
						pageElm.find('.new-comment-btn').attr('disabled', false);
						
				   },
				   error: function() {
				   	  navigator.notification.alert('There was a problem posting the comment.  Please try again.', function() {} , 'Comment Problem', 'Dismiss');
				      
				      pageElm.find('.new-comment-btn').html('Post It');
					  pageElm.find('.new-comment-btn').attr('disabled', false);
				   }
				});
		}
	};
	
		
	$scope.fullScorecard = function() {
		myNavigator.pushPage('scorecard.html', { round: $scope.round });
	};
		
		
	$scope.shareRound = function() {
		pageElm.find('.share-icon').removeClass('fa-share').addClass('fa-circle-o-notch').addClass('fa-spin');

		var msg = '';
		if ($scope.round.Round.user_id == user.info.User.id) {
			msg = 'I shot '+$scope.round.Round.score+' at '+$scope.round.Course.Club.name+' '+whitelabel.share_hash+' ';
		}
		else {
			msg = $scope.round.User.name+' shot '+$scope.round.Round.score+' at '+$scope.round.Course.Club.name+' '+whitelabel.share_hash+ ' ';
		}
		$.ajax({
			url: whitelabel.share_url+'users/roundimage/'+$scope.round.Round.id+'/0/1/',
			timeout: 4000,
			success: function(image_url) {
				pageElm.find('.share-icon').addClass('fa-share').removeClass('fa-circle-o-notch').removeClass('fa-spin');
				shareLink('Shared Round', msg, whitelabel.share_url+'a/'+$scope.round.Round.id+'/', image_url);
			},
			error: function() {
				pageElm.find('.share-icon').addClass('fa-share').removeClass('fa-circle-o-notch').removeClass('fa-spin');
				shareLink('Shared Round', msg, whitelabel.share_url+'a/'+$scope.round.Round.id+'/', null);
			}
		});
		
	}	

	$scope.showPhoto = function(photo) {
		showPhoto(photo.Photo.medium);
	};

	$scope.openUser = function(round) {
		if (round.Round.user_id != 0) {
			myNavigator.pushPage('user.html', { user_obj: round });
		}
	};

	loadRoundDetails();

});



offcourseApp.controller('ScorecardController', function($scope, $sce) {
	$scope.holes = [];
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	$scope.round = page.options.round;
	$scope.userrounds = [];
	$scope.showDetailedScorecard = true;
	
	$scope.showDetailedScoring = ($scope.round.Round.scoringtype == 1) ? false : true;
	
	if ($scope.round.Course.Club.name == $scope.round.Course.name) {
		$scope.round.Course.name = '';
	}
	$scope.round.Course.Club.avatar = getClubAvatar($scope.round.Course);

	
	$scope.userrounds = [];
	$scope.round.ArrangedScore = arrangeScorecard($scope.round, $sce);

	$scope.userrounds.push($scope.round);

	if ($scope.round.Friends) {
		$.each($scope.round.Friends, function(index, friend) {
			if (friend.Round.user_id == 0) {
				friend.User.name = friend.Round.golfername;
				friend.User.avatar = getUserAvatar({});
			}
			else {
				friend.User.avatar = getUserAvatar(friend);
			}
			friend.ArrangedScore = arrangeScorecard(friend, $sce);
			$scope.userrounds.push(friend);
		});
	}

	if ($scope.round.Competition) {
		$.each($scope.round.Competition, function(index, friend) {
			if (friend.Round.user_id == 0) {
				friend.User.name = friend.Round.golfername;
				friend.User.avatar = getUserAvatar({});
			}
			else {
				friend.User.avatar = getUserAvatar(friend);
			}
			friend.ArrangedScore = arrangeScorecard(friend, $sce);
			$scope.userrounds.push(friend);
		});
	}
	
	if ($scope.userrounds.length > 1) {
		$scope.showDetailedScorecard = false;
	}
	
});





function arrangeScorecard(round, $sce) {

	var rearrangedPlayedHoles = {};
	round = getNetScore(round);
	$.each(round.Playedhole, function(index, playedhole) {
		rearrangedPlayedHoles[playedhole.number] = playedhole;
	});

	var holes = [];
	var scoreout = {
					dist: 0,
					par: 0,
					score: 0,
					putts: 0,
					netscore: 0,
					stableford: 0
				};
	var scorein = {
					dist: 0,
					par: 0,
					score: 0,
					putts: 0,
					netscore: 0,
					stableford: 0
				};
	var scoretotal = {
					dist: 0,
					par: 0,
					score: 0,
					putts: 0,
					netscore: 0,
					stableford: 0
				};
	$.each(round.Tee.Hole, function(index, hole) {
			// number, dist, handicap, par, score
		var score = '';
		var scoreNumber = 0;
		var netscore = '';
		var netscoreNumber = 0;
		var fairway = '';
		var acc = '';
		var gir = '';
		var putts = '';
		var puttsNumber = 0;
		var sand = '';
		var penalty = '';
		var scoreClass = '';
		var netscoreClass = '';

		if (typeof(rearrangedPlayedHoles[hole.number]) != 'undefined') {
			var playedhole = rearrangedPlayedHoles[hole.number]
			score = playedhole.score;
			scoreNumber = playedhole.score;
			netscore = playedhole.netscore;
			netscoreNumber = playedhole.netscore;
			putts = playedhole.putts;
			puttsNumber = playedhole.putts;
			scoreClass = '';
			netscoreClass = '';
		
			var fairwayIcon = '';
			var fairwayClass = '';
			switch (playedhole.fairway) {
				case (-1):
					fairwayIcon = '<i class="fa fa-reply"></i>';
					break;
				case (1):
					fairwayIcon = '<i class="fa fa-share"></i>';
					break;
				case (0):
					fairwayIcon = '<i class="fa fa-check"></i>';
					fairwayClass = 'text-success';
					break
			}
			fairway = '<span class="'+fairwayClass+'">'+fairwayIcon+'</span>';

			var accIcon = '';
			var accClass = '';
			switch (playedhole.gir) {
				case (0):
					accIcon = '<i class="fa fa-check"></i>';
					accClass = 'text-success';
					break;
				case (1):
					accIcon = '<i class="fa fa-chevron-up"></i>';
					break;
				case (2):
					accIcon = '<i class="fa fa-chevron-right"></i>';
					break
				case (3):
					accIcon = '<i class="fa fa-chevron-down"></i>';
					break
				case (4):
					accIcon = '<i class="fa fa-chevron-left"></i>';
					break
			}
			acc = '<span class="'+accClass+'">'+accIcon+'</span>';
			
			gir = '<span class="text-success">'+(((playedhole.score - playedhole.putts) <= (playedhole.Hole.par - 2)) ? '<i class="fa fa-check"></i>' : '')+'</span>';
			sand = '<span class="">'+((playedhole.sand > 0) ? '<i class="fa fa-times-circle-o"></i>' : '')+'</span>';
			penalty = '<span class="">'+((playedhole.penalty > 0) ? '<i class="fa fa-times-circle-o"></i>' : '')+'</span>';
		
		
			scoreClass = getScoreClass(playedhole.score, playedhole.Hole.par);
			netscoreClass = getScoreClass(playedhole.netscore, playedhole.Hole.par);
			
		
		}
		
		var stablefordPoints = getStablefordPoints(hole.par, netscore);
		
		if (!hole.metric) {
			var hole_dist = user.convertDistance(hole.yards);
		}
		else {
			var hole_dist = hole.yards;
		}

		holes.push({
				number: hole.number,
				index: index,
				dist: hole_dist,
				handicap: hole.rating,
				par: hole.par,
				score: score,
				netscore: netscore,
				putts: putts,
				fairway: $sce.trustAsHtml(fairway),
				gir: $sce.trustAsHtml(gir),
				acc: $sce.trustAsHtml(acc),
				sand: $sce.trustAsHtml(sand),
				penalty: $sce.trustAsHtml(penalty),
				scoreClass: scoreClass,
				netscoreClass: netscoreClass,
				stableford: stablefordPoints
			});
		if (hole.number < 10) {
			scoreout.dist += parseInt(hole_dist);
			scoreout.par += parseInt(hole.par);
			scoreout.score += parseInt(scoreNumber);
			scoreout.putts += parseInt(puttsNumber);
			scoreout.netscore += parseInt(netscoreNumber);
			if (stablefordPoints) {
				scoreout.stableford += parseInt(stablefordPoints);
			}
		}
		if (hole.number > 9) {
			scorein.dist += parseInt(hole_dist);
			scorein.par += parseInt(hole.par);
			scorein.score += parseInt(scoreNumber);
			scorein.putts += parseInt(puttsNumber);
			scorein.netscore += parseInt(netscoreNumber);
			if (stablefordPoints) {
				scorein.stableford += parseInt(stablefordPoints);
			}
		}
		scoretotal.dist += parseInt(hole_dist);
		scoretotal.par += parseInt(hole.par);
		scoretotal.score += parseInt(scoreNumber);
		scoretotal.putts += parseInt(puttsNumber);
		scoretotal.netscore += parseInt(netscoreNumber);
		if (stablefordPoints) {
			scoretotal.stableford += parseInt(stablefordPoints);
		}
	});
	
	return {
			scoreout: scoreout,
			scorein: scorein,
			scoretotal: scoretotal,
			holes: holes
		};
	
}

function getStablefordPoints(par, score) {
	if (score && score != '') {
		score = (parseInt(par) + 2) - parseInt(score);
		if (score < 0) {
			score = 0;
		}
		return parseInt(score);
	}
	return score;
}








offcourseApp.controller('HolehistoryController', function($scope, $sce) {
	$scope.holes = [];
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	$scope.round = page.options.round;
	$scope.coursehistory = page.options.coursehistory;
	$scope.holenumber = page.options.holenumber;
	$scope.holehistory = [];
	$scope.hole = {};
	
	var hole = {};
	var holehistory = [];
	$.each($scope.coursehistory, function(index, round) {
		$.each(round.Round.Playedhole, function(index2, ph) {
			if (ph.number == $scope.holenumber) {
				round_date = parseApiDate(round.Round.date);
				ph.rounddate = toStandardDate(round_date);	//todo
				holehistory.push(ph);
				
				ph.Hole.yardstext = user.convertDistance(ph.Hole.yards) + ' ' + dUnits(true);
				hole = ph.Hole;
				
			}
		});
	});
	
	var totalscore = 0;
	var holecount = holehistory.length;
	$.each(holehistory, function(i, ph) {
		totalscore += parseInt(ph.score);

		var fairwayIcon = '';
		var fairwayClass = '';
		switch(ph.fairway) {
			case (-1):
				fairwayIcon = '<i class="fa fa-reply"></i>';
				break;
			case (1):
				fairwayIcon = '<i class="fa fa-share"></i>';
				break;
			case (0):
				fairwayIcon = '<i class="fa fa-check"></i>';
				fairwayClass = 'text-success';
				break
		}
		var accIcon = '';
		var accClass = '';
		switch (ph.gir) {
			case (0):
				accIcon = '<i class="fa fa-check"></i>';
				accClass = 'text-success';
				break;
			case (1):
				accIcon = '<i class="fa fa-chevron-up"></i>';
				break;
			case (2):
				accIcon = '<i class="fa fa-chevron-right"></i>';
				break
			case (3):
				accIcon = '<i class="fa fa-chevron-down"></i>';
				break
			case (4):
				accIcon = '<i class="fa fa-chevron-left"></i>';
				break
		}
		
		var scoreDisplay = ph.score - hole.par;
		scoreDisplay = scoreDisplay;
		if (scoreDisplay > 0) {
			scoreDisplay = '+'+scoreDisplay;
		}


		holehistory[i].fairwayClass = fairwayClass;
		holehistory[i].fairwayIcon = $sce.trustAsHtml(fairwayIcon);

		holehistory[i].accClass = accClass;
		holehistory[i].accIcon = $sce.trustAsHtml(accIcon);
		
		holehistory[i].sandIcon = $sce.trustAsHtml( ((ph.sand == 1) ? '<i class="fa fa-times-circle"></i>' : '') );
		holehistory[i].penaltyIcon = $sce.trustAsHtml( ((ph.penalty == 1) ? '<i class="fa fa-times-circle"></i>' : '') );

		holehistory[i].scoreDisplay = scoreDisplay;
	});
	
	var avgscoreDisplay = 0;
	if (holecount > 0) {
		var avgScore = parseFloat(totalscore / holecount);
		avgscoreDisplay = avgScore - hole.par;
		avgscoreDisplay = avgscoreDisplay.toFixed(1)
		if (avgscoreDisplay > 0) {
			avgscoreDisplay = '+'+avgscoreDisplay;
		}
	}
	$scope.avgScore = avgscoreDisplay;
	$scope.hole = hole;
	$scope.holehistory = holehistory;
});










offcourseApp.controller('NewroundController', function($scope) {
	
	$scope.course = {
		search: ''
	}
	$scope.lat = '';
	$scope.lng = '';
  
	$scope.courses = [];
	$scope.isLoading = false; 
	$scope.courseCount = 100;
	$scope.currentCount = 0;
	$scope.currentPage = 0;
	$scope.gpsproblems = false;


	var page = myNavigator.getCurrentPage();
	var currentUser = page.options.user;
	var pageElm = $(page.element);
	
		// if they get here, just set it as onboarded
	app.setOnboarded();
	
    $scope.canLoadMoreCourses = function() {
		return ($scope.courses.length >= $scope.courseCount) ? false : true;
	};
	
	$scope.populateCourses = function() {
		if($scope.isLoading) return;
		
		
		$scope.isLoading = true;
		
		
		
		gps.getPosition(function(data) {
			if (data) {
				user.cachedLat = data.coords.latitude;
				user.cachedLng = data.coords.longitude;
				user.cachedAccuracy = data.coords.accuracy;
			}
			else {
				$scope.gpsproblems = true;
			}
			

			var params = {tk: user.tk, uk: user.uk, pk: user.pk};
			if (user.cachedLat) {
				params['lat'] = user.cachedLat;
				params['lng'] = user.cachedLng;
			}
			
			//params['q'] = pageElm.find('.search-input').val();
			params['q'] = $scope.course.search;
			params['date'] = new Date().toString();
			
			$scope.lat = user.cachedLat;
			$scope.lng = user.cachedLng;
			
				// default list
			if (app.default_club_list.length > 0) {
				$scope.currentCount = app.default_club_list.length;
				$scope.courseCount = app.default_club_list.length;
					$scope.currentPage = 1;
					
				$scope.courses = app.default_club_list;

			}

			$.ajax({
			   url: APIHOST + '/courses/apifind/page:1/limit:30/',
			   method: 'GET',
			   data: params,
			   success: function(data) {
			   		var courses = data.data;
			   		$.each(courses, function(i, course) {
			   			if (course.Course.name == course.Club.name) {
			   				courses[i].Course.name = '';
			   			}
			   			courses[i].Club.avatar = getClubAvatar(courses[i]);
			   		});
			   		
			   		//$scope.currentCount = data.page * data.limit;
					//$scope.courseCount = data.count;
						//$scope.currentPage = data.page;
							// search doesn't support paging yet
						$scope.currentCount = courses.length;
					$scope.courseCount = courses.length;
						$scope.currentPage = 1;
						
					$scope.courses = courses;
				
					$scope.isLoading = false;
					$scope.$apply(function() { });

					//if ($scope.currentCount <= 10) {
					//	$scope.populateCourses();
					//}

					
			   },
			   error: function() {
					$scope.isLoading = false;
			   }
			});
			
		});
			
		
        return true;
	};
	
	
	
	$scope.newCourse = function() {
		myNavigator.pushPage('newcourse.html', { search: $scope.course.search, lat: $scope.lat, lng: $scope.lng })
	}
	
	
	
	$scope.populateCourses();
	
	
	
});



offcourseApp.controller('NewcourseController', function($scope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	$scope.searchterm = page.options.search;
	$scope.lat = page.options.lat;
	$scope.lng = page.options.lng;
	$scope.city = page.options.city;

	if (typeof($scope.city) == 'undefined') {
		$scope.city = '';
	}


	$scope.doNewCoursePhoto = function() {
		
		params = {
					name: pageElm.find('.new-course-name').val(),
					location: pageElm.find('.new-course-location').val(),
					tee: pageElm.find('.new-course-tee').val(),
					searchterm: $scope.searchterm,
					searchlat: $scope.lat,
					searchlng: $scope.lng,
					searchParams: {}
				};
		
		photo.upload('scorecardphoto', 
					APIHOST + '/users/apinewcourse/',
					params, 
					function(photoURI, progress) {
						if (progress < 1) {
							newcoursemodal.show();
						}
							//progress
						$('.scorecard-upload-percent').html(progress+'%');
							
					}, 
					function() {
							// Done well
						
						
						$.ajax({
							   url: APIHOST + '/courses/apicoursedetails/',
							   method: 'GET',
							   data: {tk: user.tk, uk: user.uk, pk: user.pk, id: genericCourse},
							   success: function(data) {
									newcoursemodal.hide();
									var course = data.data;
									myNavigator.pushPage('newrounddetails2.html', { course_obj: course, tee_obj: course.Tee[0]});
							   },
							   error: function() {
	   								newcoursemodal.hide();
	   								navigator.notification.alert('We ran into a problem uploading your photo.  Please try again.', function() {} , 'Photo Problem', 'Dismiss');
							   }
							});
						
					}, 
					function() {
							//error
						newcoursemodal.hide();
						navigator.notification.alert('We ran into a problem uploading your photo.  Please try again.', function() {} , 'Photo Problem', 'Dismiss');
					});
	
	};
	



});


offcourseApp.controller('NewrounddetailsController', function($scope, ParamService) {
	$scope.tees = [];
	$scope.course = {};
	
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	$scope.course = page.options.course_obj;
	$scope.user = page.options.user_obj;
	$scope.new_round = page.options.new_round;
	$scope.round = page.options.round;

	var isFriend = false;
	if (typeof($scope.user) != 'undefined') {
		isFriend = true;
	}
	else {
		$scope.user = user.info;
	}

	
	showTees = function(course) {
					
		$.each(course.Tee, function(i, tee) {
			if ($scope.user.User.gender == 1) {
				if (tee.slopefemale > 0) {
					course.Tee[i]['teerating'] = '(' + tee.ratingfemale + '/' + tee.slopefemale + ')';
				}
				else if (tee.ratingfemale > 0) {
					course.Tee[i]['teerating'] = '(' + tee.ratingfemale + ' SSS)';
				}
			}
			else {
				if (tee.slope > 0) {
					course.Tee[i]['teerating'] = '(' + tee.rating + '/' + tee.slope + ')';
				}
				else if (tee.rating > 0) {
					course.Tee[i]['teerating'] = '(' + tee.rating + ' SSS)';
				}
			}
			
			if (user.isMetric) {
				course.Tee[i]['teelength'] = yardsToMeters(tee.yards) + '' + dUnits(true);
			}
			else {
				course.Tee[i]['teelength'] = tee.yards + '' + dUnits(true);
			}
			
		});
		
		if (course.Course.name == course.Club.name) {
			course.Course.name = '';
		}
		course.Club.avatar = getClubAvatar(course);
		
		$scope.$apply(function() {
			$scope.course = course;
			$scope.tees = course.Tee;
		});
	}

	if (typeof($scope.course.Tee) == 'undefined') { 
		$.ajax({
			   url: APIHOST + '/courses/apicoursedetails/',
			   method: 'GET',
			   data: {tk: user.tk, uk: user.uk, pk: user.pk, id: $scope.course.Course.id},
			   success: function(data) {
					showTees(data.data);
			   },
			   error: function() {
		   
			   }
			});
	}
	else {
		showTees($scope.course);
	}

			
	var btnclicked = false;
	$scope.loadMoreDetail = function(tee) {
		if (!btnclicked) {
			btnclicked = true;
			if (isFriend) {
				$scope.user.Tee = tee;
				var params = ParamService.getParams();
				
				params.friends = (params.friends) ? params.friends : [];
				params.friends.push($scope.user);
				ParamService.setParams({
					friends: params.friends
				});
				
				myNavigator.popPage({ animation: "none" });
				myNavigator.popPage({ animation: "none" });

				if (!$scope.new_round) {
						// save the round with new friend and reset round.
					var saveRoundData = {
						tk: user.tk, 
						uk: user.uk, 
						pk: user.pk,
						'Round': $scope.round.Round,
						'User': user.info.User,
						'Friends': params.friends
					};
				
				
					$.ajax({
						   url: APIHOST + '/users/apisaveround/',
						   method: 'POST',
						   data: saveRoundData,
						   success: function(data) {
						   		$scope.$apply(function() {
						   			$scope.loadingPlay = false;
						   		});
						   		roundStartPressed = false;
								if (data.data && data.data.Round) {
									currentRound = data.data;
									myNavigator.resetToPage('play.html', { round_id: currentRound.Round.id, start_hole: $scope.start_hole, friends: $scope.friends });
								}
						   },
						   error: function(err) {
						   		$scope.$apply(function() {
						   			$scope.loadingPlay = false;
						   		});
								roundStartPressed = false;

						   }
						});
					
				}
			}
			else {
				
				myNavigator.pushPage('newrounddetails2.html', { course_obj: $scope.course, tee_obj: tee});
				
			}
		}
		setTimeout(function() {
			btnclicked = false;
		}, 200);
	}
	
	$scope.newCourse = function() {
		myNavigator.pushPage('newcourse.html', { search: $scope.course.Club.name + ' : ' + $scope.course.Course.name, city: $scope.course.Club.city, lat: user.cachedLat, lng: user.cachedLng });
	}

	
});



offcourseApp.controller('Newrounddetails2Controller', function($scope, ParamService) {
	
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	
	$scope.loadingPlay = false;
	
	$scope.course = page.options.course_obj;
	$scope.tee = page.options.tee_obj;
	$scope.friends = [];
	
	$scope.is18holes = ($scope.tee.holecount > 9) ? true : false;
	$scope.start_nine = 'Start on Front 9';
	$scope.start_hole = 1;
	$scope.nicedate = 'Today';
	$scope.rounddate = toApiDate(new Date());

	$scope.scoringtype = scoringtypes[app.defaultScoringType];
	$scope.scoringtype_id = 0;
	var scoring_indexes = [];
	var scoring_labels = [];
	$.each(scoringtypes, function(i, st) {
		scoring_indexes.push(i);
		scoring_labels.push(st);
	});

	$scope.gametype = gametypes[0];
	$scope.gametype_id = 0;
	var gametype_indexes = [];
	var gametype_labels = [];
	$.each(gametypes, function(i, st) {
		gametype_indexes.push(i);
		gametype_labels.push(st);
	});
	
	$scope.friendscoring = app.caps.friendscoring;
	$scope.friends = [];
	ParamService.addChangeListener('friendAdd', function(params) {
		if (params.friends) {
			$scope.friends = params.friends;
		}
	});

	$scope.scoringtypeoption = true;

	$scope.changeScoringType = function() {
		var btnActions = function(buttonIndex) {	
			if (typeof(scoring_indexes[buttonIndex - 1]) != 'undefined') {
				$scope.$apply(function() {
					$scope.scoringtype_id = scoring_indexes[buttonIndex - 1];
					$scope.scoringtype = scoringtypes[$scope.scoringtype_id];
					if ($scope.scoringtype_id == 2) {
						$scope.scoringtypeoption = false;
					}
					else {
						$scope.scoringtypeoption = true;
					}
				});
			}
		};
		var options = {
			'title': 'Change Scoring Type?',
			'buttonLabels': scoring_labels
		};
		showActionSheet(options, btnActions);
	}
	$scope.changeGameType = function() {
		var btnActions = function(buttonIndex) {	
			if (typeof(gametype_indexes[buttonIndex - 1]) != 'undefined') {
				$scope.$apply(function() {
					$scope.gametype_id = gametype_indexes[buttonIndex - 1];
					$scope.gametype = gametypes[$scope.gametype_id];
				});
			}
		};
		var options = {
			'title': 'Change Game Type?',
			'buttonLabels': gametype_labels
		};
		showActionSheet(options, btnActions);
	}

	$scope.changeStartHole = function() {
		var btnActions = function(buttonIndex) {	
			if (buttonIndex > 0) {
				$scope.$apply(function() {
					if (buttonIndex == 2) {
						$scope.start_nine = 'Start on Back 9';
						$scope.start_hole = 10;
					}
					else if (buttonIndex == 1) {
						$scope.start_nine = 'Start on Front 9';
						$scope.start_hole = 1;					
					}
				});
				
			}
		};
		var options = {
			'title': 'Change Starting Hole?',
			'buttonLabels': [
				'Start on Front 9',
				'Start on Back 9'
			]
		};
		showActionSheet(options, btnActions);
	}



	$scope.changeDate = function() {
		pickRoundDate($scope.rounddate, function(date) {
			$scope.$apply(function() {
				$scope.nicedate = toApiDate(date);
				$scope.rounddate = toApiDate(date);
			});
		});
		
	}



	var roundStartPressed = false;
	$scope.startRound = function() {
		if (!roundStartPressed) {
			$scope.loadingPlay = true;
			roundStartPressed = true;
			var saveRoundData = {
				tk: user.tk, 
				uk: user.uk, 
				pk: user.pk,
				'Round': {
					'course_id': $scope.course.Course.id,
					'tee_id': $scope.tee.id,
					'user_id': user.info.User.id,
					'date': pageElm.find('.round-date').val(),
					'gametype': $scope.gametype_id,
					'scoringtype': $scope.scoringtype_id,
					'score': 0,
					'holes': 0,
					'starthole': $scope.start_hole
				},
				'User': user.info.User,
				'Playedholes': [],
				'Friends': $scope.friends
			};
		
			
			$.ajax({
				   url: APIHOST + '/users/apisaveround/',
				   method: 'POST',
				   data: saveRoundData,
				   success: function(data) {
				   		$scope.$apply(function() {
				   			$scope.loadingPlay = false;
				   		});
				   		roundStartPressed = false;
						if (data.data && data.data.Round) {
							currentRound = data.data;
							myNavigator.resetToPage('play.html', { round_id: currentRound.Round.id, start_hole: $scope.start_hole, friends: $scope.friends });
						}
				   },
				   error: function(err) {
				   			// make this work offline.... 
				   		$scope.$apply(function() {
				   			$scope.loadingPlay = false;
				   		});
						roundStartPressed = false;

							// start round offline - it will try save later when it can....
						myNavigator.resetToPage('play.html', { 
								round_id: 0, 
								start_hole: $scope.start_hole, 
								scoringtype: $scope.scoringtype_id,
								gametype: $scope.gametype_id,
								date: pageElm.find('.round-date').val(),
								friends: $scope.friends, 
								course: $scope.course,
								tee: $scope.tee
							});
				   }
				});
			
		}
	};
	
	$scope.addFriend = function() {
		myNavigator.pushPage('addfriend.html', { course_obj: $scope.course, tee_obj: $scope.tee});
	};
	$scope.removeFriend = function(friend) {
		navigator.notification.confirm('Are you sure you want to remove '+friend.User.name+'?',
							function(results) {
								if (results == 1) {
									var removeIndex = null;
									$.each($scope.friends, function(i, friendCheck) {
										if ($scope.friends[i].User.id == friend.User.id) {
											removeIndex = i;
										}
			
									});
									if (removeIndex !== null) {
										$scope.friends.splice(removeIndex, 1);
									}
			
									ParamService.setParams({
										friends: $scope.friends
									});
								}
							},
							whitelabel.app_name,
							['Remove Friend', 'Keep Friend']);
	
	
	};

});



offcourseApp.controller('AddfriendController', function($scope, ParamService) {
	$scope.newfriend = {
		name: '',
		email: ''
	};
	
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	var newRound = true;
	var round_id = null;
	$scope.course = page.options.course_obj;
	$scope.tee = page.options.tee_obj;
	$scope.round = page.options.round;
	if ($scope.round) {
		console.log($scope.round);
			// this is an in round add
		$scope.course = {
			Course: $scope.round.Course
		};
		$scope.tee = {
			Tee: $scope.round.Tee
		};
		newRound = false;
		round_id = $scope.round.Round.id;
	}
	
	$scope.loadTour = function() {
		$.ajax({
				   url: APIHOST + '/users/apitour/'+ user.info.User.username +'/',
				   method: 'GET',
				   data: {tk: user.tk, uk: user.uk, pk: user.pk},
				   success: function(data) {
						userTour = data.data;
						userTour = sortUserTour(userTour, 'name', 'asc');
			   
						$.each(userTour, function(i, tUser) {
							userTour[i].User.avatar = getUserAvatar(userTour[i]);
							userTour[i].User.onTour = user.onTour(tUser.User.id);
							userTour[i].User.isSelf = (user.info.User.id == tUser.User.id);
						});
			   
						$scope.$apply(function(){
							$scope._list = userTour;
						});
				   },
				   error: function() {
					
				   }
				});	
	};	
	
	$scope.addFriend = function(tourUser) {
		myNavigator.pushPage('newrounddetails.html', { course_obj: $scope.course, user_obj: tourUser, new_round: newRound, round: $scope.round});
	};
	
	$scope.addNewFriend = function() {
		if ($scope.newfriend.email != '' && !validateEmail($scope.newfriend.email)) {
			alert('Please enter a valid email address.');
			return;
		}
		if ($scope.newfriend.name == '') {
			alert('Please enter your friends name.');
			return;
		}
		var tourUser = {
			User: {
				id: 0,
				name: $scope.newfriend.name,
				email: $scope.newfriend.email,
				avatar: getUserAvatar({})
			} 
		};
		myNavigator.pushPage('newrounddetails.html', { course_obj: $scope.course, user_obj: tourUser, new_round: newRound, round: $scope.round});
	};
	
	$scope.loadTour();

});


offcourseApp.controller('FinishroundController', function($scope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	$scope.round = page.options.round_obj;

	$scope.gc_club = false;

	getGolfCanadaInfo($scope.round.Course.Club.slug, function(gc_club) {
		if (gc_club) {
			$scope.gc_club = gc_club;
			$scope.$apply();
		}
	});

	$scope.finishRound = function(post_score_external) {
		finishroundmodal.show();
		$scope.round.Round.status = 0;
		$scope.round.Round.comment = pageElm.find('.current-round-comments').val();
		
		var saveRound = {
			tk: user.tk, 
			uk: user.uk,
			pk: user.pk,
			'Round': {
				'id': $scope.round.Round.id,
				'status': $scope.round.Round.status,
				'comment': $scope.round.Round.comment
			}
		};
		
		$.ajax({
               url: APIHOST + '/users/apisaveround/',
               method: 'POST',
               data: saveRound,
               success: function(data) {
               		if (data.data && data.data.Round) {
               			var currentRound = data.data;
               			user.currentRound = {};
               			gps.stopGpsTracker();
               			stopSmartWatch();
               			
               			user.refresh(function() {
               				finishroundmodal.hide();
							app.openHome();
							setTimeout(function() {
								myNavigator.pushPage('round.html', { round_id: currentRound.Round.id })
								if (post_score_external && $scope.gc_club) {
									myNavigator.pushPage('golfcanada.html', { 
											club_name: $scope.gc_club.value,
											gckey: $scope.gc_club.key,
											score: $scope.round.Round.score,
											score_date: $scope.round.Round.date
										});
								}
							}, 200);
							
						},
						function() { 
						
						});
               		}
               		else {
               			finishroundmodal.hide();
               		}
               },
               error: function(err) {
               		finishroundmodal.hide();

               			//error
               		navigator.notification.alert("We could not save your round at this time.  Please check your cellular connection or WiFi strength and try again.");
               }
            });
	};
	
});


offcourseApp.controller('SimplescoreController', function($scope) {
	$scope.round = {};
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	$scope.round = page.options.round_obj;

	user.currentRound = $scope.round;
	
	if ($scope.round.Round.holes == 0) {
		if ($scope.round.Tee.Hole.length > 0) {
			$scope.round.Round.holes = $scope.round.Tee.Hole.length;
		}
		else {
			$scope.round.Round.holes = 18;
		}
	}
	if ($scope.round.Round.score == 0) {
		$scope.round.Round.score = '';
	}

	$scope.openPlayMenu = function(showAnimation) {
		saveThisRound(function(savedRound) {
					$scope.round = savedRound;
					user.currentRound = $scope.round;
				});
				
		var menuOption = { round_obj: $scope.round };
		if (typeof(showAnimation) != 'undefined') {
			menuOption['animation'] = showAnimation;
		}
	
		myNavigator.pushPage('playmenu.html', menuOption);
		
	};


	var saveThisRound = function(onSuccess) {
			// make this work...
		var saveRoundData = {
			tk: user.tk, 
			uk: user.uk, 
			pk: user.pk,
			'Round': {
				'id': $scope.round.Round.id,
				'course_id': $scope.round.Course.id,
				'tee_id': $scope.round.Tee.id,
				'user_id': user.info.User.id,
				'date': $scope.round.Round.date,
				'gametype': $scope.round.Round.gametype,
				'scoringtype': $scope.round.Round.scoringtype,
				'score': pageElm.find('.simple-score-score').val(),
				'holes': pageElm.find('.simple-score-holes').val()
			},
			'User': user.info.User
		};
		
		
		$.ajax({
               url: APIHOST + '/users/apisaveround/',
               method: 'POST',
               data: saveRoundData,
               success: function(data) {
               		if (data.data && data.data.Round) {
               			var currentRound = data.data;
               			user.currentRound = currentRound;
               			onSuccess(currentRound);
               		}
               },
               error: function(err) {
               		//error
               }
            });
	
	};

	$scope.finishRound = function() {
		saveThisRound(function(savedRound) {
					$scope.round = savedRound;
					user.currentRound = $scope.round;
				});
				
		myNavigator.pushPage('finishround.html', { round_obj: $scope.round });
	};
	
	
	$scope.cancelRound = function() {
		app.openHome();
	};


});


offcourseApp.controller('PlayController', function($scope, $sce, $rootScope) {


	$scope.course_name = '';
	$scope.dUnits = dUnits(false);
	$scope.round = {};
	$scope.userrounds = [];
	$scope.holes = {};
	$scope.photos = [];
	$scope.friends = [];
	$scope.coursehistory = [];
	$scope.holetips ={};
	var currentGPS = [];
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	var round_id = page.options.round_id;
	var start_hole = page.options.start_hole;

	var course = {};
	if (page.options.course) {
		course = page.options.course;
	}
	var tee = {};
	if (page.options.tee) {
		tee = page.options.tee;
	}
	var scoringtype = {};
	if (page.options.scoringtype) {
		scoringtype = page.options.scoringtype;
	}
	var gametype = {};
	if (page.options.gametype) {
		gametype = page.options.gametype;
	}
	var date = {};
	if (page.options.date) {
		date = page.options.date;
	}

	if (typeof(start_hole) == 'undefined') {
		start_hole = 1;
	}

	$scope.friends = page.options.friends;

	setTimeout(function() {
		if (round_id == 0) {
				// we are potentially starting this one offline
				// So we need to create the round structure
			course.Course.Club = course.Club;

			round = {
				Activity: {},
				Course: course.Course,
				Friends: {},
				Gps: course.Gps,
				Holetips: course.Holetips,
				Honour: {},
				Playedhole: {},
				Round: {
					user_id: user.info.User.id,
					course_id: course.Course.id,
					tee_id: tee.id,
					date: date,
					scoringtype: scoringtype,
					gametype: gametype
				},
				Tee: tee,
				User: user.info.User
			};

			createScoring(round);
		}
		else {
			$.ajax({
			    url: APIHOST + '/users/apiround/' + round_id + '/',
			    method: 'GET',
			    data: {tk: user.tk, uk: user.uk, pk: user.pk},
			    success: function(data) {

					var round = data.data;
					
					if (typeof(round.Round) == 'undefined') {
						console.log(data);
						navigator.notification.alert('We ran into a problem starting this round.  Please try again.', function() { } , 'Round Problem', 'Dismiss');
						app.openHome();
						return false;
					}

					console.log(round);

					if (typeof(round.Tee.Hole) != 'undefined') {
						createScoring(round);
					}
					else {
							// something bad happened.  delete this round?
						round.Tee.Hole = {};
						createScoring(round);
					}
					

				}
			});
		}
	}, 1);
	
	
	var createScoring = function(round) {
		
			// this is a simple scoring round - redirect there.
		if (round.Round.scoringtype == 2) {
			myNavigator.resetToPage('simplescore.html', { round_obj: round });
			return;
		}
		
		if (round.Gps) {
			currentGPS = round.Gps;
		}
		
		var course_name = shorten(round.Course.name, 20);
		if (round.Course.Club.name == round.Course.name) {
			round.Course.name = '';
		}


		$.each(round.Tee.Hole, function(i, hole) {
			round.Tee.Hole[i].showFairway = (hole.par && hole.par == 3) ? false : true;
			round.Tee.Hole[i].Gps = (round.Gps && round.Gps[hole.number]) ? round.Gps[hole.number] : false ;
		});


		$.each(round.Holetips, function(i, holetip) {
			round.Holetips[i] = $sce.trustAsHtml(round.Holetips[i]);
		});
		
		$scope.$apply(function() {
			
			$scope.holetips = round.Holetips;
			$scope.course_name = course_name;
			$scope.showDetailedScoring = (round.Round.scoringtype == 1) ? false : true;
			$scope.round = round;			// the main round
			$scope.userrounds.push(round);	// the start of multiuser
			
			if (round.Friends) {
				$scope.friends = round.Friends;
				$.each(round.Friends, function(index, friendround) {
					if (friendround.Round.user_id == 0) {
						friendround.User.name = friendround.Round.golfername;
						friendround.User.avatar = getUserAvatar({});
					}
					$scope.userrounds.push(friendround);
				});
			}
			
			$scope.holes = round.Tee.Hole;

			if (typeof($scope.holetips[1]) == 'undefined') {
				$scope.holetips[1] = $sce.trustAsHtml('Touch the "<i class="fa fa-edit"></i> Score" button by your name to enter your score.  Then swipe your screen to the left and head to the next screen.');
			}

			if (typeof($scope.holetips[2]) == 'undefined') {
				$scope.holetips[2] = $sce.trustAsHtml('Touch the "GPS Distance" button in the top left to get an overhead view of the hole.');
			}

			if (typeof($scope.holetips[6]) == 'undefined') {
				$scope.holetips[6] = $sce.trustAsHtml('Remember this round with a photo.<br /><br />Touch the "<i class="fa fa-camera"></i> Take Photo" button and share the scenery, a tough lie, or a #selfie.');
			}

			if (typeof($scope.holetips[9]) == 'undefined') {
				$scope.holetips[9] = $sce.trustAsHtml("If you decide you aren't playing a whole round today you can touch \"Finish Round\" at any time.");
			}

			if (typeof($scope.holetips[13]) == 'undefined') {
				$scope.holetips[13] = $sce.trustAsHtml('Check out the options button "<i class="fa fa-navicon"></i>" on the top right of your screen.  You can change some round options and see who else is playing.');
			}

			if (typeof($scope.holetips[17]) == 'undefined') {
				$scope.holetips[17] = $sce.trustAsHtml('Remember to share your round on Facebook or Twitter when you are done. '+whitelabel.share_hash);
			}

		});

		playcarousel.refresh();	// ensure it doesn't miss the spacing at the top for iphone

		pageElm.find('.button-up').click(function() {
			var maxVal = 99;
			if ($(this).is('.button-putts')) {
				maxVal = parseInt($(this).parents('.play-card-user-scoring').find('.input-score-strokes').val());
			}
			var val = parseInt($(this).next('input').val());
			if (isNaN(val)) {
				val = 0;
			}
			if (val >= maxVal) {
				val = maxVal - 1;
			}
			$(this).next('input').val(val + 1);
			updateScoreDisplay();
		});
		pageElm.find('.button-down').click(function() {
			var val = parseInt($(this).prev('input').val());
			if (isNaN(val)) {
				val = 1;
			}
			if (val <= 0) {
				val = 1;
			}
			val = val - 1;
			$(this).prev('input').val(val);
			
			if ($(this).is('.button-score')) {
				var putts = parseInt($(this).parents('.play-card-user-scoring').find('.input-score-putts').val());
				if (putts > val) {
					$(this).parents('.play-card-user-scoring').find('.input-score-putts').val(val);
				}
			}
			
			updateScoreDisplay();
		});
		pageElm.find('.input-score-fairway-inner > div').click(function() {
			var fairway_val = '';
			var elm = $(this).parents('.input-score-fairway-container').find('.input-score-fairway');
			if ($(this).is('.input-score-fairway-left')) {
				fairway_val = -1;
			}
			if ($(this).is('.input-score-fairway-right')) {
				fairway_val = 1;
			}
			if ($(this).is('.input-score-fairway-center')) {
				fairway_val = 0;
			}
			$(elm).val(fairway_val);
			var fairwayelm = $(elm).parent('.input-score-fairway-container').find('.input-score-fairway-inner');
			setFairway(fairwayelm, fairway_val);
			
		});
		pageElm.find('.input-score-gir-inner > div').click(function() {
			var gir_val = '';
			var elm = $(this).parents('.input-score-gir-container').find('.input-score-gir');
			if ($(this).is('.input-score-gir-center')) {
				gir_val = 0;
			}
			if ($(this).is('.input-score-gir-top')) {
				gir_val = 1;
			}
			if ($(this).is('.input-score-gir-right')) {
				gir_val = 2;
			}
			if ($(this).is('.input-score-gir-bottom')) {
				gir_val = 3;
			}
			if ($(this).is('.input-score-gir-left')) {
				gir_val = 4;
			}
			elm.val(gir_val);

			var girelm = $(elm).parent('.input-score-gir-container').find('.input-score-gir-inner');
			setGir(girelm, gir_val);
			
		
		});
		
		
		setTimeout(function() {
				// Maximize the touchable area for entry
			var windowWidth = $(window).width();
			var girDims = windowWidth * 0.30;
			pageElm.find('.input-score-gir-container').css({
				width: girDims+'px',
				height: girDims+'px'
			});
			pageElm.find('.input-score-fairway-container').css({
				width: girDims+'px',
				height: girDims+'px'
			});
			var windowWidth = $(window).width();
			var btnDims = windowWidth * 0.155;
			var btnHDims = (girDims - pageElm.find('.input-score-putts').outerHeight()) / 2;
			pageElm.find('.play-hole .play-card-user-scoring button').css({
				width: btnDims+'px',
				height: btnHDims+'px'
			});
			var btnDims = btnDims - 2;
			pageElm.find('.play-card-user-scoring input').css({
				width: btnDims+'px'
			});


			var changedStartHole = false;
			var stopStartHoleTracking = false;
			
			$.each($scope.userrounds, function(index, userround) {
				var playedholes = {};

				$.each(userround.Playedhole, function(i, ph) {
					playedholes[ph.number] = ph;
				});
				
				pageElm.find('.play-hole').each(function() {
					var currentNumber = $(this).find('.play-hole-number').val();
			
					if (typeof(playedholes[currentNumber]) != 'undefined') {

						$(this).find('.round_index_'+index+' .play-hole-id').val(playedholes[currentNumber].id);
						$(this).find('.round_index_'+index+' .play-hole-played').val(1);
						$(this).find('.round_index_'+index+' .input-score-strokes').val(playedholes[currentNumber].score);
						$(this).find('.round_index_'+index+' .input-score-putts').val(playedholes[currentNumber].putts);
						$(this).find('.round_index_'+index+' .input-score-fairway').val(playedholes[currentNumber].fairway);
						$(this).find('.round_index_'+index+' .input-score-gir').val(playedholes[currentNumber].gir);
			
						var fairwayelm = $(this).find('.round_index_'+index+' .input-score-fairway-container').find('.input-score-fairway-inner');
						setFairway(fairwayelm, playedholes[currentNumber].fairway);
			
						var girelm = $(this).find('.round_index_'+index+' .input-score-gir-container').find('.input-score-gir-inner');
						setGir(girelm, playedholes[currentNumber].gir);
			
						$(this).find('.round_index_'+index+' .input-score-sand').prop('checked', playedholes[currentNumber].sand);
						$(this).find('.round_index_'+index+' .input-score-penalty').prop('checked', playedholes[currentNumber].penalty);
			
						$(this).find('.round_index_'+index+' .score-entry-btn').hide();
						if (index == 0) {
							$(this).find('.round_index_'+index+' .score-entry').show();
						}
						if (!stopStartHoleTracking) {
							start_hole = currentNumber;
							changedStartHole = true;
						}
					}
					else {
						if (changedStartHole) {
							stopStartHoleTracking = true;
						}
					}
				
				});
			});
			
			updateScoreDisplay();
			updateGreenDistance();
			
			
				// do the following to ensure vertical scroll on score entry.
			playcarousel._hammer.off('dragup dragdown swipeup swipedown');
			playcarousel._hammer.on('dragup dragdown', function() {
				return true;
			});
			
			
			
			playcarousel.setActiveCarouselItemIndex(start_hole - 1);
			
				// lets check the top gap of th carousel.  ios has a problem sometimes
			setTimeout(function() {
				var topSpace = pageElm.find('ons-toolbar').outerHeight();
				pageElm.find('.page__content').css('top', topSpace + 'px');
			}, 50);
			
			setTimeout(function() {
				var h = parseInt($(window).height()) - (parseInt(pageElm.find('.navigation-bar').outerHeight()) + parseInt(pageElm.find('.play-card:visible').outerHeight()) + parseInt(pageElm.find('.play-card-hole-info:visible').outerHeight()) + parseInt(pageElm.find('.tab-bar').outerHeight()));
				$('.play-scroller').height(h);
			}, 100);

			setTimeout(function() {
				
				var relaunchTried = 5;
				function launchSmartWatchApp() {
					launchSmartWatch(function() {
						setTimeout(function() {
							//loadSmartWatchHoles(round, function() {
								//changeSmartWatchHole(start_hole);
								changeSmartWatchHole($scope.round.Tee.Hole[start_hole - 1]);
							//});
						}, 200); 
					}, function() {
						if (relaunchTried > 0) {
							relaunchTried--;
							setTimeout(function() {
								launchSmartWatchApp();
							}, 800);
						}
						console.log('******* could not launch pebble app');
					});
				}
				launchSmartWatchApp();
			}, 400);
			
		}, 10);
		
		user.currentRound = $scope.round;
		
		
		
		setTimeout(function() {
			$.ajax({
				   url: APIHOST + '/users/apirounds/'+user.info.User.username+'/course_id:'+$scope.round.Round.course_id+'/holes:1/limit:10/',
				   method: 'GET',
				   data: {tk: user.tk, uk: user.uk, pk: user.pk},
				   success: function(data) {
				   		$scope.$apply(function() {
							if (data.data.length > 0) {
								$scope.coursehistory = data.data;
							}
							else {
								$scope.coursehistory = [];
							} 
						});      	
				   }
				});
			
		}, 3000);
		

		setTimeout(function() {
			if (!window.localStorage['playpopover'] && $scope.round.Round.score == 0) {
				window.localStorage['playpopover'] = 1;
				ons.createPopover('playpopover.html')
					.then(function(popover) {
						popover.show(
							pageElm.find('.score-entry-btn')[0],
							{

							}
						);
						popover.on('posthide', function() {
							makePopover2();
						});
				});
				function makePopover2() {
					ons.createPopover('playpopover2.html')
						.then(function(popover) {
							popover.show(
								pageElm.find('.gps-distance-label')[0],
								{

								}
							);
							popover.on('posthide', function() {
								makePopover3();
							});
					});
				}
				function makePopover3() {
					ons.createPopover('playpopover3.html')
						.then(function(popover) {
							popover.show(
								pageElm.find('.photo-upload-label')[0],
								{

								}
							);
							popover.on('posthide', function() {
								
							});
					});
				}
			}
		}, 1000);
	}


	var saveThisRound = function(onSuccess) {
		var playedholes = collectScoring(0, $scope.round, $scope.round.Round.id, $scope.round.Round.status);
	
		
		$.each($scope.friends, function(index, friend) {
			var play_index = index + 1;	// main user is first
			var f_playedholes = collectScoring(play_index, friend, friend.Round.id, $scope.round.Round.status);
			$scope.friends[index]['Playedholes'] = f_playedholes;
			$scope.friends[index]['Round']['score'] = getCurrentScore(play_index);
			$scope.friends[index]['Round']['holes'] = f_playedholes.length;
		});
	
		var saveRoundData = {
			tk: user.tk, 
			uk: user.uk, 
			pk: user.pk,
			'Round': {
				'id': $scope.round.Round.id,
				'course_id': $scope.round.Course.id,
				'tee_id': $scope.round.Tee.id,
				'user_id': user.info.User.id,
				'date': $scope.round.Round.date,
				'gametype': $scope.round.Round.gametype,
				'scoringtype': $scope.round.Round.scoringtype,
				'score': getCurrentScore(0),
				'holes': playedholes.length
			},
			'User': user.info.User,
			'Playedholes': playedholes,
			'Friends': $scope.friends
		};
		
           		// Save the round to localStorage.  Then try again later
       	window.localStorage['savedRound'] = JSON.stringify(saveRoundData);
		
		$.ajax({
               url: APIHOST + '/users/apisaveround/',
               method: 'POST',
               data: saveRoundData,
               success: function(data) {
               		if (data.data && data.data.Round) {
               			var currentRound = data.data;
               			user.currentRound = currentRound;
               			
               			$scope.round = currentRound;			// the main round
               			$scope.userrounds = [];
						$scope.userrounds.push(currentRound);	// the start of multiuser
					
						if (currentRound.Friends) {
							$scope.friends = currentRound.Friends;
							$.each(currentRound.Friends, function(index, friendround) {
								if (friendround.Round.user_id == 0) {
									friendround.User.name = friendround.Round.golfername;
									friendround.User.avatar = getUserAvatar({});
								}
								$scope.userrounds.push(friendround);
							});
						}
						
							// ensure hole ids are in sync
						$.each($scope.userrounds, function(index, userround) {
							$.each(userround.Playedhole, function(i, ph) {
								playedholes[ph.number] = ph;
							});
							pageElm.find('.play-hole').each(function() {
								var currentNumber = $(this).find('.play-hole-number').val();
					
								if (typeof(playedholes[currentNumber]) != 'undefined') {
									$(this).find('.round_index_'+index+' .play-hole-id').val(playedholes[currentNumber].id);
								}
							});
						});
               			
               			window.localStorage['savedRound'] = '';
               			onSuccess(currentRound);
               		}
               },
               error: function(err) {
               		// error saving - perhaps there was a network problem or something
               		// We still need to do a few things here to be safe.

               }
            });
	
	};
	
	
	
	$scope.takePhoto = function() {
		
		photo.upload('photo', 
					APIHOST + '/users/apieditphoto/', 
					{ round_id: $scope.round.Round.id, comment: '' },
					function(photoURI, progress) {
							//progress
						pageElm.find(".photo-upload-label").html('Saving '+progress+'% <i class="fa fa-circle-o-notch fa-spin"></i>');
						
					}, 
					function() {
							// Done well
						pageElm.find(".photo-upload-label").html('Take Photo');
						
					}, 
					function() {
							//error
						navigator.notification.alert('We ran into a problem uploading your photo.  Please try again.', function() {} , 'Photo Problem', 'Dismiss');
						pageElm.find(".photo-upload-label").html('Take Photo');
						
					});
		
	};
	
	
	
	updateScoreDisplay = function() {
		setTimeout(function() {
			$.each($scope.userrounds, function(index, round) {
				current_score = getCurrentScore(index);
				pageElm.find('.round_index_'+index+' .current_score').html(current_score);
			});
		}, 1);
	}
	
	$scope.enterScore = function(holenumber, index) {
		if ($scope.userrounds.length > 1) {
			pageElm.find('.round_indexes .score-entry-'+holenumber).not('.round_index_'+index+' .score-entry-'+holenumber).slideUp();
		
			pageElm.find('.round_index_'+index+' .score-entry-'+holenumber).slideToggle();
		}
		else {
			pageElm.find('.round_index_'+index+' .score-entry-'+holenumber).slideDown();		
		}
		
		pageElm.find('.round_index_'+index+' .score-entry-btn-'+holenumber).hide();
		pageElm.find('.round_index_'+index+' .play-hole-played-'+holenumber).val(1);

		updateScoreDisplay();
	};
	
	$scope.resetHole = function(holenumber) {

		pageElm.find('.score-entry-'+holenumber).hide();
		pageElm.find('.score-entry-btn-'+holenumber).show();
		pageElm.find('.play-hole-played-'+holenumber).val(0);
		clearFairway(pageElm.find('.play-hole-'+holenumber).find('.input-score-fairway-container .input-score-fairway-inner'));
		clearGir(pageElm.find('.play-hole-'+holenumber).find('.input-score-gir-container .input-score-gir-inner'));

		updateScoreDisplay();
	};
	
	$scope.openPlayMenu = function(showAnimation) {
				
		var menuOption = { round_obj: $scope.round };
		if (typeof(showAnimation) != 'undefined') {
			menuOption['animation'] = showAnimation;
		}
		
		myNavigator.pushPage('playmenu.html', menuOption);

		saveThisRound(function(savedRound) {
					$scope.round = savedRound;
					$scope.round.Gps = currentGPS;
					user.currentRound = $scope.round;
				});
		
	};


	$scope.finishRound = function() {		
		myNavigator.pushPage('finishround.html', { round_obj: $scope.round });

		saveThisRound(function(savedRound) {
					$scope.round = savedRound;
					$scope.round.Gps = currentGPS;
					user.currentRound = $scope.round;
				});

	}


	
	$scope.nextHole = function() {
		nextHole();
	};
	$scope.prevHole = function() {
		prevHole();
	};
	
	
	
	$scope.showYardage = function(hole) {
		if (typeof(hole.Gps) != 'undefined' && typeof(hole.Gps.hole) != 'undefined') {
			myNavigator.pushPage('yardage.html', { yardage: hole.Gps });
		}
	};
	
	
	setTimeout(function() {
		playcarousel.on('postchange', function(event) {
			var hole_count = $scope.round.Tee.Hole.length;
			var hole_index = playcarousel.getActiveCarouselItemIndex();
			var hole_number = 1 + parseInt(hole_index);
			
			for(var i = 1; i <= hole_count; i++) {
				if (i == hole_number || i == hole_number - 1 || i == hole_number + 1) {
					pageElm.find('.play-hole-'+i+' .toggle-visible').show();
				}
				else {
					pageElm.find('.play-hole-'+i+' .toggle-visible').hide();
				}
			}
			
			// Save stuff now.
			setTimeout(function() {
				updateScoreDisplay();
				displayGreenDistance(user.cachedLat, user.cachedLng, user.cachedAccuracy);
				//changeSmartWatchHole(parseInt(playcarousel.getActiveCarouselItemIndex()) + 1);
				changeSmartWatchHole($scope.round.Tee.Hole[hole_index]);
				saveThisRound(function(savedRound) {
					$scope.round = savedRound;
					$scope.round.Gps = currentGPS;
					user.currentRound = $scope.round;
				});
			}, 100);
			
		});
		playcarousel.on('overscroll', function(event) {
			var doChange = false;
			if (playcarousel.getActiveCarouselItemIndex() == 0) {
				if ($('.play-hole-1').offset().left > 20) {
					doChange = true;
				}
			}
			else {
				var last_hole = $scope.round.Tee.Hole.length;
				if ($('.play-hole-'+last_hole).offset().left < -20) {
					doChange = true;
				}
			}
			if (doChange) {
				if (event.direction == 'right') {
					playcarousel.first();
				}
				if (event.direction == 'left') {
					playcarousel.last();
				}
			}
		});
	},200);
	
	
	
	
	var prevYardage = 0;
	var prevAcc = 0;
	var currentHole = 0;
	var currentHoleElm = {};
	var green_lat = 0;
	var green_lng = 0;	
	var displayGreenDistance = function(lat, lng, accuracy) {
				
		currentHoleNumber = playcarousel.getActiveCarouselItemIndex() + 1;
		currentHole = $scope.round.Tee.Hole[currentHoleNumber - 1];

		if (typeof($scope.round.Gps) == 'undefined' || typeof($scope.round.Gps[currentHoleNumber]) == 'undefined') {
			return;
		}
		
		green_lat = $scope.round.Gps[currentHoleNumber].lat;
		green_lng = $scope.round.Gps[currentHoleNumber].lng;
	
		var currentYardage = calcDistance({latitude: lat, longitude: lng}, {latitude: green_lat, longitude: green_lng});
				
		currentYardage = currentYardage.toFixed(0);
		if (prevYardage != currentYardage || prevAcc != accuracy) {
			prevYardage = currentYardage;
			prevAcc = accuracy;
			
			currentYardageText = currentYardage + dUnits();
			
			if (user.isMetric) {
				var accuracyText = '+/- ' + Math.round(accuracy) + 'm';
			}
			else {
				var accuracyText = '+/- ' + Math.round(metersToYards(accuracy)) + 'yds';
			}
			
			var accuracyClass = 'unknown';
			if (parseInt(accuracy) < 6) {
				accuracyClass = 'good';
			}
			else if (parseInt(accuracy) >= 6 && parseInt(accuracy) < 11) {
				accuracyClass = 'fair';
			}
			else {
				accuracyClass = 'poor';
			}
	
			if (currentYardage > 999) {
				pageElm.find('.gps-distance').html('<span class="too-far-away">Far</span>');
				changeSmartWatchDistance('Far', accuracyText, currentHole);
			}
			else {
				pageElm.find('.gps-distance').html('<span class="accuracy-'+accuracyClass+'">'+currentYardageText+'<span>');
				changeSmartWatchDistance(currentYardageText, accuracyText, currentHole);
			}
			
		}
		
		if (pageElm.find('.gps-distance').length == 0) {
			stopGreenDistance();
		}
			
	}
	
	
	var clearDistanceTimeout = false;
	var updateGreenDistance = function() {
		
		stopGreenDistance();
		
		displayGreenDistance(user.cachedLat, user.cachedLng, user.cachedAccuracy);
				
		gps.addGPSListener('updateGreenDistance', function(lat, lng, accuracy) {
			user.cachedLat = lat;
			user.cachedLng = lng;
			user.cachedAccuracy = accuracy;
			displayGreenDistance(lat, lng, accuracy);
		});
		
		
	};
	var stopGreenDistance = function() {
		gps.removeGPSListener('updateGreenDistance');
	};
	
	
	$scope.handleBackButton = function() {
		// do nothing
		return false;
	}
	
	
	$scope.fullScorecard = function() {
		myNavigator.pushPage('scorecard.html', { round: $scope.round });
	}
	
	
	$scope.showHistory = function(holenumber) {
		myNavigator.pushPage('holehistory.html', { round: $scope.round, coursehistory: $scope.coursehistory, holenumber: holenumber });
	}
	
	
	gps.startGpsTracker();
	

  	var roundUpdate = $rootScope.$on('roundUpdate', function(ev, round) {
  			// sync what might have changed in the menu updates
  		$scope.round.Competition = round.Competition;
  		$scope.round.Round.date = round.Round.date;
  		$scope.round.Round.gametype = round.Round.gametype;
  	});
  	$scope.$on('$destroy', roundUpdate);


});

nextHole = function() {
	var holeCount = user.currentRound.Tee.Hole.length;
	if (playcarousel.getActiveCarouselItemIndex() == holeCount - 1) {
		playcarousel.first();
	}
	else {
		playcarousel.next();
	}
};
prevHole = function() {
	if (playcarousel.getActiveCarouselItemIndex() == 0) {
		playcarousel.last();
	}
	else {
		playcarousel.prev();
	}
};


function setFairway(fairwayelm, fairway_val) {
	fairwayelm.removeClass('input-score-fairway-hitleft');
	fairwayelm.removeClass('input-score-fairway-hitright');
	fairwayelm.removeClass('input-score-fairway-hitcenter');

	if (fairway_val !== '') {
		if (fairway_val < 0) {
			fairwayelm.addClass('input-score-fairway-hitleft');
		}
		if (fairway_val > 0) {
			fairwayelm.addClass('input-score-fairway-hitright');
		}
		if (fairway_val == 0) {
			fairwayelm.addClass('input-score-fairway-hitcenter');
		}
	}
}
function clearFairway(fairwayelm) {
	fairwayelm.removeClass('input-score-fairway-hitleft');
	fairwayelm.removeClass('input-score-fairway-hitright');
	fairwayelm.removeClass('input-score-fairway-hitcenter');
}
function setGir(girelm, gir_val) {
	girelm.find('div').removeClass('gir-active');
	
	if (gir_val !== '') {
		if (gir_val == 0) {
			girelm.find('.input-score-gir-center').addClass('gir-active');
		}
		if (gir_val == 1) {
			girelm.find('.input-score-gir-top').addClass('gir-active');
		}
		if (gir_val == 2) {
			girelm.find('.input-score-gir-right').addClass('gir-active');
		}
		if (gir_val == 3) {
			girelm.find('.input-score-gir-bottom').addClass('gir-active');
		}
		if (gir_val == 4) {
			girelm.find('.input-score-gir-left').addClass('gir-active');
		}
	}
}
function clearGir(girelm) {
	girelm.find('div').removeClass('gir-active');
}

function getGolfCanadaInfo(club_slug, callback) {
	$.ajax({
				url: APIHOST + '/courses/apiclubdetails/'+club_slug+'/simple:1/',
				method: 'GET',
				cache: false,
				data: { },
				success: function(data) {
					console.log(data);
					var gc_club = false;
					if (data.data) {
						if (data.data.Golfcanadaclub.data) {
							var gc_club = data.data.Golfcanadaclub.data;

						}
					}
					callback(gc_club);
				},
				error: function() {
					callback(false);
				}
			});
}



offcourseApp.controller('YardageController', function($scope) {
	$scope.yardageTitle = '';

	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	var yardageInfo = page.options.yardage;
	
	var prevYardage = 0;
	var prevAccuracy = 100;
	var zoomChanged = false;
	var mapRunning = false;
	var touchMarker = false;
	var golferMarker = false;
	var yards_container = {};
	var yardage_accuracy = {};
	
	$scope.yardageTitle = 'Hole ' + yardageInfo.hole;
	

	setTimeout(function() {
		var contHeight = pageElm.find('.map-container').height();
		var mapHeight = contHeight - 52;
		pageElm.find('#map-canvas').height(mapHeight);

		yards_container = pageElm.find('.yards-to-hole');
		yardage_accuracy = pageElm.find('.yardage-accuracy');

	}, 50); 
	
	$scope.stopListeners = function() {
		if (isBB || isWeb || useWebMap) {
			gps.removeGPSListener('yardage');
			if (typeof(golferMarker) != 'undefined' && golferMarker != false) {
				golferMarker.setMap(null);
			}
			golferMarker = false;
		}
		else {
			$('.playholes').show();
	
			gps.removeGPSListener('yardage');
			gps.yardageMap.clear();
			gps.yardageMap.setVisible(false);
			
			gps.yardageMap.remove();
			$('#map-canvas').remove();
			console.log('All map stuff turned off and removed');
		}
	}
	
	
	if (isBB || isWeb || useWebMap || (typeof(plugin) == 'undefined' && typeof(plugin.google) == 'undefined')) {
				// Use web plugin	
		var arrangeMap = function(lat, lng, accuracy) {
			
			user.cachedLat = lat;
			user.cachedLng = lng;
			user.cachedAccuracy = accuracy;
				
			if (golferMarker == false) {
				golferMarker = new google.maps.Marker({
					position: new google.maps.LatLng(lat, lng),
					map: gps.yardageMap,
					icon: {
					  path: google.maps.SymbolPath.CIRCLE,
					  scale: 4,
					  fillColor: "red",
					  strokeColor: "red",
					  fillOpacity: 0.4,
					  strokeOpacity: 0.7
					}
				  });
			}
			else {
				golferMarker.setPosition(new google.maps.LatLng(lat, lng));
			}
			  
				// success - should trigger every second or so
			var currentYardage = calcDistance({latitude: lat, longitude: lng}, {latitude: yardageInfo.lat, longitude: yardageInfo.lng});
			currentYardage = currentYardage.toFixed(0);
			if (prevYardage != currentYardage) {
				prevYardage = currentYardage;
				yards_container.html(currentYardage + ' '+dUnits());
			}


			if (prevAccuracy != accuracy) {
				prevAccuracy = accuracy;
				if (user.isMetric) {
					var display_acc = Math.round(accuracy) + 'm';
				}
				else {
					var display_acc = Math.round(metersToYards(accuracy)) + 'yds';
				}
				if (accuracy < 6) {
					yardage_accuracy.html('Good GPS +/- '+display_acc);
					yardage_accuracy.removeClass('poor');
					yardage_accuracy.removeClass('med');
					yardage_accuracy.addClass('good');
				}
				else if (accuracy < 11) {
					yardage_accuracy.html('Fair GPS +/- '+display_acc);
					yardage_accuracy.removeClass('poor');
					yardage_accuracy.addClass('med');
					yardage_accuracy.removeClass('good');
				}
				else {
					yardage_accuracy.html('Poor GPS +/- '+display_acc);
					yardage_accuracy.addClass('poor');
					yardage_accuracy.removeClass('med');
					yardage_accuracy.removeClass('good');
				}
			}

	
			if (!zoomChanged && mapRunning && currentYardage < 900) {
	
					// If you are close to the green then change the view and rotate
				var bearing = calcBearing({latitude: lat, longitude: lng}, {latitude: yardageInfo.lat, longitude: yardageInfo.lng});
	
					// change the center to somewhere between you and the hole
				zoomChanged = true;
				var mapZoom = 18 - yardsToMeters(currentYardage) / 500;	// todo - make a good zoom
				var midLat = parseFloat(yardageInfo.lat) - ( parseFloat(yardageInfo.lat) - parseFloat(lat) ) / 2;
				var midLng = parseFloat(yardageInfo.lng) - ( parseFloat(yardageInfo.lng) - parseFloat(lng) ) / 2;


				bearing = Math.round(bearing);
				gps.yardageMap.setHeading(bearing);
									
				var bounds = new google.maps.LatLngBounds();
				bounds.extend(new google.maps.LatLng(lat, lng));
				bounds.extend(new google.maps.LatLng(yardageInfo.lat, yardageInfo.lng));
				gps.yardageMap.fitBounds(bounds);

					
			}		
		}
	
		setTimeout(function() {
			var mapOptions = {
			  center: new google.maps.LatLng(yardageInfo.lat, yardageInfo.lng),
			  zoom: 18,
			  mapTypeId: google.maps.MapTypeId.SATELLITE,
			  heading: 90
			};
	
			gps.yardageMap = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);
			
			var holeMarker = new google.maps.Marker({
				position: new google.maps.LatLng(yardageInfo.lat, yardageInfo.lng),
				map: gps.yardageMap
			  });
		  
			google.maps.event.addListener(gps.yardageMap, 'click', function(ev) {
				var latLng = {
					lat: ev.latLng.lat(), 
					lng: ev.latLng.lng()
				};

				if (touchMarker != false) {
					touchMarker.setMap(null);
				}
	
				var currentYardage = calcDistance({latitude: user.cachedLat, longitude: user.cachedLng}, {latitude: latLng.lat, longitude: latLng.lng});
				currentYardage = currentYardage.toFixed(0);
		
				var currentToGreen = calcDistance({latitude: latLng.lat, longitude: latLng.lng}, {latitude: yardageInfo.lat, longitude: yardageInfo.lng});
				currentToGreen = currentToGreen.toFixed(0);
		
				var contentString = 'To You: '+ currentYardage + '' + dUnits() + '<br />To Green: '+ currentToGreen + '' + dUnits();
				touchMarker = new google.maps.Marker({
						map: gps.yardageMap,
						position: latLng,
						title: 'To You: '+ currentYardage + '' + dUnits() + '<br />To Green: '+ currentToGreen + '' + dUnits()
					});
				infowindow = new google.maps.InfoWindow({
					  content: contentString
				  });
				infowindow.open(gps.yardageMap, touchMarker);
			
			  });
		  
	
		  
			mapRunning = true;		

			arrangeMap(user.cachedLat, user.cachedLng, user.cachedAccuracy);
			
			gps.addGPSListener('yardage', function(lat, lng, accuracy) {
					arrangeMap(lat, lng, accuracy);
				});
			
		},100);
	
	
	
		
		
	
	}
	else {
			// Use special google map plugin
		var holePosition = new plugin.google.maps.LatLng(yardageInfo.lat, yardageInfo.lng);


		function arrangeMap(lat, lng, accuracy) {
			
			user.cachedLat = lat;
			user.cachedLng = lng;
			user.cachedAccuracy = accuracy;
				
				// success - should trigger every second or so
			var currentYardage = calcDistance({latitude: lat, longitude: lng}, {latitude: yardageInfo.lat, longitude: yardageInfo.lng});
			currentYardage = currentYardage.toFixed(0);
			if (prevYardage != currentYardage) {
				prevYardage = currentYardage;
				yards_container.html(currentYardage + ' '+dUnits());
			}
			
			if (prevAccuracy != accuracy) {
				prevAccuracy = accuracy;
				if (user.isMetric) {
					var display_acc = Math.round(accuracy) + 'm';
				}
				else {
					var display_acc = Math.round(metersToYards(accuracy)) + 'yds';
				}
				if (accuracy < 5) {
					yardage_accuracy.html('Good GPS +/- '+display_acc);
					yardage_accuracy.removeClass('poor');
					yardage_accuracy.removeClass('med');
					yardage_accuracy.addClass('good');
				}
				else if (accuracy < 10) {
					yardage_accuracy.html('Fair GPS +/- '+display_acc);
					yardage_accuracy.removeClass('poor');
					yardage_accuracy.addClass('med');
					yardage_accuracy.removeClass('good');
				}
				else {
					yardage_accuracy.html('Poor GPS +/- '+display_acc);
					yardage_accuracy.addClass('poor');
					yardage_accuracy.removeClass('med');
					yardage_accuracy.removeClass('good');
				}
			}
	
			if (!zoomChanged && mapRunning && currentYardage < 900) {
	
					// If you are close to the green then change the view and rotate
				var bearing = calcBearing({latitude: lat, longitude: lng}, {latitude: yardageInfo.lat, longitude: yardageInfo.lng});
	
					// change the center to somewhere between you and the hole
				zoomChanged = true;
				var mapZoom = 18 - yardsToMeters(currentYardage) / 500;	// todo - make a good zoom
				var midLat = parseFloat(yardageInfo.lat) - ( parseFloat(yardageInfo.lat) - parseFloat(lat) ) / 2;
				var midLng = parseFloat(yardageInfo.lng) - ( parseFloat(yardageInfo.lng) - parseFloat(lng) ) / 2;

				var mapPosition = new plugin.google.maps.LatLng(midLat, midLng);
						
				gps.yardageMap.moveCamera({
				  target: [ 
					new plugin.google.maps.LatLng(yardageInfo.lat, yardageInfo.lng), 
					new plugin.google.maps.LatLng(lat, lng)
				  ],
				  'tilt': 0,
				  'zoom': mapZoom.toFixed(1),
				  'bearing': bearing
				});
			
				gps.yardageMap.animateCamera({
				//  'target': mapPosition,
				  'tilt': 0,
				  'zoom': mapZoom.toFixed(1),
				  'bearing': bearing,
				  'duration': 500
				}); 
			
			
			}		
		}
		function initMap(holePosition) {

			console.log('initMap ', holePosition);

			var latLng = new plugin.google.maps.LatLng(user.cachedLat, user.cachedLng);
					
			gps.yardageMap.setMapTypeId(plugin.google.maps.MapTypeId.SATELLITE);

			gps.yardageMap.setVisible(true);
			gps.yardageMap.setMyLocationEnabled(true);
			


				// Move where the hole is
			gps.yardageMap.moveCamera({
			  'target': holePosition,
			  'tilt': 0,
			  'zoom': 17,
			  'bearing': 0
			});

			gps.yardageMap.addMarker({
					'position': holePosition
				});

			gps.yardageMap.addEventListener(plugin.google.maps.event.MAP_CLICK, function(latLng) {
	
				console.log('MAP CLICKED ', latLng);


				if (touchMarker != false) {
					touchMarker.remove();
				}

				var currentYardage = calcDistance({latitude: user.cachedLat, longitude: user.cachedLng}, {latitude: latLng.lat, longitude: latLng.lng});
				currentYardage = currentYardage.toFixed(0);

				var currentToGreen = calcDistance({latitude: latLng.lat, longitude: latLng.lng}, {latitude: yardageInfo.lat, longitude: yardageInfo.lng});
				currentToGreen = currentToGreen.toFixed(0);

			
				gps.yardageMap.addMarker({
						'position': latLng,
						'title' : 'To You: '+ currentYardage + '' + dUnits() + '\nTo Green: '+ currentToGreen + '' + dUnits()
					}, function(marker) {
						touchMarker = marker;
						marker.showInfoWindow();
					});
		
			});
			console.log('CLick Handler should be added ');

			mapRunning = true;

			setTimeout(function() {
				arrangeMap(user.cachedLat, user.cachedLng, user.cachedAccuracy);
				gps.addGPSListener('yardage', function(lat, lng, accuracy) {
					arrangeMap(lat, lng, accuracy);
				}); 
			}, 100);
			
			
		}


		setTimeout(function() {
			
			
			var mapDiv = document.getElementById('map-canvas');
			if (mapDiv == null) {
				console.log('MAP ELEMENT DOES NOT EXIST YET');
			}
			
			
			gps.yardageMap = plugin.google.maps.Map.getMap(mapDiv, {
					'backgroundColor': '#FFFFFF',
					'mapType': plugin.google.maps.MapTypeId.SATELLITE
			});
			
			
			gps.yardageMap.addEventListener(plugin.google.maps.event.MAP_READY, function(yardageMap) {
				
				console.log('MAP READY ', gps.yardageMap);

				//gps.yardageMap = yardageMap;
				gps.yardageMapInit = true;
				setTimeout(function() {
					$('.yardage_page').find('.page__background').css({ 'background-color' : 'rgba(0,0,0,0)'});
					initMap(holePosition);
					$('.yardage_page').find('.page__background').css({ 'background-color' : 'rgba(0,0,0,0)'});
						// Need to set background after map is changed for some reason.
				}, 5);
			});
			
		/*	gps.yardageMap.setOptions({
					'backgroundColor': '#FFFFFF'
			}); */

			
		/*	
			setTimeout(function() {
			
			
				if (!gps.yardageMapInit) {
					gps.yardageMap.addEventListener(plugin.google.maps.event.MAP_READY, function(yardageMap) {

						gps.yardageMap = yardageMap;
						gps.yardageMapInit = true;

						setTimeout(function() {
							console.log('=========== yep ============');
							initMap(holePosition);
							console.log('=========== yep AFTER ============');
						}, 150);	
					});
				}
				else {
					setTimeout(function() {
						console.log('=========== yep2 ============');
						initMap(holePosition);
						console.log('=========== yep2 AFTER ============');
					}, 150);	
				}	*/

					// lots of timeouts to work coreectly
		/*		setTimeout(function() {
					arrangeMap(user.cachedLat, user.cachedLng, user.cachedAccuracy);
					gps.addGPSListener('yardage', function(lat, lng, accuracy) {
						arrangeMap(lat, lng, accuracy);
					});
				}, 300); */
		//	}, 50);
		
		}, 600);
		
	}
	
	
	
	

});




offcourseApp.controller('PlaymenuController', function($scope, $rootScope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	$scope.round = page.options.round_obj;
	$scope.photos = [];
	$scope.golfers = [];
	$scope.pebbleConnected = false;
	$scope.enableWearables = app.caps.wearables;

	if (typeof($scope.round.Competition) == 'undefined') {
		$scope.round.Competition = [];
	}	
	
	setTimeout(function() {
		pageElm.find('.round-type').html('Type: ' + gameTypesShort[$scope.round.Round.gametype]);
	}, 10);

	$scope.finishRound = function() {
		myNavigator.pushPage('finishround.html', { round_obj: $scope.round });
	}
	
	$scope.pauseRound = function() {
		gps.stopGpsTracker();
		stopSmartWatch();
		app.openHome();
	}
	
	if(enableSmartWatch && app.caps.wearables) {
		connectPebble(function(connected) {
			if (connected) {
				$scope.pebbleConnected = true;
			}
			else {
				$scope.pebbleConnected = false;
			}
		},
		function() {
			$scope.pebbleConnected = false;
		});
	}
	
	
	$scope.deleteRound = function() {
		var btnActions = function(buttonIndex) {	
			if (buttonIndex == 1) {
				data = { id: $scope.round.Round.id }
  		
				data.tk = user.tk;
				data.uk = user.uk;
				data.pk = user.pk;
		
				loadingmodal.show();

				$.ajax({
					   url: APIHOST + '/users/apideleteround/',
					   method: 'POST',
					   data: data,
					   success: function(data) {
					   		loadingmodal.hide();
					   		user.currentRound = {};
					   		app.roundInProgress = false;
							app.openHome();
							gps.stopGpsTracker();
							stopSmartWatch();
					   },
					   error: function(err) {
					   		loadingmodal.hide();
					   		user.currentRound = {};
					   		app.roundInProgress = false;
							app.openHome();
							gps.stopGpsTracker();
							stopSmartWatch();
					   }
					});	

			}
		};
		var options = {
			'title': 'Delete This Round?',
			'buttonLabels': [
				'Yes, Delete Round'
			]
		};
		showActionSheet(options, btnActions);
	}


	$scope.loadFoodMenu = function() {
		openCustomLink(whitelabel.play_menu_food.url);
	}

	$scope.addGolfer = function() {
		myNavigator.pushPage('addfriend.html', { round: $scope.round});
	}

	$scope.changeDate = function() {
		pickRoundDate($scope.round.Round.date, function(date) {
			$scope.round.Round.date = toApiDate(date);
			
			saveThisRound(function() {
				$rootScope.$emit("roundUpdate", $scope.round);
			});

		});
		
	}


	$scope.changeRoundType = function() {
		var btnActions = function(buttonIndex) {
			if (buttonIndex > 0) {	
				if (typeof(labelIndexes[buttonIndex - 1]) != 'undefined') {
			
					$scope.round.Round.gametype = buttonIndex - 1;
					$rootScope.$emit("roundUpdate", $scope.round);
				
					pageElm.find('.round-type').html('Saving...');
					saveThisRound(function() {
						pageElm.find('.round-type').html('Type: ' + gameTypesShort[$scope.round.Round.gametype]);
					});
				}
			}
		};
		
		var labels = [];
		var labelIndexes = [];
		$.each(gameTypes, function(index, value) {
				labels.push(value);
				labelIndexes.push(index);
		});
		var options = {
			'title': 'Change Your Round Scoring',
			'buttonLabels': labels
		};
		showActionSheet(options, btnActions);
	
	}


	$scope.changePowerSaving = function() {
		var btnActions = function(buttonIndex) {
			if (buttonIndex > 0) {	
				if (typeof(labels[buttonIndex - 1]) != 'undefined') {
			
					if(buttonIndex == 2) {
						setPowerSaveMode(false);
						powerLabel = 'Power Saving Off';
					}
					else {
						setPowerSaveMode(true);
						powerLabel = 'Power Saving On';
					}
					
					pageElm.find('.powersaving-type').html(powerLabel);
					
				}
			}
		};
		
		var labels = [
			'Power Saving On (Slower GPS)',
			'Power Saving Off'
		];		
		var options = {
			'title': 'Adjust the Power Saving',
			'buttonLabels': labels
		};
		showActionSheet(options, btnActions);
	}
	if(isPowerSaveMode()) {
		pageElm.find('.powersaving-type').html('Power Saving On');
	}



	var saveThisRound = function(onSuccess) {
		
		var saveRoundData = {
			tk: user.tk, 
			uk: user.uk, 
			pk: user.pk,
			'Round': {
				'id': $scope.round.Round.id,
				'course_id': $scope.round.Course.id,
				'tee_id': $scope.round.Tee.id,
				'user_id': user.info.User.id,
				'date': $scope.round.Round.date,
				'gametype': $scope.round.Round.gametype,
				'scoringtype': $scope.round.Round.scoringtype
			},
			'User': user.info.User
		};
		
		
		$.ajax({
               url: APIHOST + '/users/apisaveround/',
               method: 'POST',
               data: saveRoundData,
               success: function(data) {
               		if (data.data && data.data.Round) {
               			var currentRound = data.data;
               			onSuccess(currentRound);
               		}
               },
               error: function(err) {
               		//error
               }
            });
	
	};



	function loadRoundsInProgress() {
			
			var params = {
        			tk: user.tk, uk: user.uk, pk: user.pk
				};
			$.ajax({
					   url: APIHOST + '/users/apiroundsinprogress/' + $scope.round.Round.course_id + '/' + $scope.round.Round.id + '/',
					   method: 'GET',
					   data: params,
					   success: function(data) {
					   		var golfers = data.data;
					   		$.each(golfers, function(i, golfer) {
					   			golfers[i].User.avatar = getUserAvatar(golfer);
					   			golfers[i].Round.incompetition = false;
					   			$.each($scope.round.Competition, function(c, comp) {
					   				if (comp.Round.id == golfers[i].Round.id) {
					   					golfers[i].Round.incompetition = true;
					   				}
					   			});
					   		});
							$scope.$apply(function() {
								$scope.golfers = golfers;
							});
					   }
					});
	}

	$scope.toggleJoinRound = function(friendround, doRemove) {

		var user_id = friendround.Round.user_id;
		var round_id = friendround.Round.id;
		var current_round_id = $scope.round.Round.id;
		var params = {
			tk: user.tk, 
			uk: user.uk, 
			pk: user.pk,
			user_id: user_id,
			round_id: round_id,
			do_remove: doRemove,
			current_round_id: current_round_id
		};
		$.ajax({
				url: APIHOST + '/users/apicompetitionjoin/',
				method: 'POST',
				data: params,
				success: function(data) {
					if (doRemove) {
						friendround.Round.incompetition = false;
						
						var comp_index = false;
						$.each($scope.round.Competition, function(cm_index, comp) {
							if (comp.Round.id == friendround.Round.id) {
								comp_index = cm_index;
							}
						});
						if (comp_index !== false) {
							$scope.round.Competition.splice(comp_index, 1);
						}
					}
					else {
						friendround.Round.incompetition = true;
						$scope.round.Competition.push(friendround);
					}
					$rootScope.$emit("roundUpdate", $scope.round);
					$scope.$apply();
				},
				error: function(data) {
					
				}
			});
	};

	loadRoundsInProgress();



	$scope.reportCourseProblem = function() {
		ons.notification.confirm({
		  message: 'Wrong yardage for a hole?  Missing Info?  Send us a note.  Attaching a scorecard photo really helps.',
		  // or messageHTML: '<div>Message in HTML</div>',
		  title: 'Course Problem?',
		  buttonLabels: ['Report Problem', 'Cancel'],
		  animation: 'default', // or 'none'
		  primaryButtonIndex: 0,
		  cancelable: true,
		  callback: function(index) {
		  	if (index == 0) {
		  		var default_message = "Hi,\n\nWe found a problem:\n\n\n\n\n\n";
		  		
		  		default_message += "---- Please keep this extra info below to help us ----\n";
		  		default_message += "Club: " + $scope.round.Course.Club.name + "(" + $scope.round.Course.Club.id + ")\n";
		  		default_message += "Course: " + $scope.round.Course.name + "(" + $scope.round.Course.id + ")\n";
		  		default_message += "Tee: " + $scope.round.Tee.name + "(" + $scope.round.Tee.id + ")\n";
		  		default_message += "UID: " + user.info.User.id + "\n";
		  		default_message += "Round Date: " + $scope.round.Round.date + "\n";
		  		default_message += "RID: " + $scope.round.Round.id + "\n\n";
		  		
		  		sendEmail('Course Problem Feedback - ' + whitelabel.app_name, default_message, [ whitelabel.feedback_email ]);
		  	}
		  }
		});
	};


	$scope.takePhoto = function() {
		
		photo.upload('photo', 
					APIHOST + '/users/apieditphoto/', 
					{ round_id: $scope.round.Round.id, comment: '' },
					function(photoURI, progress) {
							//progress
						pageElm.find(".photo-upload-label").html('Saving '+progress+'% <i class="fa fa-circle-o-notch fa-spin"></i>');
						
					}, 
					function() {
							// Done well
						pageElm.find(".photo-upload-label").html('Take Photo');
						setTimeout(function() {
							renderPhotos();
						}, 300);
						
					}, 
					function() {
							//error
						navigator.notification.alert('We ran into a problem uploading your photo.  Please try again.', function() {} , 'Photo Problem', 'Dismiss');
						pageElm.find(".photo-upload-label").html('Take Photo');
						renderPhotos();
					});
		
	};

	$scope.deletePhoto = function(photo) {
		
		var btnActions = function(buttonIndex) {	
			if (buttonIndex == 1) {
				var params = {
		        			tk: user.tk, 
		        			uk: user.uk, 
		        			pk: user.pk,
		        			id: photo.Photo.id
						};
				$.ajax({
						   url: APIHOST + '/users/apieditphoto/remove/',
						   method: 'POST',
						   data: params,
						   success: function(data) {
						   		// actually remove it now
						   		renderPhotos();
						   }
						});
			}
			
		};
		var options = {
			'title': 'Delete Photo?',
			'buttonLabels': [
				'Yes, delete this photo?'
			]
		};
		showActionSheet(options, btnActions);

	};

	$scope.showPhoto = function(photo) {
		showPhoto(photo.Photo.medium);
	};

	function renderPhotos() {
		photo.getRoundPhotos($scope.round.Round.id, function(photos) {
			$scope.$apply(function() {
					$scope.photos = photos;
				});
		});
	}


	renderPhotos();	

});




offcourseApp.controller('SmartwatchController', function($scope) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	
	$scope.company_name = whitelabel.app_name;
	
	$scope.openPebbleLink = function() {
		window.open(whitelabel.pebble_link, '_system');
	};


});





var honourCache = {};
offcourseApp.controller('HonourListController', function($scope) {
	$scope._list = [];
	
	$scope.roundCount = 100;
	$scope.currentCount = 0;
	$scope.currentPage = 0;
	$scope.apicall = 'apihonours';
	
	
	var page = myNavigator.getCurrentPage();
	var currentUser = page.options.user;
	var pageElm = $(page.element);
	if (currentUser.User.id == user.info.User.id) {
		pageElm.find('.navigation-bar .title').html('Your '+ page.options.label);
	}
	else {
		pageElm.find('.navigation-bar .title').html(currentUser.User.name+"'s "+ page.options.label);
	}
	$scope.apicall = page.options.apicall;
	

	$.ajax({
			   url: APIHOST + '/users/'+ $scope.apicall +'/'+ currentUser.User.username +'/',
			   method: 'GET',
			   data: {tk: user.tk, uk: user.uk, pk: user.pk},
			   success: function(data) {
					$scope.$apply(function(){
						$.each(data.data, function(i, honour) {
							
							
							if (typeof(honour.Honour) == 'undefined') {
								//honourDetails = honour.Details;
								honour.Honour = honour;
 							}
							if (typeof(honour.Details) == 'undefined' && honour.Honour.Details) {
								honour.Details = honour.Honour.Details;
							}
							
							
							honourCache[honour.Details.func] = honour;
							
							$scope._list.push({
								id: honour.Details.func,
								name: honour.Details.name,
							 	image: APIHOST + honour.Details.img_small,
							 	image_class: (honour.Details.awarded) ? '' : 'faded'
							 });
							 
						});
					});
			   },
			   error: function() {
					
			   }
			});	
		
      
	
		
});



offcourseApp.controller('HonourController', function($scope) {
	$scope.rounds = [];
	
	var page = myNavigator.getCurrentPage();
	var honour_obj = page.options.honour;
	var honour = honourCache[honour_obj.id];
	honour.Details.img = APIHOST + honour.Honour.Details.img_large;

	$scope.$apply(function() {
		$scope.honour = honour;
	});
	
	
	if (honour.Honour && honour.Honour.round_id) {
		$.ajax({
			   url: APIHOST + '/users/apiround/'+honour.Honour.round_id+'/',
			   method: 'GET',
			   cache: false,
			   data: {tk: user.tk, uk: user.uk, pk: user.pk},
			   error: function(err) {
				
			   },
			   success: function(data) {
			   		$scope.$apply(function() {
						round = data.data;
						round.Round.Course = round.Course;
						round.Round.Tee = round.Tee;
					
						var course_name = '';
						if (round.Round.Course.Club.name != round.Round.Course.name) {
							course_name = round.Round.Course.name;
						}
						var photo = '';
						if (round.Round.Photo && round.Round.Photo[0] && round.Round.Photo[0].medium) {
							photo = "background-image:url("+round.Round.Photo[0].medium+");width:100%;height:150px;position:relative;background-repeat:no-repeat;background-size:cover;background-position:center center;border-radius:4px;margin:5px 0;";
						}
						$scope.rounds.push({
									id: round.Round.id,
									date: toNiceDateTime(parseApiDate(round.Round.date)),
									name: round.User.name,
									club: round.Round.Course.Club.name,
									course: course_name,
									score: round.Round.score,
									holes: round.Round.holes,
									netscore: round.Round.netscore,
									comment: round.Round.comment,
									image: getUserAvatar(round),
									photo: photo
								});
					
					});
				}
			});
	}

});





offcourseApp.controller('OffersController', function($scope, $sce) {
	$scope._list = [];
	$scope.isLoading = false;
	$scope.is_club_app = is_club_app;


	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	pageElm.find('.navigation-bar .title').html(page.options.label);

	$scope.loadLatest = true;
	$scope.loadCourses = false;
	$scope.loadClub = false;

	$scope.courseCount = 100;
	$scope.currentCount = 0;
	$scope.currentPage = 0;
	$scope.course = { search: '' };

	if ($scope.is_club_app) {
		$scope.loadLatest = true;
		$scope.loadCourses = false;
		$scope.loadClub = true;
	}
	
	$scope.switchToClosest = function() {
		$scope.loadLatest = false;
		$scope.loadCourses = false;
		$scope._list = [];
		$scope.currentCount = 0;
		$scope.currentPage = 0;
		$scope.populateOffers();
	}
	$scope.switchToLatest = function() {
		$scope.loadLatest = true;
		$scope.loadCourses = false;
		$scope._list = [];
		$scope.currentCount = 0;
		$scope.currentPage = 0;
		$scope.populateOffers();
	}
	$scope.switchToCourses = function() {
		$scope.loadCourses = true;
		$scope._list = [];
		$scope.currentCount = 0;
		$scope.currentPage = 0;
		$scope.populateOffers();
	}

	$scope.canLoadMoreOffers = function() {
		if (!$scope.loadCourses) {
			return false;
		}
		else {
			var canLoad = ($scope.courseCount >= $scope.currentCount) ? true : false;
			return canLoad;
		}
	}

	$scope.searchCourses = function() {
		//$scope.course.search
		$scope.switchToCourses();
	}

	$scope.populateOffers = function() {
		
		if($scope.isLoading) return;
				
		$scope.isLoading = true;
		
		if ($scope.loadLatest) {
			var offerOrder = 'order:date';
		}
		else {
			var offerOrder = 'order:close';
		}

		if ($scope.loadCourses) {
			var callUrl = APIHOST + '/courses/apifindclubs/page:'+(parseInt($scope.currentPage) + 1)+'/?lat=' + user.cachedLat + '&lng' + user.cachedLng + '&q=' + $scope.course.search;
			$.ajax({
	               url: callUrl,
	               method: 'GET',
	               data: {tk: user.tk, uk: user.uk, pk: user.pk},
	               success: function(data) {
	               		
						$scope.courseCount = data.count;
						$scope.currentPage = data.page;

						$scope.$apply(function(){
		               		$.each(data.data, function(i, club) {
		               			data.data[i].Club.avatar = getClubAvatar(data.data[i]);
		               			data.data[i].Club.avatar = $sce.trustAsResourceUrl(data.data[i].Club.avatar);
		               			data.data[i].isClub = true;
		               			$scope._list.push(data.data[i]);
							});               		
	               		  		
	               		  	$scope.currentCount = $scope._list.length;

							$scope.isLoading = false;
						});

						
						setTimeout(function() {
							//pageElm.find('.ons-scroller-inner').css({ 'height':'100%', '' });
						}, 500);

						
	               }
	            });	
		}
		else {
			if (is_club_app) {
				
				var callUrl = APIHOST + '/users/apioffers/' + user.cachedLat + '/' + user.cachedLng + '/'+whitelabel.course.club_id+'/types:'+offer_types+'/'+offerOrder+'/';
				
			}
			else {
				var callUrl = APIHOST + '/users/apioffers/' + user.cachedLat + '/' + user.cachedLng + '/types:'+offer_types+'/'+offerOrder+'/';
			}

			$.ajax({
	               url: callUrl,
	               method: 'GET',
	               data: {tk: user.tk, uk: user.uk, pk: user.pk},
	               success: function(data) {
	               		
	               		$.each(data.offers, function(i, offer) {
	               			data.offers[i].Offer.excerpt = $sce.trustAsHtml(data.offers[i].Offer.excerpt);
	               			data.offers[i].Offer.content = $sce.trustAsHtml(data.offers[i].Offer.content);
	               			data.offers[i].Club.avatar = getClubAvatar(data.offers[i]);
	               			data.offers[i].Club.avatar = $sce.trustAsResourceUrl(data.offers[i].Club.avatar);
	               			if (data.offers[i].Offer.photo != '') {
	               				data.offers[i].Offer.photo = $sce.trustAsResourceUrl(data.offers[i].Offer.photo);
	               			}
	               			data.offers[i].isOffer= true;
	               			trackOffer(data.offers[i].Offer.id, 0);
						});               		
	               		$scope.$apply(function(){
							$scope._list = data.offers;   		
							$scope.isLoading = false;
						});

						setTimeout(function() {
							//pageElm.find('.ons-scroller-inner').css({ 'height':'100%', '' });
						}, 500);

						
	               }
	            });	
		}
	    return true;
	};
	
	$scope.populateOffers();

	user.newOfferCount = 0;
	setNewOfferCount(user.newOfferCount);
});




offcourseApp.controller('OfferController', function($scope, $sce, $timeout) {

	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	
	var offer = page.options.offer_obj;
	var offer_id = page.options.offer_id;

	$scope.hide_promo_share = hide_promo_share;


	function offerLoadError() {
		navigator.notification.alert("We ran into a problem.  Sorry about that.", function() {
			myNavigator.popPage();
		});
	}

	if (typeof(offer) == 'undefined') {
		// get from the offer_id
		$.ajax({
				   url: APIHOST + '/users/apioffer/'+ offer_id +'/',
				   method: 'GET',
				   data: {tk: user.tk, uk: user.uk, pk: user.pk},
				   success: function(data) {
				   		if (typeof(data.Offer) != 'undefined') {
							$scope.$apply(function(){
								data.Offer.excerpt = $sce.trustAsHtml(data.Offer.excerpt);
		               			data.Offer.content = $sce.trustAsHtml(data.Offer.content);
		               			data.Club.avatar = getClubAvatar(data);
		               			data.Club.avatar = $sce.trustAsResourceUrl(data.Club.avatar);
		               			if (data.Offer.photo != '') {
		               				data.Offer.photo = $sce.trustAsResourceUrl(data.Offer.photo);
		               			}
								$scope.offer = data;
								trackOffer($scope.offer.Offer.id, 1);
								
							});
						}
						else {
							offerLoadError();
						}

						$timeout(function () {
						    $('.offer-content a').click(function () {
								var url = $(this).attr('href');
								window.open(encodeURI(url), '_system');
								return false;
						    });
						}, 100);
				   },
				   error: function() {
					
				   }
				});	
	}
	else {
		$scope.offer = offer;
		trackOffer($scope.offer.Offer.id, 1);

		$timeout(function () {
		    $('.offer-content a').click(function () {
				var url = $(this).attr('href');
				window.open(encodeURI(url), '_system');
				return false;
		    });
		}, 100);
	}





	$scope.shareOffer = function() {
		var msg = '';
		if ($scope.offer.Club && $scope.offer.Club.id) {
			msg = $scope.offer.Offer.title + ' | '+ $scope.offer.Club.name +' '+whitelabel.share_hash+' ';
			shareLink($scope.offer.Offer.title, msg, whitelabel.offer_url+'itemdetails/'+$scope.offer.Offer.id+'/', '');
		}
		else {
			msg = $scope.offer.Offer.title + ' ' + whitelabel.share_hash+' ';
			shareLink($scope.offer.Offer.title, msg, whitelabel.offer_url+'users/offerdetails/'+$scope.offer.Offer.id+'/', '');
		}
		
		
	}

	$scope.callOffer = function() {
		//window.open('tel:' + $scope.offer.Offer.phone);
		//window.open('tel:' + $scope.offer.Offer.phone, '_system');
		trackOffer($scope.offer.Offer.id, 2);
		setTimeout(function() {	
			phoneCall($scope.offer.Offer.phone);
			//document.location.href = 'tel:' + $scope.offer.Offer.phone;
		}, 100);
		//var ref = cordova.InAppBrowser.open('tel:' + $scope.offer.Offer.phone, '_system');
	}
	 
	$scope.onlineOffer = function() {
		trackOffer($scope.offer.Offer.id, 2);

		var outURL = $scope.offer.Offer.bookingurl;
		if ($scope.offer.Offer.contest == 1) {
			if ($scope.offer.Offer.bookingurl.indexOf("?") > -1) {
				outURL = $scope.offer.Offer.bookingurl + '&ock=' + user.uk + '-'+md5(user.info.User.email);
			}
			else {
				outURL = $scope.offer.Offer.bookingurl + '?ock=' + user.uk + '-'+md5(user.info.User.email);
			}
		}

//bookinginapp
		setTimeout(function() {	
			var openExternal = true;
			if ($scope.offer.Offer.bookinginapp && $scope.offer.Offer.bookinginapp == 1) {
				openExternal = false;
			}
			openCustomLink(outURL, openExternal);
			//window.open(outURL, '_system');
		}, 100);
	}

});




offcourseApp.controller('TourController', function($scope) {
	$scope._list = [];
	$scope.isLoading = false;
	$scope.people = {search: ''};
	$scope.sortheader = "";
	$scope.sortitem = 'handicap';
	$scope.sortitemname = 'HDCP';
	
	var page = myNavigator.getCurrentPage();
	var currentUser = page.options.user;
	var pageElm = $(page.element);
	if (currentUser.User.id == user.info.User.id) {
		pageElm.find('.navigation-bar .title').html('Your '+ page.options.label);
	}
	else {
		pageElm.find('.navigation-bar .title').html(currentUser.User.name+"'s "+ page.options.label);
	}
	
	$scope.loadTour = function() {
		$.ajax({
				   url: APIHOST + '/users/apitour/'+ currentUser.User.username +'/',
				   method: 'GET',
				   data: {tk: user.tk, uk: user.uk, pk: user.pk},
				   success: function(data) {
						userTour = data.data;
						userTour = sortUserTour(userTour, 'name', 'asc');
			   
						$.each(userTour, function(i, tUser) {
							userTour[i].User.avatar = getUserAvatar(userTour[i]);
							userTour[i].User.onTour = user.onTour(tUser.User.id);
							userTour[i].User.isSelf = (user.info.User.id == tUser.User.id);
						});
			   
						$scope.$apply(function(){
							$scope._list = userTour;
						});
				   },
				   error: function() {
					
				   }
				});	
	
	
			$scope.canLoadMoreCourses = function() {
			return ($scope.courses.length >= $scope.courseCount) ? false : true;
		};
	};
	
	var ajaxRunning = false;
	$scope.populatePeople = function() {
		$scope.isLoading = true;
		
		if ($scope.people.search.length == 0) {
			$scope.isLoading = true;
			ajaxRunning.abort();
			$scope.loadTour();
		}
		else {
			var params = {tk: user.tk, uk: user.uk, pk: user.pk};
		
			//params['q'] = pageElm.find('.search-input').val();
			params['q'] = $scope.people.search;
			params['date'] = new Date().toString();
		
			if (ajaxRunning) {
				ajaxRunning.abort();
				ajaxRunning = false;
			}
		
			ajaxRunning = $.ajax({
			   url: APIHOST + '/users/apiuserfind/',
			   method: 'GET',
			   data: params,
			   success: function(data) {
			   		ajaxRunning = false;
			   		$scope.isLoading = false;
			   		
			   		var userTour = data.data;
					$.each(userTour, function(i, tUser) {
						userTour[i].User.avatar = getUserAvatar(userTour[i]);
						userTour[i].User.onTour = user.onTour(tUser.User.id);
						userTour[i].User.isSelf = (user.info.User.id == tUser.User.id);
					});
					
					$scope.$apply(function(){
						$scope._list = userTour;
					});
				
			   },
			   error: function() {
					ajaxRunning = false;
					$scope.isLoading = false;
			   }
			});
		}
			
		
        return true;
	};
	

	$scope.sortTour = function() {
		
		var btnActions = function(buttonIndex) {	
			var userTour = $scope._list;
			if (buttonIndex == 1) {
				userTour = sortUserTour(userTour, 'name', 'asc');
				$scope.sortheader = "";
				$scope.sortitem = 'handicap';
				$scope.sortitemname = 'HDCP';
			}
			if (buttonIndex == 2) {
				userTour = sortUserTour(userTour, 'avgscore', 'asc');
				$scope.sortheader = "Avg Score";
				$scope.sortitem = 'avgscore';
				$scope.sortitemname = 'Score';
			}
			if (buttonIndex == 3) {
				userTour = sortUserTour(userTour, 'avggross5', 'asc');
				$scope.sortheader = "Avg Score - Last 5 Rounds";
				$scope.sortitem = 'avggross5';
				$scope.sortitemname = 'Score';
			}
			if (buttonIndex == 4) {
				userTour = sortUserTour(userTour, 'lastgross', 'asc');
				$scope.sortheader = "Latest Score";
				$scope.sortitem = 'lastgross';
				$scope.sortitemname = 'Score';
			}
			if (buttonIndex == 5) {
				userTour = sortUserTour(userTour, 'avgnet5', 'asc');
				$scope.sortheader = "Net Avg Score - Last 5 Rounds";
				$scope.sortitem = 'avgnet5';
				$scope.sortitemname = 'Score';
			}
			if (buttonIndex == 6) {
				userTour = sortUserTour(userTour, 'lastnet', 'asc');
				$scope.sortheader = "Net Latest Score";
				$scope.sortitem = 'lastnet';
				$scope.sortitemname = 'Score';
			}
			if (buttonIndex == 7) {
				userTour = sortUserTour(userTour, 'hdcpchange5', 'asc');
				$scope.sortheader = "HDCP +/-";
				$scope.sortitem = 'hdcpchange5';
				$scope.sortitemname = 'HDCP Change';
			}
			
			$scope.$apply(function() {
				$scope._list = userTour;
			});
		};
		var options = {
			'title': 'Sort Tour Members?',
			'buttonLabels': [
				'By Name',
				'Avg Score',
				'Avg Score - Last 5 Rounds',
				'Latest Score',
				'Net Avg Score - Last 5 Rounds',
				'Net Latest Score',
				'HDCP +/-'
			]
		};
		showActionSheet(options, btnActions);
	

	};
		
      
    $scope.loadTour();
		
});




offcourseApp.controller('GalleryController', function($scope) {
	$scope._list = [];
	$scope.isLoading = false; 
	$scope.galleryCount = 100;
	$scope.currentCount = 0;
	$scope.currentPage = 0;
	$scope.pendinggallery = [];
	
	var page = myNavigator.getCurrentPage();
	var currentUser = page.options.user;
	var pageElm = $(page.element);
	if (currentUser.User.id == user.info.User.id) {
		pageElm.find('.navigation-bar .title').html('Your '+ page.options.label);
	}
	else {
		pageElm.find('.navigation-bar .title').html(currentUser.User.name+"'s "+ page.options.label);
	}
	

	
	$scope.pendinggallery = user.pendingGalleryCache;
	

    $scope.canLoadMoreGallery = function() {
		return ($scope._list.length >= $scope.galleryCount) ? false : true;
	};
	

	$scope.populateGallery = function() {
		if($scope.isLoading) return;
		
		$scope.$apply(function(){
			$scope.isLoading = true;
		});
		
		
		$.ajax({
			   url: APIHOST + '/users/apigallery/'+ currentUser.User.username +'/page:'+($scope.currentPage+1)+'',
			   method: 'GET',
			   data: {tk: user.tk, uk: user.uk, pk: user.pk},
			   success: function(data) {
			   		
					$scope.$apply(function(){
						$scope.currentCount = data.page * data.limit;
						$scope.galleryCount = data.count;
 						$scope.currentPage = data.page;
 						
						$.each(data.data, function(i, gUser) {
							gUser.User.avatar = getUserAvatar(gUser);
							gUser.User.onTour = user.onTour(gUser.User.id);
							gUser.User.isSelf = (user.info.User.id == gUser.User.id);
							$scope._list.push(gUser);
						});
					
						$scope.isLoading = false;
						
					});

					if ($scope.currentCount <= 10) {
						$scope.populateGallery();
					}

					
			   },
			   error: function() {
					
			   }
			});	
		
        return true;
	};
	
	$scope.populateGallery();


});




offcourseApp.controller('LeaderboardController', function($scope) {
	$scope._list = [];
	$scope.isLoading = false;
	$scope.sortheader = "Past Year";
	$scope.sortitem = 'net';
	$scope.sortitemname = 'Net';
	
	var page = myNavigator.getCurrentPage();
	var club_id = page.options.club_id;
	var pageElm = $(page.element);
	var leaderboardData = {};
	$scope.leaderboardAction = function(round) {
		if (leaderboardData.Club.type == 0) {
			myNavigator.pushPage('round.html', { round_id: round.Round.id });
		}
		else {
			myNavigator.pushPage('user.html', { user_obj: round });
		}
	}

	$scope.loadLeaderboard = function() {
		$.ajax({
				   url: APIHOST + '/courses/apileaderboard/'+ club_id +'/',
				   method: 'GET',
				   data: { },
				   success: function(data) {
						leaderboardData = data.data;
						leaderboardCourses = [];
						
						if (leaderboardData.Club.type == 0) {
							$.each(leaderboardData.Course, function(i, lbCourse) {
								leaderboardCourses[i] = {
									'Course': {
										'name': lbCourse.name,
										'id': lbCourse.id,
										'type': leaderboardData.Club.type
									},
									'LB': {}
								};
								var lb_counter = 0;
								$.each(lbCourse.Leaderboard, function(j, lb) {
									if (typeof(lb) == 'object' && lb.rounds && lb.rounds.length > 0) {
										leaderboardCourses[i]['LB'][lb_counter] = {
											'label': lb.label,
											'rounds': [],
											'type': leaderboardData.Club.type
										};
										$.each(lb.rounds, function(r, rnd) {
											rnd.User.avatar = getUserAvatar(rnd);
											rnd.User.onTour = user.onTour(rnd.User.id);
											if (user.info.User) {
												rnd.User.isSelf = (user.info.User.id == rnd.User.id);
											}
											else {
												rnd.User.isSelf = false;
											}
											leaderboardCourses[i]['LB'][lb_counter]['rounds'].push(rnd);
										});
										lb_counter++;
									}
								});
							});
				   
							$scope.$apply(function() {
								$scope.leaderboard = leaderboardCourses;
								$scope.course = leaderboardCourses[0];
							});
						}
						else {
							
							leaderboardCourses[0] = {
								'Course': {
									'name': leaderboardData.Club.name,
									'id': leaderboardData.Club.id,
									'type': leaderboardData.Club.type
								},
								'LB': {}
							};
							var lb_counter = 0;
							$.each(leaderboardData.Club.Leaderboard, function(j, lb) {
								if (typeof(lb) == 'object' && lb.label && lb.param) {
									leaderboardCourses[0]['LB'][lb_counter] = {
										'label': lb.label,
										'rounds': [],
										'type': leaderboardData.Club.type
									};
									$.each(lb.users, function(r, lUser) {
										lUser.User.avatar = getUserAvatar(lUser);
										lUser.User.onTour = user.onTour(lUser.User.id);
										if (user.info.User) {
											lUser.User.isSelf = (user.info.User.id == lUser.User.id);
										}
										else {
											lUser.User.isSelf = false;
										}
										lUser.User.val = lUser.User[lb.param];
										leaderboardCourses[0]['LB'][lb_counter]['rounds'].push(lUser);
									});
									lb_counter++;
								}
							});
						
				   
							$scope.$apply(function() {
								$scope.leaderboard = leaderboardCourses;
								$scope.course = leaderboardCourses[0];
							});
						}
				   },
				   error: function() {
					
				   }
				});	
	
	
			$scope.canLoadMoreCourses = function() {
				return false;
			};
	};
	
	$scope.changeCourse = function() {
			// for courses with many courses
		if ($scope.leaderboard.length > 1) {
			var btnActions = function(buttonIndex) {
				$scope.$apply(function() {
					if (typeof($scope.leaderboard[buttonIndex - 1]) != 'undefined') {
						$scope.course = $scope.leaderboard[buttonIndex - 1];
					}
					
				});
			};

			var buttonlabels = [];
			$.each($scope.leaderboard, function(i, lb) {
				buttonlabels.push(lb.Course.name)
			});
			var options = {
				'title': 'Change Course',
				'buttonLabels': buttonlabels
			};
			showActionSheet(options, btnActions);
		}
	}
      
    $scope.loadLeaderboard();

});






var user = {
	
	info: {},
	isMetric: false,
	pk: '',
	tk: '',
	uk: '',
	cachedLat: 0,
	cachedLng: 0,
	cachedAccuracy: '',

	privatemember: {},
	
	offers: [],
	newOfferCount: 0,
	
	currentRound: {},
	
	tourCache: [],
	tourCacheMatch: {},
	
	pendingTourCache: [],
	pendingGalleryCache: [],
	
	fb_token: false,
	
	isSignedIn: function() {
		if (user.tk && user.tk != '' && user.info) {
			return true;
		}
		return false;
	},
	isFemale: function() {
		return (this.info.User.gender == 1) ? true : false;
	},
	isMale: function() {
		return (this.info.User.gender == 1) ? false : true;
	},
	
	setRole: function() {
		var role_id = 0;
		if (user.info.Golfjetuser && user.info.Golfjetuser.role) {
			if (typeof(role_caps[user.info.Golfjetuser.role]) != 'undefined') {
				role_id = user.info.Golfjetuser.role;
			}
		}
		else if (user.info.Golfjetuser && typeof(user.info.Golfjetuser.trialdays) != 'undefined') {
			if (parseInt(user.info.Golfjetuser.trialdays) > 0) {
				role_id = 1;
			}
		}
				
		$.extend(app.caps, role_caps[role_id]);
		
		
		if (!enableSmartWatch) {
			app.caps.wearables = false;
		}
		
		if (app.caps.advertising) {
			enable_offers = true;
		}
		else {
			enable_offers = false;
		}
		
		if (role_id == 1 && typeof(offer_member_types) != 'undefined') {
			offer_types = offer_member_types;
		}
		
		if (!app.caps.fullscoring) {
			app.defaultScoringType = 1;
			delete scoringtypes[0];
		}
		
	},
	
	signin: function(email, password, success, error, alldata) {
		this.pk = Math.random();
        
		var club_id = 0;
    	if (is_club_app) {
    		club_id = whitelabel.course.club_id;
    	}

        $.ajax({
               url: APIHOST + '/users/apisignin/',
               method: 'POST',
               data: { email: email, password: password, pk: this.pk, club_id: club_id },
               success: function(data) {
               		if (data.User && data.tk) {
	                    user.info = data;
						user.isMetric = user.info.User.metric;
						user.tk = data.tk;
						user.uk = user.info.User.id;
						
	                    window.localStorage['lastemail'] = user.info.User.email;
	                    window.localStorage['pk'] = user.pk;
	                    window.localStorage['tk'] = user.tk;
	                    window.localStorage['currentUser'] = JSON.stringify(data);
	                   
	                    user.initUserData(function() {
	                    	success(user.info);
	                    	setMemberGuestGroup();
	                    	alldata();
	                    });
                    }
                    else {
                    	error(data);
                    }
               },
               error: function() {
               		navigator.notification.alert('There was a problem signing you in.  Please try again.', function() {} , 'Sign In Error', 'Dismiss');
               		
               }
            });
            
	},


    checkAuth: function(success, error, alldata) {  
          
    	if (window.localStorage['tk']) {
    		this.tk = window.localStorage['tk'];
    	}
    	if (window.localStorage['pk']) {
    		this.pk = window.localStorage['pk'];
    	}
    	if (window.localStorage['currentUser']) {
    		try {
    			this.info = JSON.parse(window.localStorage['currentUser']);
    		}
    		catch (err) {
    			this.info = {};
    		}
    	}
    	if (this.info.User && this.info.User.id) {
    		this.uk = this.info.User.id;
    	}
    	
    	if (window.localStorage['cachedAccuracy']) {
    		this.cachedAccuracy = window.localStorage['cachedAccuracy'];
    	}
    	if (window.localStorage['cachedLat']) {
    		this.cachedLat = window.localStorage['cachedLat'];
    	}
    	if (window.localStorage['cachedLng']) {
    		this.cachedLng = window.localStorage['cachedLng'];
    	}
    	else {
    		if (window.localStorage['tk']) {
				gps.getPosition(function(data) {
					if (data) {
						user.cachedLat = data.coords.latitude;
						user.cachedLng = data.coords.longitude;
						user.cachedAccuracy = data.coords.accuracy;						
					}
				});
			}
    	}
    	  	
    	if (window.localStorage['fb_token']) {
    		user.fb_token = window.localStorage['fb_token'];
    	}
    	
    	if (this.pk == '') {
    		this.pk = Math.random();
    	}
    	var club_id = 0;
    	if (is_club_app) {
    		club_id = whitelabel.course.club_id;
    	}
    	
		$.ajax({
				   url: APIHOST + '/users/apicheckauth/',
				   method: 'GET',
				   cache: false,
				   data: {tk: this.tk, uk: this.uk, pk: this.pk, club_id: club_id},
				   success: function(data) {
					
						if (typeof(data.User) != 'undefined') {

							user.info = data;
							user.isMetric = user.info.User.metric;
							
							if (typeof(data.tk) != 'undefined') {
								
								user.tk = data.tk;
								user.uk = user.info.User.id;
					
								window.localStorage['lastemail'] = user.info.User.email;
								window.localStorage['pk'] = user.pk;
								window.localStorage['tk'] = user.tk;
								window.localStorage['currentUser'] = JSON.stringify(data);
				   
							}

					
							user.initUserData(function() {
								success(user.info);
								setMemberGuestGroup();
								alldata();
							});
							
						}
						else {
							user.removeSession(true);
							error({});
						}
				   },
				   error: function(err) {
				   			// load club cache.  Incase we are offline
				   		app.cacheClub();
						error(err);
				   }
				});
		
    },
    
	
	refresh: function(callback, alldata) {
		var club_id = 0;
    	if (is_club_app) {
    		club_id = whitelabel.course.club_id;
    	}
    	$.ajax({
				   url: APIHOST + '/users/apicheckauth/',
				   method: 'GET',
				   cache: false,
				   data: {tk: this.tk, uk: this.uk, pk: this.pk, club_id: club_id},
				   success: function(data) {
						if (data.User) {
                    		user.info = data;
                    		user.isMetric = user.info.User.metric;
                    	}
                    	user.initUserData(function() {
							if (typeof(callback) == 'function') {
								callback();
							}
							setMemberGuestGroup();
                    		alldata();
                    	});

                    	
				   },
				   error: function() {
                    	if (typeof(callback) == 'function') {
							callback();
						}
				   }
				});
    },
	
	signout: function(success, error) {
        
        $.ajax({
               url: APIHOST + '/users/apisignout/',
               method: 'POST',
               data: {tk: this.tk, uk: this.uk, pk: this.pk},
               success: function(data) {
				
					user.removeSession();

					success();
                    
               },
               error: function() {
               		error();
               }
            });
        
    },

    removeSession: function(keepPrivate) {
    	if (typeof(keepPrivate) == 'undefined') {
    		 keepPrivate = false;
    	}

		window.localStorage['pk'] = '';
		window.localStorage['tk'] = '';
		window.localStorage['currentUser'] = '';
		window.localStorage['fb_token'] = '';
		window.localStorage['savedOffers'] = '';
		user.tk = '';
		user.uk = '';
		user.pk = '';
		user.fb_token = false;
		user.info = {};
		
		if (!keepPrivate) {
			window.localStorage.removeItem('privatemember');
			window.localStorage.removeItem('teetimeusername');
			window.localStorage.removeItem('teetimepassword');
		}
    },
    
    
    convertDistance: function(distance) {
   		if (user.isMetric) {
			return yardsToMeters(distance);
		}
		else {
			return distance;
		}
    },
    
    initUserData: function(callback) {

		if (user.isSignedIn()) {
			setTrackingUID(user.info.User.id);
			user.setRole();
			
			setTimeout(function() {
				user.cacheTour();
			}, 200);
			
			setTimeout(function() {
				user.getPendingTour();
			}, 500);
			
			setTimeout(function() {
				user.getPendingGallery();
			}, 1200);
			
			setTimeout(function() {
				user.getPendingGallery();
			}, 1700);
		}

		setTimeout(function() {
			if (app.isOnboarded()) {
				registerPushNotificationEvents();
			}
		}, 1);
	

		app.cacheClub();

		callback();
    },
    
    getPendingTour: function(callback) {
  		$.ajax({
				url: APIHOST + '/users/apitourpending/',
				method: 'GET',
				data: {tk: user.tk, uk: user.uk, pk: user.pk},
				success: function(data) {
					user.pendingTourCache = data.data;
					if (typeof(callback) != 'undefined') {
						callback();
					}
				},
				error: function() {
					if (typeof(callback) != 'undefined') {
						callback();
					}
				}
			}); 
  	},
  	
  	addTourPendingUser: function(user_obj) {
  		user.pendingTourCache.push(user_obj);
  	},
  	
  	removeTourPendingUser: function(user_id) {
		var index = null;
		for(var i = 0; i < user.pendingTourCache.length; i++) {
			if (user.pendingTourCache[i]['User']['id'] == user_id) {
				index = i;
			}
		}
		if (index !== null) {
			user.pendingTourCache.splice(index, 1);
		}	
  	},
  	
  	isTourPendingUser: function(user_id) {
  		var isTour = false;
  		if (user.isSignedIn()) {
	  		if (user.pendingTourCache.length > 0) {
				$.each(user.pendingTourCache, function(i, user) {
					
					if (user.User.id == user_id) {
						isTour = true;
						return false;
					}
				
				});
			}
		}
  		return isTour;
  	},
    
    getPendingGallery: function(callback) {
    	if (user.isSignedIn()) {
			if (user.info.User.privacy) {
		  		$.ajax({
						url: APIHOST + '/users/apigallerypending/',
						method: 'GET',
						data: {tk: user.tk, uk: user.uk, pk: user.pk},
						success: function(data) {
							user.pendingGalleryCache = data.data;
							if (typeof(callback) != 'undefined') {
								callback();
							}
						},
						error: function() {
							if (typeof(callback) != 'undefined') {
								callback();
							}
						}
					}); 
			}
    	}
    },

  	isGalleryPendingUser: function(user_id) {
  		if (user.isSignedIn()) {
	  		if (user.info.User.privacy) {
				var isGallery = false;
				if (user.pendingGalleryCache.length > 0) {
					$.each(user.pendingGalleryCache, function(i, user) {
						if (user.User) {
							if (user.User.id == user_id) {
								isGallery = true;
								return false;
							}
						}
					});
				}
				return isGallery;
			}
		}
		return false;
  	},
    
    approveGalleryUser: function(username, callback) {
  		$.ajax({
				url: APIHOST + '/users/apigalleryapprove/'+username+'/',
				method: 'GET',
				data: {tk: user.tk, uk: user.uk, pk: user.pk},
				success: function(data) {
					user.getPendingGallery(function() {
						if (typeof(callback) != 'undefined') {
							callback();
						}
					});
				},
				error: function(err) {
					if (typeof(callback) != 'undefined') {
						callback();
					}
				}
			}); 
  	},
  	
  	blockGalleryUser: function(username, callback) {
  		$.ajax({
				url: APIHOST + '/users/apigalleryblock/'+username+'/',
				method: 'GET',
				data: {tk: user.tk, uk: user.uk, pk: user.pk},
				success: function(data) {
					user.getPendingGallery(function() {
						if (typeof(callback) != 'undefined') {
							callback();
						}
					});
				},
				error: function(err) {
					if (typeof(callback) != 'undefined') {
						callback();
					}
				}
			}); 
  	},
    
    cacheTour: function() {
    	$.ajax({
			   url: APIHOST + '/users/apitour/'+ user.info.User.username +'/',
			   method: 'GET',
			   data: {tk: user.tk, uk: user.uk, pk: user.pk},
			   success: function(data) {
			   		var userTour = data.data;
			   		userTour = sortUserTour(userTour, 'Name', 'name', 'asc');
			   
			   		$.each(userTour, function(i, tUser) {
			   			userTour[i].User.avatar = getUserAvatar(userTour[i]);
			   			user.tourCacheMatch[tUser.User.id] = true;
			   			userTour[i].User.onTour = user.onTour(tUser.User.id);
			   			userTour[i].User.isSelf = (user.info.User.id == tUser.User.id);
			   		});
			   
					user.tourCache = userTour;
					
			   },
			   error: function() {
					
			   }
			});	
    },
    addTourCache: function(tourUser) {
    	user.tourCacheMatch[tourUser.User.id] = true;
    },
    removeTourCache: function(tourUser) {
		delete user.tourCacheMatch[tourUser.User.id];
    },
    
    onTour: function(user_id) {
    	if (user.isSignedIn()) {
	    	if (typeof(user.tourCacheMatch[user_id]) != 'undefined') {
	    		return true;
	    	}
	    }
    	return false;
    },
    
    addFacebookInfo: function(fb_token, success, error) {
 console.log('******* addFacebookInfo '+fb_token);
 console.log('https://graph.facebook.com/v2.8/me?access_token='+fb_token);

//https://graph.facebook.com/v2.8/me?format=json&fields=name,gender,hometown,location,picture,email,cover&access_token=EAAPJnZCNdAsEBANFNw2AufuJZALqsOZCo08IhPVeItTpZB3U8qGrf39w9vPVHmFjNL6xrEqTkejxZCVLbZAV4sZAEY8LbBkrHyX1WdhSdidSDZBKjzZBZBzoKUlmC7aysXJ4jYWjxBYomZAbDcvkpTIuc2l52ALwiqyZBxYZD

    	$.ajax({
					url: 'https://graph.facebook.com/v2.8/me',
					method: 'GET',
					data: {
						access_token: fb_token,
						fields: "name,gender,hometown,location,picture,email,cover",
						format: 'json'
					},
					success: function (data) {
						user.pk = Math.random();
console.log('******* addFacebookInfo SUCCESS '+fb_token);
console.log(data);
console.log(JSON.stringify(data));					
						data.fb_token = fb_token;
						data.pk = user.pk;
						$.ajax({
							   url: APIHOST + '/users/apifacebook/',
							   method: 'POST',
							   data: data,
							   success: function(data) {
									if (typeof(data.User) != 'undefined') {
										user.info = data;
										user.isMetric = user.info.User.metric;
	                    				user.tk = data.tk;
										user.uk = user.info.User.id;
										
										user.fb_token = fb_token;

										window.localStorage['lastemail'] = user.info.User.email;
										window.localStorage['pk'] = user.pk;
										window.localStorage['tk'] = user.tk;
										window.localStorage['uk'] = user.uk;
										window.localStorage['currentUser'] = JSON.stringify(data);
										window.localStorage['fb_token'] = user.fb_token;
										
										user.initUserData(function() {
											success(user.info);
										});
					
									}
									else {
										navigator.notification.alert("We had problems signing you in with Facebook.  Make sure you have an account with GolfJet.");
										
									}
							   }
							});	
					},
					error: function (err) {
console.log('******* addFacebookInfo ERROR ');
console.log(err);
console.log(JSON.stringify(err));					

						
					} 
				});
    },
    
    canSeeUser: function(otherUser) {	
		if (!otherUser.User.privacy) {
			return true;
		}
		if (user.isSignedIn()) {
			if (user.info.User.id == otherUser.User.id) {
				return true;
			}
			if (user.info.User.id == 5) {
				return true;
			}
			
			if(user.tourCacheMatch[otherUser.User.id]) {
				return true;
			}
		}
		return false;
    }
    	
}



function cacheOffers($sce) {
		
	if (user.cachedLat == '') {
		gps.getPosition(function(data) {
					if (data) {
						user.cachedLat = data.coords.latitude;
						user.cachedLng = data.coords.longitude;
						user.cachedAccuracy = data.coords.accuracy;	
						
						loadOffers();					
					}
				});
	}
	else {
		loadOffers();
	}
			
	function loadOffers() {

		if(enable_offers) {
			if (is_club_app) {
				var callUrl = APIHOST + '/users/apioffers/' + user.cachedLat + '/' + user.cachedLng + '/'+whitelabel.course.club_id+'/types:'+offer_types+'/';
			}
			else {
				var callUrl = APIHOST + '/users/apioffers/' + user.cachedLat + '/' + user.cachedLng + '/types:'+offer_types+'/';
			}

			$.ajax({
				   url: callUrl,
				   method: 'GET',
				   data: {tk: user.tk, uk: user.uk, pk: user.pk},
				   success: function(data) {
						user.offers = data.offers;
						


						var savedOffers = [];
						if (window.localStorage['savedOffers']) {
				    		try {
				    			savedOffers = JSON.parse(window.localStorage['savedOffers']);
				    		}
				    		catch (err) {
				    			savedOffers = [];
				    		}
				    	}
				    	var savedOfferIDs = {};
				    	$.each(savedOffers, function(i, offer) {
				    		savedOfferIDs[offer.Offer.id] = offer;
				    	});
				    	user.newOfferCount = 0;


						$.each(user.offers, function(i, offer) {
							user.offers[i].Offer.excerpt = $sce.trustAsHtml(offer.Offer.excerpt);
							user.offers[i].Offer.content = $sce.trustAsHtml(offer.Offer.content);
							user.offers[i].Club.avatar = getClubAvatar(offer);
							user.offers[i].Club.avatar = $sce.trustAsResourceUrl(offer.Club.avatar);
							if (user.offers[i].Offer.photo != '') {
								user.offers[i].Offer.photo = $sce.trustAsResourceUrl(offer.Offer.photo);
							}

							if (typeof(savedOfferIDs[offer.Offer.id]) == 'undefined') {
								offer.Offer.id;
								user.newOfferCount++;
							}
						});
						
						setNewOfferCount(user.newOfferCount);


						window.localStorage['savedOffers'] = JSON.stringify(user.offers);
				   }
				});	
		}
	}
	
	return true;

}



var photo = {
	upload: function(filekey, url, extradata, onupload, success, error) {
		if (isWeb) {
			
			$('<input />').attr('type', 'file').attr('name', filekey).attr('id', filekey).appendTo('body').click().change(function() {
				var file = $(this).get(0).files[0];
				var imageType = /image.*/;
	
				if (!file.type.match(imageType)) {
				  return;
				}
				
				var img = $('#'+filekey).get(0);
				img.classList.add("obj");
				img.file = file;				
				imageURI = file;

				var reader = new FileReader();
				reader.onload = (function(aImg) { return function(e) { aImg.src = e.target.result; }; })(img);
				reader.readAsDataURL(file);
				
				
				onupload(imageURI, 0);
				
				
				var params = {
						tk: user.tk, uk: user.uk, pk: user.pk
					};
				$.each(extradata, function(index, val) {
					params[index] = val;
				});
				var data = new FormData();
				$.each(params, function(index, val) {
					data.append(index, val);
				});
				data.append(filekey, imageURI);
				params = data;
				
				ft = $.ajax({
					   url: url,
					   method: 'POST',
					   data: params,
					   processData: false,
					   contentType: false,
					   success: function(data) {
					   		onupload(imageURI, 0);
							success(data);
					   },
					   error: function(err) {
							if (err.status != 0) {
								error(err.code);
							}
					   }
					});
				
				
				
			});
			
			
		}
		else {
			var onCaptureSuccess = function(imageURI) {
				setTimeout(function() {
					var fail, ft, options, params, win;

					onupload(imageURI, 0);

						// callback for when the photo has been successfully uploaded:
					var uploadsuccess = function(response) {
						success(response);
					};
						// callback if the photo fails to upload successfully.
					var uploadfail = function(err) {
						error(err.code);
					};
				
					options = new FileUploadOptions();
					options.fileKey = filekey;
					options.fileName = imageURI.substr(imageURI.lastIndexOf('/') + 1);
					options.mimeType = "text/plain";
					params = {
						tk: user.tk, uk: user.uk, pk: user.pk
					};
					options.params = params;
					$.each(extradata, function(index, val) {
						options.params[index] = val;
					});
					options.chunkedMode = false;
			
					ft = new FileTransfer();
					ft.onprogress = function(progressEvent) {
						if (progressEvent.lengthComputable) {
							var perc = Math.floor(progressEvent.loaded / progressEvent.total * 100);
							onupload(imageURI, perc);
						}
						else {
							//onupload(imageURI, perc);
						}
					};
					ft.upload(imageURI, url, uploadsuccess, uploadfail, options, true);
				}, 5);
			};

			// there was an error capturing the photo:
			var onCaptureFail = function(message) {
				setTimeout(function() {
					if (message != 'no image selected'.toLowerCase() && message != 'Selection cancelled.'.toLowerCase()) {
						error(message);
					}
				}, 10);
			};

			var capturePhoto = function(sourceType) {
			
				var shareType = function(buttonIndex) {	
					if (buttonIndex == 1) {
						navigator.camera.getPicture(onCaptureSuccess, onCaptureFail, {
																destinationType: Camera.DestinationType.FILE_URI,
																sourceType: Camera.PictureSourceType.CAMERA,
																correctOrientation: true,
																targetWidth: 1200,
																targetHeight: 1200,
																saveToPhotoAlbum: true
															  });
					}
					if (buttonIndex == 2) {
						navigator.camera.getPicture(onCaptureSuccess, onCaptureFail, {
																destinationType: Camera.DestinationType.FILE_URI,
																sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
																correctOrientation: true,
																targetWidth: 1200,
																targetHeight: 1200
															  });
					}
				};
				var options = {
					'title': 'Choose Photo From:',
					'buttonLabels': [
						'Camera',
						'Photo Library'
					]
				};
				showActionSheet(options, shareType);
		
			};  

			capturePhoto();
		}
	},
	
	photosAjax: false,
	getRoundPhotos: function(round_id, callback) {
	
		params = {
				tk: user.tk, uk: user.uk, pk: user.pk
			};
    	
    	if (photo.photosAjax && photo.photosAjax.readystate != 4) {
    		photo.photosAjax.abort();
    	}
    	
    	photo.photosAjax = $.ajax({
               url: APIHOST + '/users/apiroundphotos/'+round_id+'/',
               method: 'GET',
               data: params,
               success: function(data) {
               		callback(data.data);
               },
               error: function() {
               		callback([]);
               }
            });
            
	}
	
};




var gps = {
	getPosition: function(callback) {
		if (navigator.geolocation && app.isOnboarded()) {
			navigator.geolocation.getCurrentPosition(function(data) {	
			
						window.localStorage['cachedAccuracy'] = data.coords.accuracy;
						window.localStorage['cachedLat'] = data.coords.latitude;
						window.localStorage['cachedLng'] = data.coords.longitude;
	
						if (typeof(callback) == 'function') {
							callback(data);
						}
						
					},
					function(err) {
						callback(false);
					},
					{ timeout: 5000, enableHighAccuracy: true, maximumAge: 90000 });
		}
		else {
			if (typeof(callback) == 'function') {
				callback(false);
			}
		}
	},
	firstPosition: function() {
		requestAlwaysLocation(true);

		if (navigator.geolocation) {

				// I think this is messing things up with permissions.  Perhaps we need to change this up
			configBackgroundGeolocation(function() {});
			/*
			navigator.geolocation.getCurrentPosition(function(data) {	
						window.localStorage['cachedAccuracy'] = data.coords.accuracy;
						window.localStorage['cachedLat'] = data.coords.latitude;
						window.localStorage['cachedLng'] = data.coords.longitude;
	
						callback(data);
					},
					function(err) {
						callback(false);
					},
					{ timeout: 1000, maximumAge: 5000 });
					*/
		}
		else {
			if (typeof(callback) == 'function') {
				callback(false);
			}
		}
	},

	yardageMap: {},
	gpsTracker: false,
	gpsListeners: {},
	gpsRunning: false,
	startGpsTracker: function() {
		
			// lightly track GPS to keep things fresh for when needed
		gps.gpsRunning = true;
		
		gps.gpsTracker = navigator.geolocation.watchPosition(
				function(position) {
						// success - should trigger every second or so
				
					user.cachedLat = position.coords.latitude;
					user.cachedLng = position.coords.longitude;
					user.cachedAccuracy = position.coords.accuracy;
					
					$.each(gps.gpsListeners, function(i, gpsFunc) {
						gpsFunc(user.cachedLat, user.cachedLng, user.cachedAccuracy);
					});
					
				}, 
				function(error) {
					console.log("Watch Position Error:");
					console.log(error);
					
					$.each(gps.gpsListeners, function(i, gpsFunc) {
						gpsFunc(user.cachedLat, user.cachedLng, user.cachedAccuracy);
					});

						// error
					//if (prevYardage == 0) {
						//yards_container.html('Searching...');
					//}
				}, 
				{ 
					maximumAge: 5000, timeout: 5000, enableHighAccuracy: true 
				}
			);
	

		
	},
	stopGpsTracker: function() {
		if (gps.gpsTracker !== false) {
			navigator.geolocation.clearWatch(gps.gpsTracker);
			gps.gpsTracker = false;
		}
		gps.gpsRunning = false;
	},
	addGPSListener: function(listenerID, listenerFunc) {
		gps.gpsListeners[listenerID] = listenerFunc;
	},
	removeGPSListener: function(listenerID) {
		delete gps.gpsListeners[listenerID];
	},
	pauseGPS: function() {
		if (gps.gpsRunning) {		
			gps.stopGpsTracker();
		}
	},
	restartGPS: function() {
		if (gps.gpsRunning) {
			gps.startGpsTracker();
		}
	}

}















if (!navigator.notification) {
	navigator.notification = {};
}
if(!navigator.notification.confirm) {
	navigator.notification.confirm = function(msg, callback, title, buttons) {
		if (confirm(msg)) {
			callback(1);
		}
	}
}
if(!navigator.notification.alert) {
	navigator.notification.alert = function(msg) {
		alert(msg);
	}
}












function createDashboardStats(rounds) {
		
	var standardStats = {
					Fairway: {
						total: 0,
						center: 0,
						right: 0,
						left: 0,
						centerPercent: 'NA',
						rightPercent: 'NA',
						leftPercent: 'NA'
					},
					Accuracy: {
						total: 0,
						center: 0,
						right: 0,
						left: 0,
						long: 0,
						short: 0,			
						centerPercent: 'NA',
						rightPercent: 'NA',
						leftPercent: 'NA',
						longPercent: 'NA',
						shortPercent: 'NA'				
					},
					Round: {
						totalgir: 0,
						totalholes: 0,
						totalrounds: 0,
						totalbird: 0,
						totalpar: 0,
						totalbog: 0,
						total2bog: 0,
						total3bog: 0,
						scramble: 0,
						totalpar3: 0,
						totalpar4: 0,
						totalpar5: 0,
						countpar3: 0,
						countpar4: 0,
						countpar5: 0,
						par3avg: 'NA',
						par4avg: 'NA',
						par5avg: 'NA',
						sand: 0,
						sandsave: 0,
						penalty: 0,
						girPercent: 'NA',
						scramblePercent: 'NA',
						sandsavePercent: 'NA',
						sandhitPercent: 'NA',
						penaltyPercent: 'NA',
						birdPercent: 'NA',
						parPercent: 'NA',
						bogPercent: 'NA',
						bog2Percent: 'NA',
						bog3Percent: 'NA',
						avgscore: 'NA',
						totalscore: 0

					},
					Puttavg: {
						putts: 0,
						putt0: 0,
						putt1: 0,
						putt2: 0,
						putt3: 0,
						puttavg: 0,
						putt0avg: 0,
						putt1avg: 0,
						putt2avg: 0,
						putt3avg: 0,
						girputts: 0,
						girputtavg: 0
					}
				};

	var todaysDate = new Date();
	var startThisYear = new Date(todaysDate.getFullYear(), 0, 1);
	var endThisYear = todaysDate;
	var startLastYear = new Date(todaysDate.getFullYear() - 1, 0, 1);
	var endLastYear = new Date(todaysDate.getFullYear(), 0, 1);

	var userStatConfig = {
				thisYear: {
					roundlimit: false,
					dateStart: startThisYear,
					dateEnd: endThisYear
				},
				lastYear: {
					roundlimit: false,
					dateStart: startLastYear,
					dateEnd: endLastYear
				},
				last20: {
					roundlimit: 20,
					dateStart: false,
					dateEnd: false
				},
				last5: {
					roundlimit: 5,
					dateStart: false,
					dateEnd: false
				}
			};

	var userStats = {};
	
	
	
	if (rounds.length > 0) {
		$.each(userStatConfig, function(statkey, stat) {
			
			userStats[statkey] = {};
			$.extend(true, userStats[statkey], standardStats);

			var round_count = 0;

			$.each(rounds, function(i, round) {
				round_count++;
				var countThisRound = false;
				if (stat.roundlimit && round_count <= stat.roundlimit) {
					countThisRound = true;
				}
				var round_date = new Date(parseApiDate(round.Round.date));

				if (stat.dateEnd && stat.dateStart && round_date.getTime() <= stat.dateEnd.getTime() && round_date.getTime() >= stat.dateStart.getTime()) {
					countThisRound = true;
				}
				else if (stat.dateEnd && !stat.dateStart && round_date.getTime() <= stat.dateEnd.getTime()) {
					countThisRound = true;
				}
				else if (stat.dateStart && !stat.dateEnd && round_date.getTime() >= stat.dateStart.getTime()) {
					countThisRound = true;
				}

				if (countThisRound) {
					userStats[statkey].Round.totalrounds++;
					
					$.each(round.Round.Playedhole, function(j, playedhole) {
				
						if (playedhole.fairway !== null) {
							userStats[statkey].Fairway.total++;
							if (playedhole.fairway < 0) {
								userStats[statkey].Fairway.left++;
							}
							else if (playedhole.fairway > 0) {
								userStats[statkey].Fairway.right++;
							}
							else {
								userStats[statkey].Fairway.center++;
							}
						}
					
						if (playedhole.gir !== null) {
							userStats[statkey].Accuracy.total++;
							if (playedhole.gir == 1) {
								userStats[statkey].Accuracy.long++;
							}
							else if (playedhole.gir == 2) {
								userStats[statkey].Accuracy.right++;
							}
							else if (playedhole.gir == 3) {
								userStats[statkey].Accuracy.short++;
							}
							else if (playedhole.gir == 4) {
								userStats[statkey].Accuracy.left++;
							}
							else {
								userStats[statkey].Accuracy.center++;
							}
						}
					
						userStats[statkey].Round.totalholes++;
						
						if (playedhole.Hole.par > 0) {
							if (parseInt(playedhole.score) - parseInt(playedhole.putts) <= parseInt(playedhole.Hole.par) - 2) {
								userStats[statkey].Round.totalgir++;
								userStats[statkey].Puttavg.girputts += parseInt(playedhole.putts);
								if (playedhole.sand > 0) {
									userStats[statkey].Round.sandsave++;
								}
								
							}
							else {
									// look for scramble here.
								if (parseInt(playedhole.score) <= parseInt(playedhole.Hole.par)) {
									userStats[statkey].Round.scramble++;
									if (playedhole.sand > 0) {
										userStats[statkey].Round.sandsave++;
									}
								}
							}
							
							
							if (playedhole.sand > 0) {
								userStats[statkey].Round.sand++;
							}
							if (playedhole.penalty > 0) {
								userStats[statkey].Round.penalty++;
							}
							
							
							if (parseInt(playedhole.Hole.par) == 3) {
								userStats[statkey].Round.totalpar3 += playedhole.score;
								userStats[statkey].Round.countpar3++;
							}
							if (parseInt(playedhole.Hole.par) == 4) {
								userStats[statkey].Round.totalpar4 += playedhole.score;
								userStats[statkey].Round.countpar4++;
							}
							if (parseInt(playedhole.Hole.par) == 5) {
								userStats[statkey].Round.totalpar5 += playedhole.score;
								userStats[statkey].Round.countpar5++;
							}
							
							
							if ((parseInt(playedhole.score) - parseInt(playedhole.Hole.par)) == -1) {
								userStats[statkey].Round.totalbird++;
							}
							if ((parseInt(playedhole.score) - parseInt(playedhole.Hole.par)) == 0) {
								userStats[statkey].Round.totalpar++;
							}
							if ((parseInt(playedhole.score) - parseInt(playedhole.Hole.par)) == 1) {
								userStats[statkey].Round.totalbog++;
							}
							if ((parseInt(playedhole.score) - parseInt(playedhole.Hole.par)) == 2) {
								userStats[statkey].Round.total2bog++;
							}
							if ((parseInt(playedhole.score) - parseInt(playedhole.Hole.par)) >= 3) {
								userStats[statkey].Round.total3bog++;
							}
													
						}
					
					
						userStats[statkey].Puttavg.putts += playedhole.putts;
						if (playedhole.putts == 0) {
							userStats[statkey].Puttavg.putt0++;
						}
						else if (playedhole.putts == 1) {
							userStats[statkey].Puttavg.putt1++;
						}
						else if (playedhole.putts == 2) {
							userStats[statkey].Puttavg.putt2++;
						}
						else {
							userStats[statkey].Puttavg.putt3++;
						}
					
						

					});

					userStats[statkey].Round.totalscore += parseInt(getEffectiveScore(round));
					
				}
			});

			if (userStats[statkey].Round.totalholes > 0) {
				userStats[statkey].Puttavg.putt0avg = Math.round(userStats[statkey].Puttavg.putt0 / userStats[statkey].Round.totalholes * 100) + '%';
				userStats[statkey].Puttavg.putt1avg = Math.round(userStats[statkey].Puttavg.putt1 / userStats[statkey].Round.totalholes * 100) + '%';
				userStats[statkey].Puttavg.putt2avg = Math.round(userStats[statkey].Puttavg.putt2 / userStats[statkey].Round.totalholes * 100) + '%';
				userStats[statkey].Puttavg.putt3avg = Math.round(userStats[statkey].Puttavg.putt3 / userStats[statkey].Round.totalholes * 100) + '%';
		
				userStats[statkey].Puttavg.puttavg = (userStats[statkey].Puttavg.putts / userStats[statkey].Round.totalholes).toFixed(1);		
				if (userStats[statkey].Round.totalgir > 0) {
					userStats[statkey].Puttavg.girputtavg = (userStats[statkey].Puttavg.girputts / userStats[statkey].Round.totalgir).toFixed(1);	
				}
			}
			
			
			if (userStats[statkey].Fairway.total > 0) {
				userStats[statkey].Fairway.centerPercent = Math.round(userStats[statkey].Fairway.center / userStats[statkey].Fairway.total * 100) + '%';
				userStats[statkey].Fairway.leftPercent = Math.round(userStats[statkey].Fairway.left / userStats[statkey].Fairway.total * 100) + '%';
				userStats[statkey].Fairway.rightPercent = Math.round(userStats[statkey].Fairway.right / userStats[statkey].Fairway.total * 100) + '%';
			}
			

			if (userStats[statkey].Accuracy.total > 0) {
				userStats[statkey].Accuracy.centerPercent = Math.round(userStats[statkey].Accuracy.center / userStats[statkey].Accuracy.total * 100) + '%';
				userStats[statkey].Accuracy.leftPercent = Math.round(userStats[statkey].Accuracy.left / userStats[statkey].Accuracy.total * 100) + '%';
				userStats[statkey].Accuracy.rightPercent = Math.round(userStats[statkey].Accuracy.right / userStats[statkey].Accuracy.total * 100) + '%';
				userStats[statkey].Accuracy.longPercent = Math.round(userStats[statkey].Accuracy.long / userStats[statkey].Accuracy.total * 100) + '%';
				userStats[statkey].Accuracy.shortPercent = Math.round(userStats[statkey].Accuracy.short / userStats[statkey].Accuracy.total * 100) + '%';
			}
			
			
			if (userStats[statkey].Round.sand > 0) {
				userStats[statkey].Round.sandsavePercent = Math.round(userStats[statkey].Round.sandsave / userStats[statkey].Round.sand * 100) + '%';
			}
			

			if (userStats[statkey].Round.totalholes > 0) {
				userStats[statkey].Round.girPercent = Math.round(userStats[statkey].Round.totalgir / userStats[statkey].Round.totalholes * 100) + '%';
			}
			

			var scramblePotential = userStats[statkey].Round.totalholes - userStats[statkey].Round.totalgir;
			if (scramblePotential > 0) {
				userStats[statkey].Round.scramblePercent = Math.round(userStats[statkey].Round.scramble / scramblePotential * 100) + '%';
			}
			
			if (userStats[statkey].Round.totalholes > 0) {
				userStats[statkey].Round.birdPercent = Math.round(userStats[statkey].Round.totalbird / userStats[statkey].Round.totalholes * 100) + '%';
				userStats[statkey].Round.parPercent = Math.round(userStats[statkey].Round.totalpar / userStats[statkey].Round.totalholes * 100) + '%';
				userStats[statkey].Round.bogPercent = Math.round(userStats[statkey].Round.totalbog / userStats[statkey].Round.totalholes * 100) + '%';
				userStats[statkey].Round.bog2Percent = Math.round(userStats[statkey].Round.total2bog / userStats[statkey].Round.totalholes * 100) + '%';
				userStats[statkey].Round.bog3Percent = Math.round(userStats[statkey].Round.total3bog / userStats[statkey].Round.totalholes * 100) + '%';
			}
			
			if (userStats[statkey].Round.countpar3 > 0) {
				userStats[statkey].Round.par3avg = (userStats[statkey].Round.totalpar3 / userStats[statkey].Round.countpar3).toFixed(1);
			}
			if (userStats[statkey].Round.countpar4 > 0) {
				userStats[statkey].Round.par4avg = (userStats[statkey].Round.totalpar4 / userStats[statkey].Round.countpar4).toFixed(1);
			}
			if (userStats[statkey].Round.countpar5 > 0) {
				userStats[statkey].Round.par5avg = (userStats[statkey].Round.totalpar5 / userStats[statkey].Round.countpar5).toFixed(1);
			}

			if (userStats[statkey].Round.totalholes > 0) {
				userStats[statkey].Round.penaltyPercent = Math.round(userStats[statkey].Round.penalty / userStats[statkey].Round.totalholes  * 100) + '%';
				userStats[statkey].Round.sandhitPercent = Math.round(userStats[statkey].Round.sand / userStats[statkey].Round.totalholes  * 100) + '%';
			}
			
			if (userStats[statkey].Round.totalrounds > 0) {
				userStats[statkey].Round.avgscore = parseFloat(userStats[statkey].Round.totalscore / userStats[statkey].Round.totalrounds).toFixed(1);
			}


		});
	}
	return userStats;
}





function collectScoring(golferIndex, currentUser, round_id, round_status) {
 	
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
//round_index_
	var playedholes = [];
	
	pageElm.find('.play-hole').each(function() {
		if ($(this).find('.play-hole-played').val() > 0) {
			playedholes.push({
				id: $(this).find('.round_index_'+golferIndex+' .play-hole-id').val(),
				hole_id: $(this).find('.play-hole-hole-id').val(),
				round_id: round_id,
				user_id: currentUser.User.id,
				tee_id: $(this).find('.play-hole-tee-id').val(),
				number: $(this).find('.play-hole-number').val(),
				score: parseInt($(this).find('.round_index_'+golferIndex+' .input-score-strokes').val()),
				putts: parseInt($(this).find('.input-score-putts').val()),
				gir: $(this).find('.round_index_'+golferIndex+' .input-score-gir').val(),
				fairway: $(this).find('.round_index_'+golferIndex+' .input-score-fairway').val(),
				sand: ($(this).find('.round_index_'+golferIndex+' .input-score-sand').prop('checked')) ? 1 : 0,
				penalty: ($(this).find('.round_index_'+golferIndex+' .input-score-penalty').prop('checked')) ? 1 : 0,
				played: $(this).find('.round_index_'+golferIndex+' .play-hole-played').val(),
				status: round_status,
				par: parseInt($(this).find('.play-hole-par').val())
			});
		}
	});	
	
	
	return playedholes;  
}
function getCurrentScore(index) {
	var page = myNavigator.getCurrentPage();
	var pageElm = $(page.element);
	var score = 0;
	pageElm.find('.play-hole .round_index_'+index).each(function() {
		if ($(this).find('.play-hole-played').val() > 0) {
			score += parseInt($(this).find('.input-score-strokes').val());
		}
	});
	return score;
}



function dUnits(abv) {
	if (typeof(abv) == 'undefined') {
		abv = true;
	}
	if (user.isMetric) {
		if (abv) {
			return 'm';
		}
		else {
			return 'Metres';
		}
	}
	else {
		if (abv) {
			return 'yds';
		}
		else {
			return 'Yards';
		}
	
	}
}

function toRad(theNumber) {
	return theNumber * (Math.PI / 180); 
}
function toDeg(theNumber) {
	return theNumber * 180 / Math.PI;
}
function calcDistance(from, to) {
	var lat1 = from.latitude;
	var lon1 = from.longitude;
	var lat2 = to.latitude;
	var lon2 = to.longitude;

	var R = 6371; // km
	var dLat = toRad(lat2-lat1);
	var dLon = toRad(lon2-lon1);
	var lat1 = toRad(lat1);
	var lat2 = toRad(lat2);

	var a = Math.sin(dLat/2) * Math.sin(dLat/2) +
			Math.sin(dLon/2) * Math.sin(dLon/2) * Math.cos(lat1) * Math.cos(lat2); 
	var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a)); 
	var d = R * c;	// in KM
	
	var distanceInMeters = d * 1000;
	var distanceInYards = metersToYards(distanceInMeters);	
	if (user.isMetric) {
		return distanceInMeters;
	}
	else {
		return distanceInYards;
	}
}
function calcBearing(from, to) {
	var lat1 = from.latitude;
	var lon1 = from.longitude;
	var lat2 = to.latitude;
	var lon2 = to.longitude;
	
	var dLon = lon2 - lon1;

	var y = Math.sin(dLon) * Math.cos(lat2);
	var x = Math.cos(lat1)*Math.sin(lat2) -
		Math.sin(lat1)*Math.cos(lat2)*Math.cos(dLon);
	var brng = toDeg(Math.atan2(y, x));
	
	return brng;
}
function yardsToMeters(distanceInYards) {
	return Math.round(distanceInYards / 1.09361);
}
function metersToYards(distanceInMeters) {
	return Math.round(distanceInMeters * 1.09361);
}



function sortUserTour(tourList, sortParam, sortDir) {
   
	tourList.sort(function(a, b) {
		var localSortParam = sortParam;
		if (sortDir == 'desc') {
			return (a.User[localSortParam] > b.User[localSortParam]) ? -1 : 1;
		}
		else {
			if (a.User[localSortParam] == null && b.User[localSortParam] == null) {
				localSortParam = 'created';
			}
			else if (a.User[localSortParam] == null || a.User[localSortParam] == '' || a.User[localSortParam] == 0) {
				return 1;
			}
			else if (b.User[localSortParam] == null || b.User[localSortParam] == '' || b.User[localSortParam] == 0) {
				return -1;
			}
			return (a.User[localSortParam] < b.User[localSortParam]) ? -1 : 1;    		
		}
	});
	
	return tourList;
}


function calcCourseHandicap(handicap, slope) {
	if (handicap && slope) {
		var handicap = Math.round((slope / 113) * handicap);
		if (handicap > 0) {
			return handicap;
		}
	}
	return handicap;
}


function getNetScore(round) {
	if (!round.Playedhole || round.Playedhole.length == 0) {
		return round;
	}
	
	round.Round.netscore = round.Round.score;
	
	$.each(round.Playedhole, function(i, playedhole) {
		round.Playedhole[i].netscore = round.Playedhole[i].score;
	});
	
	if (round.User && round.Tee) {
		if (round.User.gender == 1) {
			var courseHandicap = calcCourseHandicap(round.Round.handicap, round.Tee.slopefemale);
		}
		else {
			var courseHandicap = calcCourseHandicap(round.Round.handicap, round.Tee.slope);
		}
		
		var totalnetscore = 0;
		$.each(round.Playedhole, function(i, playedhole) {
			round.Playedhole[i].netscore = round.Playedhole[i].score;
		
			if (courseHandicap > 0) {
				if (playedhole.Hole.rating == null || playedhole.Hole.rating == 0) {
					playedhole.Hole.rating = playedhole.Hole.number;
				}
				
				if (playedhole.Hole.rating <= courseHandicap) {
					round.Playedhole[i].netscore--;
				}
				if ((playedhole.Hole.rating + 18) <= courseHandicap) {
					round.Playedhole[i].netscore--;
				}
				if ((playedhole.Hole.rating + (18 * 2)) <= courseHandicap) {
					round.Playedhole[i].netscore--;
				}
				if ((playedhole.Hole.rating + (18 * 3)) <= courseHandicap) {
					round.Playedhole[i].netscore--;
				}
			}
	
			totalnetscore += round.Playedhole[i].netscore; 
		
		
			if (round.Playedholes) {
				$.each(round.Playedholes, function(j, playedholes) {
					if (parseInt(round.Playedholes[j].number) == parseInt(round.Playedhole[i].number)) {
						round.Playedholes[j].netscore = round.Playedhole[i].netscore;
					}
				});
			}
		
		});
		
		round.Round.netscore = totalnetscore;
	}
	
	return round;
}
function getEffectiveScore(round) {

	if (round.Round.holes == 18) {
		return round.Round.score;
	}
	if (round.Round.scoringtype == 2) {
		return round.Round.score / round.Round.holes * 18;
	}
	var parPlayed = 0;
	var score = 0;
	var coursePar = round.Round.Tee.par;
	if (round.Round.Tee.holecount == 9) {
		coursePar = coursePar * 2;
	}
	$.each(round.Round.Playedhole, function(i, playedhole) {
		parPlayed += parseInt(playedhole.Hole.par);
		score += parseInt(playedhole.score);
	});

	var effscore = score / parPlayed * coursePar;
	return effscore;
}


function getScoreClass(score, par) {
	if (score <= 0 || score == '') {
		return '';
	}
	
	var scoreClass = '';				
	if (score <= par - 2) {
		scoreClass = 'score-eagle';
	}
	if (score == par - 1) {
		scoreClass = 'score-birdie';
	}
	if (score == par) {
		scoreClass = 'score-par';
	}
	if (score == par + 1) {
		scoreClass = 'score-bogey';
	}
	if (score == par + 2) {
		scoreClass = 'score-dbogey';
	}
	if (score >= par + 3) {
		scoreClass = 'score-higher';
	}
	return scoreClass;
}


function setNewOfferCount(offerCount) {
	if (!app.isPrivateGuest(false)) {

		$('.home-action-promo .home-action-badge, .home-action-teetime .home-action-badge').removeClass('locked');
		$('.home-action-promo .home-action-badge').html(offerCount);

		if (typeof(offerCount) == 'undefined' || offerCount == 0 || offerCount == '') {
			$('.home-action-promo .home-action-badge').hide();
			$('.home-action-teetimes .home-action-badge').hide();
		}
		else {
			$('.home-action-promo .home-action-badge').show();
			$('.home-action-teetimes .home-action-badge').hide();
		}

			// was the element actually there?  If not, then call it again in a while.
		if ($('.home-action-promo .home-action-badge').length == 0) {
			setTimeout(function() {
				setNewOfferCount(offerCount);
			}, 2000);
		}
	}
}

function setGuestLocks() {
	if (app.isPrivateGuest(false)) {
		$('.home-action-promo .home-action-badge, .home-action-teetime .home-action-badge').addClass('locked');
		$('.home-action-promo .home-action-badge, .home-action-teetime .home-action-badge').html('<i class="fa fa-lock"></i>');
		
		$('.home-action-promo .home-action-badge, .home-action-teetime .home-action-badge').show();
		
	}
	else {
		$('.home-action-promo .home-action-badge, .home-action-teetime .home-action-badge').hide();
	}
}

function setMemberGuestGroup() {
	if (private_allow_guest) {
		if (user.isSignedIn()) {
			var is_member = 1;
			if (app.isPrivateGuest(false)) {
				is_member = 0;
			}
			var params = {
					tk: user.tk, uk: user.uk, pk: user.pk,
					club_id: whitelabel.course.club_id
				};
			$.ajax({
					   url: APIHOST + '/users/apisetmemberguest/' + is_member + '/',
					   method: 'POST',
					   dataType: 'json',
					   data: params,
					   success: function(data) {
					   		// nothing to report - it's a server thing
					   
					   },
					   error: function() {
							
					   }
					});
		}
	}
}


function getUserAvatar(theUser) {
	if (theUser.User && theUser.User.avatar) {
		if (theUser.User.avatar.indexOf('http') >= 0) {
			return theUser.User.avatar;
		}
		else {
			return APIHOST + '/' + theUser.User.avatar;
		}    		
	}
	else {
		return default_avatar;
	}    
}
function getClubAvatar(theClub) {
	if (theClub && theClub.Club && theClub.Club.avatar) {
		if (theClub.Club.avatar.indexOf('http') >= 0) {
			return theClub.Club.avatar;
		}
		if (theClub.Club.avatar == default_club_avatar) {
			return theClub.Club.avatar;
		}
		else {
			return APIHOST + '/' + theClub.Club.avatar;
		}    		
	}
	else {
		return default_club_avatar;
	}    
}



function toApiDate(date) {
	var month = date.getMonth() + 1;
	return date.getFullYear() + '-' + month + '-' + date.getDate();
}
function toApiDateTime(date) {
	var month = date.getMonth() + 1;
	return date.getFullYear() + '-' + month + '-' + date.getDate() + ' ' + date.getHours() + ':' + date.getMinutes + ':00';
}
function toStandardDate(date) {
	var month = date.getMonth() + 1;
	return month + '/' + date.getDate() + '/' + date.getFullYear();
}
function toNiceDateTime(date) {
	dateString = month_names[date.getMonth()] + ' ' + date.getDate() + ', ' + date.getFullYear();
	return dateString;
}
function parseApiDate(dateString) {
	var t = dateString.split(/[- :]/);
	if (t.length == 3) {
		return new Date(t[0], t[1]-1, t[2], 0, 0, 0);
	}
	return new Date(t[0], t[1]-1, t[2], t[3], t[4], t[5]);
}
function parseStandardDate(dateString) {
	var t = dateString.split(/[\/]/);
	if (t.length == 3) {
		return new Date(t[2], t[0]-1, t[1], 0, 0, 0);
	}
	return new Date(t[2], t[0]-1, t[1], 0, 0, 0);
}
var month_names = new Array("Jan", "Feb", "Mar", 
									"Apr", "May", "Jun", "Jul", "Aug", "Sep", 
									"Oct", "Nov", "Dec");






function validateEmail(email) 
{ 
	email = $.trim(email);
	var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/ 
	return email.match(re) 
}



function sendEmail(title, message, email_addresses) {
	var mailto = 'mailto:?subject='+encodeURIComponent(title)+'&to='+encodeURIComponent(email_addresses.join(','))+'&body='+ encodeURIComponent(message);
	
	if ((isIOS || isAndroid)) {
		window.plugins.socialsharing.shareViaEmail(
				message,
				title,
				email_addresses,
				null,	// cc
				null,	// bcc
				null,	// files
				function(succ) {
					// onSuccess
				},
				function(err) {
					// onError
					console.log("-------- shareViaEmail ERROR ---------");
					console.log(JSON.stringify(err));
					if (isIOS) {
						document.location.href = mailto;
					}
					else {
						window.open(mailto, '_system');
					}

				}
			);
	}
	else {
		if (isIOS) {
			document.location.href = mailto;
		}
		else {
			window.open(mailto, '_system');
		}
	}
}
function shareLink(title, message, link, image) {
	if (isIOS) {
			// old:  cordova plugin add https://github.com/leecrossley/cordova-plugin-social-message.git
			// cordova plugin add https://github.com/EddyVerbruggen/SocialSharing-PhoneGap-Plugin.git
		window.plugins.socialsharing.share(message, title, image, link);
				
	}
	else if (isAndroid) {
		window.plugins.socialsharing.share(message, title, image, link);
	}
	else {
		var shareType = function(buttonIndex) {
			if (typeof(link) != 'undefined') {
				var finalMessage = message + ' ' + link;
			}
			else {
				var finalMessage = message;
			}
			if (buttonIndex == 1) {
				window.open('https://twitter.com/intent/tweet?text='+ encodeURIComponent(finalMessage), 'share window');
			}
			if (buttonIndex == 2) {
				window.open('https://www.facebook.com/sharer/sharer.php?u='+ encodeURIComponent(finalMessage), 'share window');
			}
			if (buttonIndex == 3) {
				window.open('mailto:?subject='+encodeURIComponent(title)+'&body='+ encodeURIComponent(finalMessage), 'share window');
			}
		
		};
		var options = {
			'title': title,
			'buttonLabels': [
				'Twitter',
				'Facebook',
				'Email'
			]
		};
		showActionSheet(options, shareType);
	}
}



function showPhoto(photo) {
	if (typeof(PhotoViewer) != 'undefined') {
		setTimeout(function() {
			PhotoViewer.show(photo);
		}, 10);
	}
	else {
		photomodal.show();
		setTimeout(function() {
			$('#photomodalspinner').css({ 
									'height': $(window).height() + 'px'
								});
			$('#photomodalcontainer').css({ 
									'background-image': 'url('+photo+')',
									'background-position': 'center center',
									'height': $(window).height() + 'px'
								});
		}, 100);
	}
}




var beaconChangeListener = function() { };
var beaconRegions =
[
    {
        id: 'OG7e',
        uuid:'f7826da6-4fa2-4e98-8024-bc5b71e0893e',
        major: 15277,
        minor: 20494,
        status: {}
    },
    {
        id: 'dbdQ',
        uuid:'f7826da6-4fa2-4e98-8024-bc5b71e0893e',
        major: 14275,
        minor: 23218,
        status: {}
    },
    {
        id: 'p6aD',
        uuid:'f7826da6-4fa2-4e98-8024-bc5b71e0893e',
        major: 23837,
        minor: 64328,
        status: {}
    }
];
var beaconRegistered = false;
function registerBeaconEvents() {
	
	if (typeof(cordova) == 'undefined') {
		return false;
	}
	if (user.isSignedIn() && !beaconRegistered && typeof(cordova.plugins.locationManager) != 'undefined') {
		console.log('Beacons');

		beaconRegistered = true;
		cordova.plugins.locationManager.requestAlwaysAuthorization(); 

		var delegate = new cordova.plugins.locationManager.Delegate();

		delegate.didDetermineStateForRegion = function (pluginResult) {
		    //console.log('[DOM] didDetermineStateForRegion: ', pluginResult);
		    	// This triggers when we are close to a beacon
		    console.log('++++*************** state change!!! +++++++++++=');
		    console.log(pluginResult);
		    	//https://github.com/katzer/cordova-plugin-local-notifications
		    
	        
		};

		delegate.didStartMonitoringForRegion = function (pluginResult) {
		    //console.log('[DOM] didStartMonitoringForRegion: ', pluginResult);
		};

		delegate.didRangeBeaconsInRegion = function (pluginResult) {
			for (var r in beaconRegions) {
				if (beaconRegions[r].id == pluginResult.region.identifier && pluginResult.region.typeName == 'BeaconRegion') {
					beaconRegions[r].status = pluginResult;
				}
			}
			beaconChangeListener(beaconRegions);
			//console.log('[DOM] didRangeBeaconsInRegion: ', pluginResult);
			//console.log('************ WATCH HERE ***********');
			//console.log(JSON.stringify(pluginResult));
		};

		delegate.monitoringDidFailForRegionWithError = function (pluginResult) {
		};
		delegate.didExitRegion = function (pluginResult) {
			// Exited a region

		};
		delegate.didEnterRegion = function (pluginResult) {
			console.log('++++*************** ENTERED A REGION!!! +++++++++++=');
		    console.log(pluginResult);
		    navigator.notification.alert("We detected a beacon.  " + pluginResult.region.identifier);
		    
		};
		delegate.peripheralManagerDidStartAdvertising = function (pluginResult) {
		};
		delegate.peripheralManagerDidUpdateState = function (pluginResult) {
		};
		delegate.didChangeAuthorizationStatus = function (pluginResult) {
		};





		cordova.plugins.locationManager.setDelegate(delegate);
		
		for (var r in beaconRegions) {
		    var region = beaconRegions[r]

		    var beaconRegion = new cordova.plugins.locationManager.BeaconRegion(
		        region.id, region.uuid, region.major, region.minor)

		    // Start monitoring.
		    cordova.plugins.locationManager.startMonitoringForRegion(beaconRegion)
		        .fail(console.error)
		        .done()

		    // Start ranging.
		    cordova.plugins.locationManager.startRangingBeaconsInRegion(beaconRegion)
		        .fail(console.error)
		        .done()
		}

		
	}

}
/*
var geofences = [
	{
		id:             'startround', //A unique identifier of geofence
	    latitude:       51.042078, //Geo latitude of geofence
	    longitude:      -114.036037, //Geo longitude of geofence
	    radius:         50, //Radius of geofence in meters
	    transitionType: 3, //Type of transition 1 - Enter, 2 - Exit, 3 - Both
	    notification: {         //Notification object
	        id:             1, //optional should be integer, id of notification
	        title:          'Inglewood?', //Title of notification
	        text:           'Would you like to score your round.', //Text of notification
	        smallIcon:      null, //Small icon showed in notification area, only res URI
	        icon:           null, //icon showed in notification drawer
	        openAppOnClick: true, //is main app activity should be opened after clicking on notification
	        //vibration:      [Integer], //Optional vibration pattern - see description
	        data:           {'location': 'Inglewood'}  //Custom object associated with notification
	    }
	}
]; */

var geofences = [];
var geofence_tracking = {};
var geofencingEnabled = false;
function setupGeofencing() {
	if (typeof(window.geofence) != 'undefined' && show_geofencing) {

		console.log('******** Geofences - Loading *******');
			// get the geofences

		if (window.localStorage['geofence_tracking']) {
			try {
				geofence_tracking = JSON.parse(window.localStorage['geofence_tracking']);
			}
			catch (err) {
				geofence_tracking = {};
			}
		}

		$.ajax({
				url: APIHOST + '/courses/apigeofences/'+whitelabel.course.club_id+'/',
				method: 'GET',
				cache: false,
				data: { },
				success: function(data) {
					if (data.data) {
						


						console.log('**** We have recieved the Geofences !!!! ****');
							// we have data - let's build the geofences
						// clear the current geofences
						geofences = [];
						$.each(data.data, function(i, gdata) {
							var radius = 50;
							if (typeof(gdata.Geofence.radius) != 'undefined') {
								radius = gdata.Geofence.radius;
							}
							var ping_url = APIHOST + '/courses/apigeofencehit/' + gdata.Geofence.id + '/' + user.uk + '/';
							var this_geofence = {
									id:             gdata.Geofence.id, //A unique identifier of geofence
								    latitude:       gdata.Geofence.lat, //Geo latitude of geofence
								    longitude:      gdata.Geofence.lng, //Geo longitude of geofence
								    radius:         radius, //Radius of geofence in meters
								    transitionType: parseInt(gdata.Geofence.action), //Type of transition 1 - Enter, 2 - Exit, 3 - Both
								    url: 			ping_url,
								    notification:   {         // Notification object - doesn't work without a notification
								        id:             parseInt(gdata.Geofence.id), //optional should be integer, id of notification
								        title:          gdata.Geofence.title, //Title of notification
								        text:           gdata.Geofence.message, //Text of notification
								        smallIcon:      null, //Small icon showed in notification area, only res URI
								        icon:           null, //icon showed in notification drawer
								        openAppOnClick: true, //is main app activity should be opened after clicking on notification
								        //vibration:      [Integer], //Optional vibration pattern - see description
								        data:           { 
								        	'url': ping_url, 
								        	'type': gdata.Geofence.type, 
								        	'offer_id': gdata.Geofence.offer_id, 
								        	'id': gdata.Geofence.id 
								        }  //Custom object associated with notification
								    }
								};
							geofences.push(this_geofence);

							console.log('**** Fence to Load ****', this_geofence);
						});



						window.geofence.initialize().then(function() {
							console.log('*** Geofence Plugin Initialized *****');

							
							// remove all, then add in.
							window.geofence.removeAll(function() {
								console.log('**** Geofences Removed');
							}, function(reason) {
								console.log('**** Removing geofences failed', reason);
							});

							console.log('*** Geofence Plugin  - AFTER removeAll. *****');


							$.each(geofences, function(i, geofence) {
								
								console.log('**** Adding/updating Geofence For: ' + geofence.id + ' - ' + geofence.notification.title);
		
								window.geofence.addOrUpdate(geofence).then(
									function() {
										console.log('**** Adding geofence success');
									}, function(reason) {
										console.log('**** Adding geofence failed', reason);
									});
							

							});
							
							console.log('*** Geofence Plugin  - They should be added now. *****');
							
						/*	window.geofence.onTransitionReceived = function (geofences) {
									// this only works when the app is running
									// does not work when it's in the background
									// So we need to find a way for this to work
							    geofences.forEach(function (geo) {
							        console.log('Geofence transition detected', geo);
							    });
							}; */

							


							window.geofence.getWatched(function (geofencesJson) {
									// at this point we are going to remove any that don't match with the server
								console.log('**** Watched GeoFences ');
								//console.log("The watched geofences", geofencesJson);

							    var watched_geofences = JSON.parse(geofencesJson);

							    $.each(watched_geofences, function(i, gf) {
							    	var remove_fence = true;
							    	$.each(geofences, function(j, geofence) {
							    		if (gf.id == geofence.id) {
							    			remove_fence = false;
							    		}
							    	});
							    	
							    	if (remove_fence) {
										console.log('remove fence '+gf.id);
										window.geofence.remove(gf.id, function() {
									    	console.log('Removed a notification after trigger');
									    }, function() {
									    	console.log('Error Removing a notification after trigger ');
									    });
							    	}
							    	else {
							    		console.log('keep fence '+gf.id);
							    	}
								
							    });
							});


							

							geofencingEnabled = true;

						

						}, function (error) {
						    console.log('***** Initializing geofences FAILED', error);
						});

					}
					
				},
				error: function() {
					console.log('**** ERROR - getting Geofences from ajax ****');
				}
			});

		
	}
}

function setupGeofenceClickListener() {
	if (typeof(window.geofence) != 'undefined') {
		console.log('***** Overwriting setupGeofenceClickListener for awesomeness!!');
/*		window.geofence.onNotificationClicked = function (notificationData) {
			alert('Geofence Event Happened!!');

		    console.log('App opened from Geo Notification!', notificationData);

		    navigator.notification.alert(JSON.stringify(notificationData));

		    var offer_id = 0;
		    if (notificationData.notification.data.type == 1) {
		    	setTimeout(function() {
		    		myNavigator.pushPage('offer.html', { offer_id: notificationData.notification.data.offer_id });
		    	}, 500);
		    	offer_id = notificationData.notification.data.offer_id;
		    }

		    trackGeofence(offer_id);

		    	// Added this one to the tracking
		    var dateActioned = new Date();
		    geofence_tracking[notificationData.notification.id] = dateActioned.getTime();

		    	// remove this geofence so it doesn't trigger for a while.
		    window.geofence.remove(notificationData.notification.id, function() {
		    	console.log('Removed a notification after trigger');
		    }, function() {
		    	console.log('Error Removing a notification after trigger ');
		    });

		}; */

	/*	window.geofence.onTransitionReceived = function (geofences) {
				// this only works when the app is running
				// does not work when it's in the background
				// So we need to find a way for this to work
		    geofences.forEach(function (geo) {
		        console.log('Geofence transition detected', geo);
		        alert('Geofence transition detected');
		        alert(JSON.stringify(geo));

		        window.geofence.remove(geo.id, function() {
			    	console.log('Removed a notification after trionTransitionReceivedgger');
			    }, function() {
			    	console.log('Error Removing a notification after onTransitionReceived ');
			    });

		    }); 
		}; */
	}
}


	// https://github.com/phonegap/phonegap-plugin-push
var pushRegistered = false;
var pushService = {};
function registerPushNotificationEvents() {
	if (user.isSignedIn() && !pushRegistered && typeof(PushNotification) != 'undefined') {
	//if (!pushRegistered && typeof(PushNotification) != 'undefined') {

		
		pushRegistered = true;

		pushService = PushNotification.init(
						{ 
							"android": {"senderID": pushKey},
         					"ios": {
         						"alert": "true", 
         						"badge": "true", 
         						"sound": "true",
         						"clearBadge": "true"
         					}
         				} 
         			);
         
        pushService.on('registration', function(data) {
         	registerDevice(data.registrationId);
        });
        
        pushService.on('notification', function(data) {
         	if (data.additionalData.round) {
         		if (data.additionalData.foreground) {
         			navigator.notification.confirm(data.message,
							function(results) {
								if (results == 1) {
									myNavigator.pushPage('round.html', { round_id: data.additionalData.round });
								}
							},
							whitelabel.app_name,
							['View Round', 'Close']);
         		}
         		else {
	         		//pushService.setApplicationIconBadgeNumber(function() {}, function() {}, 1);
	         		myNavigator.pushPage('round.html', { round_id: data.additionalData.round });
				}
         	}
         	if (data.additionalData.user) {
          		if (data.additionalData.foreground) {
         			navigator.notification.confirm(data.message,
							function(results) {
								if (results == 1) {
									myNavigator.pushPage('user.html', { user_username: data.additionalData.user });
								}
							},
							whitelabel.app_name,
							['Go To Profile', 'Close']);
         		}
         		else {
	         		//pushService.setApplicationIconBadgeNumber(function() {}, function() {}, 1);
	         		myNavigator.pushPage('user.html', { user_username: data.additionalData.user });
				}        	
         	}
         	if (data.additionalData.offer) {
         		if (data.additionalData.foreground) {
         			navigator.notification.confirm(data.message,
							function(results) {
								if (results == 1) {
									myNavigator.pushPage('offer.html', { offer_id: data.additionalData.offer });
								}
							},
							whitelabel.app_name,
							['View Offer', 'Close']);
         		}
         		else {
	         		//pushService.setApplicationIconBadgeNumber(function() {}, function() {}, 1);
	         		setTimeout(function() {
	         			myNavigator.pushPage('offer.html', { offer_id: data.additionalData.offer });
	         		}, 400);
	         		
				}
				trackPush(data.additionalData.offer);
         	}
         	if (data.additionalData.url) {
         		if (data.additionalData.foreground) {
         			navigator.notification.confirm(data.message,
							function(results) {
								if (results == 1) {
									openCustomLink(data.additionalData.url);
								}
							},
							whitelabel.app_name,
							['View', 'Close']);
         		}
         		else {
	         		//pushService.setApplicationIconBadgeNumber(function() {}, function() {}, 1);
	         		setTimeout(function() {
	         			openCustomLink(data.additionalData.url);
	         		}, 400);
	         		
				}
				trackPush(data.additionalData.url);
         	}
         	if (data.additionalData.alert) {
         		if (data.additionalData.foreground) {
         			navigator.notification.confirm(data.message,
							function(results) {
								if (results == 1) {
									//navigator.notification.alert(data.additionalData.message, function() {}, "");
								}
							},
							whitelabel.app_name,
							['Close']);
         		}
         		else {
	         		//pushService.setApplicationIconBadgeNumber(function() {}, function() {}, 1);
	         		//navigator.notification.alert(data.message, function() {}, whitelabel.app_name);
				}
				trackPush(0);
         	}
         	if (data.additionalData.club) {
         			// not implemented yet
          		if (data.additionalData.foreground) {
         		/*	navigator.notification.confirm(data.message,
							function(results) {
								if (results == 1) {
									myNavigator.pushPage('club.html', { club_id: event.club });
								}
							},
							whitelabel.app_name,
							['Go To Course', 'Close']); */
         		}
         		else {
	         		//myNavigator.pushPage('club.html', { club_id: v });
				}        	
         	}
        });
        
        

        // later we will make another welcome screen for beacon stuff:
        //registerBeaconEvents();

        pushService.on('error', function(data) {
         		
        });
	}  
	else {
		//console.log('*********** PUSH Registration SKIPPED **************');
	} 
}

function deviceIsPushRegistered(callback) {
	if (pushRegistered && typeof(PushNotification) != 'undefined') {
		if (pushService) {
			PushNotification.hasPermission(function(data) {
			    if (data.isEnabled) {
			        callback(true);

			    }
			    else {
			    	callback(false);
			    }
			});
			return true;
		}
	}
	callback(false);
	return false;
}

function registerDevice(token) {
	var data = { 
				token: token,
				deviceType: (isAndroid) ? 1 : 0
			};
	
	data.tk = user.tk;
	data.uk = user.uk;
	data.pk = user.pk;
	if (is_club_app) {
		data.club_id = whitelabel.course.club_id;
	}

	$.ajax({
			   url: APIHOST + '/users/apiregisterdevice/',
			   method: 'POST',
			   data: data,
			   success: function(data) {
			   		console.log(data);
					// We are registered.  Don't care here.  The server cares though
			   },
			   error: function() {
					// no biggy.  Just no push here for now.
			   }
			});
			
}
    


	// https://github.com/EddyVerbruggen/Custom-URL-scheme
	// offcourse://round/id
	// offcourse://user/username
	// offcourse://user/username
function handleOpenURL(url) {
	setTimeout(function() {
		user.checkAuth(function() {
			// auth good
			 if (url.indexOf(whitelabel.launchmyapp_scheme+'://' > -1)) {
				var url_chunks = url.split('//');
				if (url_chunks.length == 2) {
					var intent = url_chunks[1].split('/');
					if (intent.length >= 2) {
						if (intent[0] == 'round') {
							myNavigator.pushPage('round.html', { round_id: intent[1] });
						}
						if (intent[0] == 'user') {
							myNavigator.pushPage('user.html', { user_username: intent[1] });
						}
					}
				}
			  } else {
				//alert("ignore intent: " + url);
			  }
		}, 
		function(err) {
			// do nothing
		}, 
		function() {
			// No need for this	
		});
		 
	}, 800);
}









function showActionSheet(options, func) {
	if (isWeb) {
	
		var endTransitionName = {
			'WebkitTransition' : 'webkitTransitionEnd',
			'OTransition' : 'oTransitionEnd',
			'msTransition' : 'MSTransitionEnd',
			'transition' : 'transitionend'
		};
		var transitionEventName = endTransitionName[ Modernizr.prefixed( 'transition' ) ];

		var actionSheet = $(".action-sheet");
		actionSheet.height($(window).height() + 'px');
		
		var action_buttons = '';
		$.each(options.buttonLabels, function(i, val) {
			action_buttons += '<button type="button" class="button button--outline button--large actionsheet-btn" data-index="'+i+'">'+val+'</button>';
		});
		actionSheet.find('.action-btns').html(action_buttons);
		
		actionSheet.find('.action-btns .actionsheet-btn').click(function() {
			var dataIndex = $(this).attr('data-index');
			var btnIndex = parseInt(dataIndex) + 1;
			func(btnIndex);
			
			actionSheet.removeClass("open").one(transitionEventName, function () {
				actionSheet.hide();
			});	
		});
		
		actionSheet.find(".cancel").click(function(){	    
			//rimuoviamo la classe che scatena l'effetto, in modo da ritornare allo stato di partenza
			//all'evento di fine della transition reipostiamo tramite jQuery la propretà "display" = "none", 
			//che era quella dello stato iniziale        
			actionSheet.removeClass("open").one(transitionEventName, function () {
				actionSheet.hide();
			});		    	
		});	
		
		actionSheet.show();
		setTimeout(function () {
			actionSheet.addClass("open");
		}, 10);		    	
		

	}
	else {
		options['addCancelButtonWithLabel'] = 'Cancel';
		window.plugins.actionsheet.show(options, func);
	}
}



function initializeMap() {
	// just an initializer placeholder
}






function makeCircle(num, max, canvas, colors) {
	var scale = num/max;
	
	canvas.width = 100;
	canvas.height = 100;
	canvas.style.width = "50px";
	canvas.style.height = "50px";
	var ctx = canvas.getContext("2d");
	ctx.scale(2,2);

	var position = Math.round( (colors.length-1)*scale );
	position = position > colors.length-1 ? colors.length-1 : position;
	
	// create gradient
	var gradient=ctx.createLinearGradient(0,0,0,70);
	gradient.addColorStop( "0", colors[position] );
	gradient.addColorStop( "1" ,"#4F4733");

	// Fill with gradient
	ctx.strokeStyle=gradient;
	// draw the circle 
	ctx.lineWidth = 2;
	ctx.beginPath();
	ctx.arc(25,25,23,0,2*Math.PI);
	ctx.stroke();
}



/*
cordova.plugins.diagnostic.getLocationAuthorizationStatus(function(status){
   switch(status){
       case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
           console.log("Permission not requested");
           break;
       case cordova.plugins.diagnostic.permissionStatus.DENIED:
           console.log("Permission denied");
           break;
       case cordova.plugins.diagnostic.permissionStatus.GRANTED:
           console.log("Permission granted always");
           break;
       case cordova.plugins.diagnostic.permissionStatus.GRANTED_WHEN_IN_USE:
           console.log("Permission granted only when in use");
           break;
   }
}, function(error){
    console.error("The following error occurred: "+error);
});
*/

function requestAlwaysLocation(force) {
	if (typeof(cordova) != 'undefined' && typeof(cordova.plugins.diagnostic) != 'undefined') {
		if (typeof(force) == 'undefined') {
			force = false;
		}
		if (app.isOnboarded() || force) {
				// look into this:  https://github.com/dpa99c/cordova-diagnostic-plugin#location-module
				// requestLocationAuthorization   - always
			cordova.plugins.diagnostic.requestLocationAuthorization(function(status){
			    switch(status){
			        case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
			            console.log("Permission not requested");
			            break;
			        case cordova.plugins.diagnostic.permissionStatus.DENIED:
			            console.log("Permission denied");
			            break;
			        case cordova.plugins.diagnostic.permissionStatus.GRANTED:
			            console.log("Permission granted always");
			            break;
			        case cordova.plugins.diagnostic.permissionStatus.GRANTED_WHEN_IN_USE:
			            console.log("Permission granted only when in use");
			            break;
			    }
			}, function(error){
			    console.error(error);
			}, cordova.plugins.diagnostic.locationAuthorizationMode.ALWAYS);

		}
	}
}


function configBackgroundGeolocation(callback) {
	
	requestAlwaysLocation();

	if (typeof(BackgroundGeolocation) != 'undefined') {
		if (app.isOnboarded()) {
      		setupGeofencing();
      	}

		console.log('###### backgroundGeoLocation plugin was found - trying to configure ##########');

		/*
		backgroundGeolocation.configure(function() {
				// all good
				console.log('backgroundGeoLocation configured');
				backgroundGeolocation.stop();	// don't want it running by default yet.
				if (callback) {
					callback();
				}

					// This has notifications built in, so we will set it up here after regular notifications.
		        if (app.isOnboarded()) {
		      		setupGeofencing();
		      	}
		        setTimeout(function() {
					if (app.isOnboarded()) {
							// we will try again in 30 seconds because there is a problem with the plugin
						setupGeofencing();
					}
				}, 30000);
				setTimeout(function() {
					if (app.isOnboarded()) {
							// we will try again in 10 seconds because there is a problem with the plugin
						setupGeofencing();
					}
				}, 10000);

			}, function() {
				// failed geo
				console.log('backgroundGeoLocation Failed configuration');
			}, {
	        desiredAccuracy: 0,	// we need great accuracy
	        stationaryRadius: 20,	//Stationary radius in meters. When stopped, the minimum distance the device must move beyond the stationary location for aggressive background-tracking to engage.
	        distanceFilter: 1,	// The minimum distance (measured in meters) a device must move horizontally before an update event is generated.
	        debug: false, // <-- disable so it doesn't ask for notification permissions
	        stopOnTerminate: true, // <-- enable this to clear background location settings when the app terminates
	        activityType: 'Fitness',
	        notificationTitle: whitelabel.app_name,
	        notificationText: 'Continue scoring your round.',
	        startOnBoot: false,
	        saveBatteryOnBackground: false,
	        pauseLocationUpdates: false
	    });
	    */

	    //backgroundGeolocation.configure(function() {}, function() {}, {
	    BackgroundGeolocation.configure({
	        desiredAccuracy: 0,	// we need great accuracy
	        stationaryRadius: 20,	//Stationary radius in meters. When stopped, the minimum distance the device must move beyond the stationary location for aggressive background-tracking to engage.
	        distanceFilter: 1,	// The minimum distance (measured in meters) a device must move horizontally before an update event is generated.
	        debug: false, // <-- disable so it doesn't ask for notification permissions
	        stopOnTerminate: true, // <-- enable this to clear background location settings when the app terminates
	        activityType: 'Fitness',
	        notificationTitle: whitelabel.app_name,
	        notificationText: 'Continue scoring your round.',
	        startOnBoot: false,
	        saveBatteryOnBackground: false,
	        pauseLocationUpdates: false
	    });

	    setTimeout(function() {

	    	BackgroundGeolocation.stop();	// don't want it running by default yet.
	    	BackgroundGeolocation.isLocationEnabled(function(is_enabled) {
	    		if (is_enabled) {
	    			console.log('^^^^^^^^ backgroundGeoLocation LOCATION IS ENABLED');
	    			if (callback) {
						callback();
					}

						// This has notifications built in, so we will set it up here after regular notifications.
			        
			        setTimeout(function() {
						if (app.isOnboarded()) {
								// we will try again in 30 seconds because there is a problem with the plugin
							setupGeofencing();
						}
					}, 30000);
					setTimeout(function() {
						if (app.isOnboarded()) {
								// we will try again in 10 seconds because there is a problem with the plugin
							setupGeofencing();
						}
					}, 10000);
	    		}
	    		else {
	    			console.log('^^^^^^^^ backgroundGeoLocation LOCATION IS NOT ENABLED');
	    		}
	    	}, function() {

	    	});

	    	//backgroundGeolocation.showAppSettings();


		}, 2000);
	}
	else {
		console.log('###### backgroundGeoLocation plugin was not found ##########');
		if (app.isOnboarded()) {
			setupGeofencing();
		}
	}

	
}
function enableBackgroundGeolocation() {
	if (typeof(BackgroundGeolocation) != 'undefined') {
		console.log('enableBackgroundGeolocation');

		configBackgroundGeolocation(function() {
			BackgroundGeolocation.start(function() {
				console.log('====== backgroundGeolocation started ');
			}, function(error) {
				console.log('====== backgroundGeolocation failed to start '+error.code+' '+error.message);
			});

		});
	}
}
function disableBackgroundGeolocation() {
	if (typeof(BackgroundGeolocation) != 'undefined' && app.isOnboarded()) {
		BackgroundGeolocation.stop();
		killBackgroundGeolocation();
		//backgroundGeoLocation.finish();
	}
}
function killBackgroundGeolocation() {
	if (typeof(BackgroundGeolocation) != 'undefined' && app.isOnboarded()) {
		//BackgroundGeolocation.finish();
	}
}



function launchSmartWatch(callback, errCallback) {
	if(enableSmartWatch && app.caps.wearables) {
		enableBackgroundGeolocation();

		connectAppleWatch(function() {
			callback();
		});

		connectPebble(function() {
			console.log('Pebble is connected');
			setTimeout(function() {
				console.log('========================== launchPebbleApp =============================');
				launchPebbleApp(callback, errCallback);
			}, 800);
		}, function() {
			errCallback();
		});
	}
	else {
		if (!isPowerSaveMode()) {
			enableBackgroundGeolocation();
		}
	}
}
function stopSmartWatch() {
	disableBackgroundGeolocation();

	stopPebbleApp();
	
}
function isPowerSaveMode() {
	if (window.localStorage['powerSaveMode']) {
		var pst = window.localStorage['powerSaveMode'];
		if (pst == 1) {
			app.powerSavingMode = true;
		}
		else {
			app.powerSavingMode = false;
		}
	}
	return app.powerSavingMode;
}
function setPowerSaveMode(newMode) {	// true to set savings on
	app.powerSavingMode = newMode;
	if (app.powerSavingMode) {
		window.localStorage['powerSaveMode'] = 1;
	}
	else {
		window.localStorage['powerSaveMode'] = 0;
	}
	if (newMode) {
		disableBackgroundGeolocation();
	}
	else {
		enableBackgroundGeolocation();
	}
	return app.powerSavingMode;
}




var appleWatchConnected = false;
function initAppleWatch() {
    if (typeof(applewatch) != 'undefined') {
	    applewatch.init(function () {
	          // register for notifications
	          // TODO throws 'undefined is not a function'.. setTimeout ?
	//                        applewatch.registerNotifications(onNotificationRegistrationSuccess, onNotificationRegistrationError);
	        	console.log('---- applewatch initialized -----');
	        	appleWatchConnected = true;

	        	loadAppleWatch();
	        },
	        function (err) {
	          // an error occurred
	          alert("err: " + JSON.stringify(err));
	        });

	    applewatch.callback.onLoadAppMainRequest = connectAppleWatch;
/*	    applewatch.callback.onLoadAppMainRequest = onAppRequestsUpdate;
	    applewatch.callback.onLoadAppDetailRequest = onAppDetailPageRequestsUpdate;
	    applewatch.callback.onLoadGlanceRequest = onGlanceRequestsUpdate;
	    applewatch.callback.onLocalNotification = onNotificationReceived;
	    applewatch.callback.onRemoteNotification = onNotificationReceived;
	    */
	    applewatch.callback.onError = function (message) {
	      //feedback("Error: " + message);
	      console.log("Apple Watch Error: " + message);
	    };
	}
 }
function loadAppleWatch() {
	var payload = {
	      'label2': { // optional, max 2 lines
	        'value': 'Start your round in the Offcourse Golf app to get distances.',
	        'color': '#FFFFFF',
	        'font': {
	          'size': 16 // default 12
	        }
	      }
    };
	applewatch.loadAppMain(payload, function() {
		//success
	},
	function() {
		//error
	});
	console.log('==========================  Apple Watch App should have loaded!! =============================');
}

function onTableRowSelected(index) {
  console.log('Selected table row index: ' + index);
}
function loadAppleWatchDistances(distance, accuracy, hole) {

	var payload = {
	      'table': {
	     	'callback':'onTableRowSelected',
	     	'rows': [
		     	{
		     		'type': 'OneColumnRowType',
		     		'label': {
		     			'value': 'Hole ' + hole.number,
		     			'font': { // optional
							'size': 18
						}
		     		}
		     	},
		     	{
		     		'type': 'OneColumnRowType',
		     		'label': {
		     			'value': distance,
		     			'font': { // optional
							'size': 28
						}
		     		}
		     	},
		     	{
		     		'type': 'TwoColumnsRowType',
		     		'col1label': {
		     			'value': 'Par ' + hole.par,
		     			'font': { // optional
							'size': 12
						}
		     		},
		     		'col2label': {
		     			'value': 'HDCP ' + hole.rating,
		     			'font': { // optional
							'size': 12
						}
		     		}
		     	}
	     	]
	      }
    };
    if (appleWatchConnected) {
		applewatch.loadAppMain(payload);
	}
}

function connectAppleWatch(callback) {
	if (typeof(applewatch) != 'undefined') {
		console.log('========================== YES Apple Watch!! =============================');
		
		loadAppleWatch();

    	
		callback();
	}
	else {
		console.log('========================== No Apple Watch =============================');
	}
}



var pebbleConnected = false;
function connectPebble(success, err) {
	console.log('----- Do connectPebble() ');
	if (typeof(Pebble) != 'undefined') {
		Pebble.setAppUUID(pebbleUUID,
				function(event) {
					Pebble.onConnect(function(event) {
						console.log('PEBBLE watch connected');
						pebbleConnected = true;
						success(true);
					});
				},
				function(event) {
					//alert('watch disconnected');
					pebbleConnected = false;
					err();
				}
			);
	}
			
	
}

function launchPebbleApp(callback, errCallback) {
	console.log('Trying to launch PEBBLE app!!!!');
	if (pebbleConnected) {

		Pebble.launchApp(
				function(result){
					console.log('LAUNCHED THE PEBBLE APP!!!!');
					startThatListener();
					
					
					callback();
				},
				function(err){
					console.log('COULd NOT LAUNCH PEBBLE APP');
					console.log(err);
					errCallback();
				}
			);

		var gettingIncoming = false;
		function startThatListener() {
			startPebbleListener(function(message) {

					console.log('RECIEVED a PEBBLE MESSAGE');
					console.log(message);
					if (!gettingIncoming) {
						gettingIncoming = true;
						$.each(message, function(key, value) {
							if (key == 4) {
								setTimeout(function() {
									console.log(key);
									nextHole();
								}, 1);
								return false;
							}
							if (key == 5) {
								setTimeout(function() {
									prevHole();
								}, 1);
								return false;
							}
						});
						setTimeout(function() {
							gettingIncoming = false;
						}, 200);
					}
				});
		}
		
		setTimeout(function() {
		 	startThatListener();	
		}, 5000);

		
	}
	else {
		errCallback();
	}
}

function stopPebbleApp() {
	if (pebbleConnected) {
		Pebble.killApp(
				function(){
					console.log('Pebble app killed');
				},
				function(err){
					console.log(err);
					//alert(err);
				}
			);

	}
	
	pebbleConnected = false;
	
}

function sendToPebble(message, callback, errCallback) {
	if (pebbleConnected) {
		
		Pebble.sendAppMessage(
				message,
				callback,
				errCallback
			);
		
	}
}

var pebbleListenerStarted = false;
function startPebbleListener(callback) {
	if (pebbleConnected && !pebbleListenerStarted) {
		
		console.log('------------STARTED PEBBLE LISTENER----------------------');
		
		pebbleListenerStarted = true;
		Pebble.onAppMessageReceived(function(message) {
			callback(message);
		}, function(err) {
			console.log('------------MESSAGE RECIEVE ERROR----------------------');
			console.log(err);
		});
	
	}
}


function setSmartWatchValue(index, val, callback, failCallback) {
	var AppMessageDic = {
			'hole': 6,
			'par': 9,
			'index': 10,
			'distance': 7,
			'accuracy': 8,
			'holeinfo': 17
		};

	var pebbleInfoPackage = { };
	pebbleInfoPackage[AppMessageDic[index]] = val;
	
	var messageTry = 6;
	function sendMessage() {
		sendToPebble(
			pebbleInfoPackage,
			function() {
				console.log('Pebble Message sent good');
				callback();
			}, 
			function() {
				console.log('Pebble Message sent Bad');
				messageTry--;
				if (messageTry > 0) {
					setTimeout(function() {
						sendMessage();
					}, 320);
				}
				else {
					failCallback();
				}
			});	
	}
	sendMessage();
}


var holeLoadAttempts = 0;
function loadSmartWatchHoles(round, callback) {
	var details = '';
	var metric = round.User.metric;
	var holeCount = round.Tee.Hole.length;
	
	var successSending = true;

	if (round.Gps) {
		$.each(round.Tee.Hole, function(i, hole) {
			round.Tee.Hole[i].showFairway = (hole.par == 3) ? false : true;
			round.Tee.Hole[i].Gps = (round.Gps) ? round.Gps[hole.number] : false ;
		});
	}
	
	asyncLoop(round.Tee.Hole.length, 
		function(loop) {
			var i = loop.iteration();
			var hole = round.Tee.Hole[i];
			if (!hole.Gps) {
				hole.Gps = {
						'lat': '',
						'lng': ''
					};
			}		
			details = metric + "|"+holeCount+"|" + hole.number+","+hole.par+","+hole.rating+","+hole.Gps.lat+","+hole.Gps.lng;	
			//var pebbleInfoPackage = [{type:'string', key:2, value:details, length:1}];
			var pebbleInfoPackage = {2:details};
			console.log('send to pebble '+details);
			sendToPebble(
				pebbleInfoPackage,
				function() {
					console.log('send to pebble Good Next');
					setTimeout(function() {
						loop.next();	// good
					}, 250);
				}, 
				function() {
					console.log('send to pebble Bad Next');
					successSending = false;
					setTimeout(function() {
						loop.next();	// bad
					}, 300);
				});		
		}, 
		function() {
			if (successSending || holeLoadAttempts > 3) {
				holeLoadAttempts = 0;
				callback();
			}
			else {
				holeLoadAttempts++;
			}
		});
	
	
	
}
var firstTryHoleChange = true;
function changeSmartWatchHole(hole) {

	var combinedHoleInfo = hole.number+':'+hole.par+':'+hole.rating;
	setTimeout(function() {
		setSmartWatchValue('holeinfo', combinedHoleInfo, function() {  }, function() {  });
	}, 400);
/*	
	function sendHole() {
		setSmartWatchValue('hole', hole.number.toString(), function() {  }, function() { });
	}
	function sendPar() {
		setSmartWatchValue('par', hole.par.toString(), function() {  }, function() {  });
	}
	function sendIndex() {
		setSmartWatchValue('index', hole.rating.toString(), function() { }, function() { });
	}
	sendHole();
	setTimeout(function() {
		sendPar();
	}, 220);
	setTimeout(function() {
		sendIndex();
	}, 440);

*/
	
/*
function changeSmartWatchHole(holeNumber) {
	//var pebbleInfoPackage = [ {type:'string', key:3, value:holeNumber, length:1}];
	var pebbleInfoPackage = {3: holeNumber.toString()};
	sendToPebble(
		pebbleInfoPackage,
		function() {
			firstTryHoleChange = true;
		}, 
		function() {
			if (firstTryHoleChange) {
				changeSmarWatchHole(holeNumber);
			}
			else {
				firstTryHoleChange = true;
			}
		});  */
}
function changeSmartWatchDistance(distance, accuracy, hole) {
	loadAppleWatchDistances(distance, accuracy, hole);

	setSmartWatchValue('distance', distance.toString(), function() {
	 	setSmartWatchValue('accuracy', accuracy.toString(), function() { }, function() { });
	}, function() { 
	 	setSmartWatchValue('accuracy', accuracy.toString(), function() { }, function() { });
	});
}


	// quick offer tracking
function trackOffer(offer_id, type) {
	if (trackOffers) {
		var club_id = 0;
		if (is_club_app) {
			club_id = whitelabel.course.club_id;
		}
		trackAction(APIHOST + '/offers/track/'+offer_id+'/'+type+'/1/'+club_id+'/');
	}
}
function trackTeetime(type) {
	if (trackTeetimes) {
		var club_id = 0;
		if (is_club_app) {
			club_id = whitelabel.course.club_id;
		}
		trackAction(APIHOST + '/users/track/teetime/'+club_id+'/'+type+'/');
			// 0 - phone, 1 - public, 2 - member, 3 - other
	}
}
function trackOpen() {
	if (trackOpens) {
		var club_id = 0;
		if (is_club_app) {
			club_id = whitelabel.course.club_id;
		}
		trackAction(APIHOST + '/users/track/open/'+club_id+'/');
	}
}
function trackPush(offer_id) {
	if (trackPushes) {
		var club_id = 0;
		if (is_club_app) {
			club_id = whitelabel.course.club_id;
		}
		trackAction(APIHOST + '/users/track/push/'+club_id+'/'+offer_id+'/');
	}
}
function trackGeofence(offer_id) {
	if (trackPushes) {
		var club_id = 0;
		if (is_club_app) {
			club_id = whitelabel.course.club_id;
		}
		trackAction(APIHOST + '/users/track/geofence/'+club_id+'/'+offer_id+'/');
	}
}
function trackAction(tracking_url) {
	$.ajax({
               url: tracking_url,
               method: 'GET',
               data: {uid: user.uk},
               success: function(data) {
               		// do nothing.  Just throwing something at the server and not expecting a reply.
               }
            });
}



var analyticsReady = false;
function initAnalytics() {
	if (typeof(window.ga) != 'undefined' && ENABLE_GA) {
		//window.analytics.debugMode();
		window.ga.startTrackerWithId(whitelabel.ga_account);
		window.ga.setAllowIDFACollection(false);
		analyticsReady = true;
	}
	else {
		
	}
}
function setTrackingUID(uid) {
	if (analyticsReady) {
		window.ga.setUserId(uid);
	}
}
function trackView(pageUrl) {
	if (analyticsReady) {
		window.ga.trackView(pageUrl)
	}
}



function openCustomLink(link, openExternal = false, requireAuth = false) {
			// massage the link to identify the user and log them in.
		// tk: this.tk, uk: this.uk, pk: this.pk
		// we are going to send them to an offcourse page and log them in first - then redirect
	if (requireAuth) {
		if (!user.isSignedIn()) {
			myNavigator.pushPage(login_page, { success: function() {
				openCustomLink(link, openExternal);
			}});
			return false;
		}
	}


	if (user.isSignedIn()) {
		var destination_link = CLUBHOST+'/'+whitelabel.app_company+'/tosite/?tk='+user.tk+'&uk='+user.uk+'&pk='+user.pk+'&url='+encodeURI(link);
	}
	else {
		var destination_link = link;
	}

	if (openExternal) {
		window.open(destination_link, '_system');
	}
	else {
		openWindow(destination_link);
	}
	return true;
}




function openWindow(url, theme, listeners) {
	if (typeof(theme) == 'undefined' || !theme) {
		theme = whitelabel.browsertheme;
	}
	if (typeof(listeners) == 'undefined' || !listeners) {
		listeners = {
			backPressed: function(e) {
			    
			},
			closePressed: function(e) {

			}
		};

	}

	var thisBrowser = {};

	if (typeof(cordova) != 'undefined' && typeof(cordova.ThemeableBrowser) != 'undefined') {
		thisBrowser = cordova.ThemeableBrowser.open(url, '_blank', theme);
		$.each(listeners, function(i, func) {
			thisBrowser.addEventListener(i, func);
		});


		var pageLoginListener = function(event) {
				setTimeout(function() {
					if (event.url.indexOf('login') >= 0) {
						var loadingScript = 
							"var jquerychecker = setInterval(function() { "+
								"if (window.jQuery) { " +
									"clearInterval(jquerychecker); " +
									"jQuery(function() { "+
										"jQuery('.LoginFormRemember').find('input').attr('checked', true);" +
									"}); "+
								"} "+
							"}, 100); ";
						//console.log(loadingScript);
						thisBrowser.executeScript({code: loadingScript});
					}		
				}, 200);
			}
		thisBrowser.addEventListener('loadstop', pageLoginListener);

		/*.addEventListener('backPressed', function(e) {
			    //alert('back pressed');
			}).addEventListener('closePressed', function(e) {
			    //alert('hello pressed');
			});*/
		
	}
	else if (typeof(cordova) != 'undefined' && typeof(cordova.InAppBrowser) != 'undefined') {
		thisBrowser = cordova.InAppBrowser.open(url, '_blank', 'location=no');
	}
	else {
		thisBrowser = window.open(url);
	}

	return thisBrowser;
}



function pickRoundDate(apiDate, success) {

	if (!isAndroid) {
		ons.createDialog('datepicker.html').then(function(dialog) {
			 var dialog_elm = $(dialog._dialog);
			 dialog_elm.find('.datepickerinput').val(apiDate);
			 dialog_elm.find('.datepickerok').click(function() {
			 	var date = parseApiDate(dialog_elm.find('.datepickerinput').val());
			 	console.log(date);
			 	success(new Date(date));
			 	dialog.hide();
			 });
			 
			 dialog_elm.find('.datepickercancel').click(function() {
			 	dialog.hide();
			 });
			 
			 dialog.show();
			 setTimeout(function() {
				 dialog_elm.find('.datepickerinput').focus();
			}, 350);
		  });
	}
	else {
		var options =  {
			date: new Date(parseApiDate(apiDate)),
			mode: 'date',
			allowOldDates:    true,
			allowFutureDates: false,
			maxDate: new Date(),
			visibility: 'auto'
		};
		datePicker.show(options, function (returnDate) {
			if(returnDate !== "" && returnDate != 'undefined' && typeof(returnDate) != 'undefined') {
				var date = new Date(returnDate);
				success(date);
			}
		},
		function(err) {
			console.log('datepicker error');
			console.log(err);
		});
	}
}



function phoneCall(thenumber) {
	if (isIOS) {
		document.location.href = 'tel:' + thenumber;
	}
	else {
		window.open('tel:' + thenumber, '_system');
	}
	
}



function shorten(inString, lengthLimit) {
	if (inString.length > lengthLimit) {
		return inString.substr(0,lengthLimit) + '...';
	}
	return inString;
}


function asyncLoop(iterations, func, callback) {
    var index = 0;
    var done = false;
    var loop = {
        'next': function() {
            if (done) {
                return;
            }

            if (index < iterations) {
                index++;
                func(loop);

            } else {
                done = true;
                callback();
            }
        },

        'iteration': function() {
            return index - 1;
        },

        'stop': function() {
            done = true;
            callback();
        }
    };
    loop.next();
    return loop;
}

function utf8_decode(str_data) {
  //  discuss at: http://phpjs.org/functions/utf8_decode/
  // original by: Webtoolkit.info (http://www.webtoolkit.info/)
  //    input by: Aman Gupta
  //    input by: Brett Zamir (http://brett-zamir.me)
  // improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // improved by: Norman "zEh" Fuchs
  // bugfixed by: hitwork
  // bugfixed by: Onno Marsman
  // bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // bugfixed by: kirilloid
  //   example 1: utf8_decode('Kevin van Zonneveld');
  //   returns 1: 'Kevin van Zonneveld'

  var tmp_arr = [],
    i = 0,
    ac = 0,
    c1 = 0,
    c2 = 0,
    c3 = 0,
    c4 = 0;

  str_data += '';

  while (i < str_data.length) {
    c1 = str_data.charCodeAt(i);
    if (c1 <= 191) {
      tmp_arr[ac++] = String.fromCharCode(c1);
      i++;
    } else if (c1 <= 223) {
      c2 = str_data.charCodeAt(i + 1);
      tmp_arr[ac++] = String.fromCharCode(((c1 & 31) << 6) | (c2 & 63));
      i += 2;
    } else if (c1 <= 239) {
      // http://en.wikipedia.org/wiki/UTF-8#Codepage_layout
      c2 = str_data.charCodeAt(i + 1);
      c3 = str_data.charCodeAt(i + 2);
      tmp_arr[ac++] = String.fromCharCode(((c1 & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
      i += 3;
    } else {
      c2 = str_data.charCodeAt(i + 1);
      c3 = str_data.charCodeAt(i + 2);
      c4 = str_data.charCodeAt(i + 3);
      c1 = ((c1 & 7) << 18) | ((c2 & 63) << 12) | ((c3 & 63) << 6) | (c4 & 63);
      c1 -= 0x10000;
      tmp_arr[ac++] = String.fromCharCode(0xD800 | ((c1 >> 10) & 0x3FF));
      tmp_arr[ac++] = String.fromCharCode(0xDC00 | (c1 & 0x3FF));
      i += 4;
    }
  }

  return tmp_arr.join('');
}
function utf8_encode(argString) {
  //  discuss at: http://phpjs.org/functions/utf8_encode/
  // original by: Webtoolkit.info (http://www.webtoolkit.info/)
  // improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // improved by: sowberry
  // improved by: Jack
  // improved by: Yves Sucaet
  // improved by: kirilloid
  // bugfixed by: Onno Marsman
  // bugfixed by: Onno Marsman
  // bugfixed by: Ulrich
  // bugfixed by: Rafal Kukawski
  // bugfixed by: kirilloid
  //   example 1: utf8_encode('Kevin van Zonneveld');
  //   returns 1: 'Kevin van Zonneveld'

  if (argString === null || typeof argString === 'undefined') {
    return '';
  }

  var string = (argString + ''); // .replace(/\r\n/g, "\n").replace(/\r/g, "\n");
  var utftext = '',
    start, end, stringl = 0;

  start = end = 0;
  stringl = string.length;
  for (var n = 0; n < stringl; n++) {
    var c1 = string.charCodeAt(n);
    var enc = null;

    if (c1 < 128) {
      end++;
    } else if (c1 > 127 && c1 < 2048) {
      enc = String.fromCharCode(
        (c1 >> 6) | 192, (c1 & 63) | 128
      );
    } else if ((c1 & 0xF800) != 0xD800) {
      enc = String.fromCharCode(
        (c1 >> 12) | 224, ((c1 >> 6) & 63) | 128, (c1 & 63) | 128
      );
    } else { // surrogate pairs
      if ((c1 & 0xFC00) != 0xD800) {
        throw new RangeError('Unmatched trail surrogate at ' + n);
      }
      var c2 = string.charCodeAt(++n);
      if ((c2 & 0xFC00) != 0xDC00) {
        throw new RangeError('Unmatched lead surrogate at ' + (n - 1));
      }
      c1 = ((c1 & 0x3FF) << 10) + (c2 & 0x3FF) + 0x10000;
      enc = String.fromCharCode(
        (c1 >> 18) | 240, ((c1 >> 12) & 63) | 128, ((c1 >> 6) & 63) | 128, (c1 & 63) | 128
      );
    }
    if (enc !== null) {
      if (end > start) {
        utftext += string.slice(start, end);
      }
      utftext += enc;
      start = end = n + 1;
    }
  }

  if (end > start) {
    utftext += string.slice(start, stringl);
  }

  return utftext;
}
function md5(str) {
  //  discuss at: http://phpjs.org/functions/md5/
  // original by: Webtoolkit.info (http://www.webtoolkit.info/)
  // improved by: Michael White (http://getsprink.com)
  // improved by: Jack
  // improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  //    input by: Brett Zamir (http://brett-zamir.me)
  // bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  //  depends on: utf8_encode
  //   example 1: md5('Kevin van Zonneveld');
  //   returns 1: '6e658d4bfcb59cc13f96c14450ac40b9'

  var xl;

  var rotateLeft = function(lValue, iShiftBits) {
    return (lValue << iShiftBits) | (lValue >>> (32 - iShiftBits));
  };

  var addUnsigned = function(lX, lY) {
    var lX4, lY4, lX8, lY8, lResult;
    lX8 = (lX & 0x80000000);
    lY8 = (lY & 0x80000000);
    lX4 = (lX & 0x40000000);
    lY4 = (lY & 0x40000000);
    lResult = (lX & 0x3FFFFFFF) + (lY & 0x3FFFFFFF);
    if (lX4 & lY4) {
      return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
    }
    if (lX4 | lY4) {
      if (lResult & 0x40000000) {
        return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
      } else {
        return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
      }
    } else {
      return (lResult ^ lX8 ^ lY8);
    }
  };

  var _F = function(x, y, z) {
    return (x & y) | ((~x) & z);
  };
  var _G = function(x, y, z) {
    return (x & z) | (y & (~z));
  };
  var _H = function(x, y, z) {
    return (x ^ y ^ z);
  };
  var _I = function(x, y, z) {
    return (y ^ (x | (~z)));
  };

  var _FF = function(a, b, c, d, x, s, ac) {
    a = addUnsigned(a, addUnsigned(addUnsigned(_F(b, c, d), x), ac));
    return addUnsigned(rotateLeft(a, s), b);
  };

  var _GG = function(a, b, c, d, x, s, ac) {
    a = addUnsigned(a, addUnsigned(addUnsigned(_G(b, c, d), x), ac));
    return addUnsigned(rotateLeft(a, s), b);
  };

  var _HH = function(a, b, c, d, x, s, ac) {
    a = addUnsigned(a, addUnsigned(addUnsigned(_H(b, c, d), x), ac));
    return addUnsigned(rotateLeft(a, s), b);
  };

  var _II = function(a, b, c, d, x, s, ac) {
    a = addUnsigned(a, addUnsigned(addUnsigned(_I(b, c, d), x), ac));
    return addUnsigned(rotateLeft(a, s), b);
  };

  var convertToWordArray = function(str) {
    var lWordCount;
    var lMessageLength = str.length;
    var lNumberOfWords_temp1 = lMessageLength + 8;
    var lNumberOfWords_temp2 = (lNumberOfWords_temp1 - (lNumberOfWords_temp1 % 64)) / 64;
    var lNumberOfWords = (lNumberOfWords_temp2 + 1) * 16;
    var lWordArray = new Array(lNumberOfWords - 1);
    var lBytePosition = 0;
    var lByteCount = 0;
    while (lByteCount < lMessageLength) {
      lWordCount = (lByteCount - (lByteCount % 4)) / 4;
      lBytePosition = (lByteCount % 4) * 8;
      lWordArray[lWordCount] = (lWordArray[lWordCount] | (str.charCodeAt(lByteCount) << lBytePosition));
      lByteCount++;
    }
    lWordCount = (lByteCount - (lByteCount % 4)) / 4;
    lBytePosition = (lByteCount % 4) * 8;
    lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition);
    lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
    lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
    return lWordArray;
  };

  var wordToHex = function(lValue) {
    var wordToHexValue = '',
      wordToHexValue_temp = '',
      lByte, lCount;
    for (lCount = 0; lCount <= 3; lCount++) {
      lByte = (lValue >>> (lCount * 8)) & 255;
      wordToHexValue_temp = '0' + lByte.toString(16);
      wordToHexValue = wordToHexValue + wordToHexValue_temp.substr(wordToHexValue_temp.length - 2, 2);
    }
    return wordToHexValue;
  };

  var x = [],
    k, AA, BB, CC, DD, a, b, c, d, S11 = 7,
    S12 = 12,
    S13 = 17,
    S14 = 22,
    S21 = 5,
    S22 = 9,
    S23 = 14,
    S24 = 20,
    S31 = 4,
    S32 = 11,
    S33 = 16,
    S34 = 23,
    S41 = 6,
    S42 = 10,
    S43 = 15,
    S44 = 21;

  str = this.utf8_encode(str);
  x = convertToWordArray(str);
  a = 0x67452301;
  b = 0xEFCDAB89;
  c = 0x98BADCFE;
  d = 0x10325476;

  xl = x.length;
  for (k = 0; k < xl; k += 16) {
    AA = a;
    BB = b;
    CC = c;
    DD = d;
    a = _FF(a, b, c, d, x[k + 0], S11, 0xD76AA478);
    d = _FF(d, a, b, c, x[k + 1], S12, 0xE8C7B756);
    c = _FF(c, d, a, b, x[k + 2], S13, 0x242070DB);
    b = _FF(b, c, d, a, x[k + 3], S14, 0xC1BDCEEE);
    a = _FF(a, b, c, d, x[k + 4], S11, 0xF57C0FAF);
    d = _FF(d, a, b, c, x[k + 5], S12, 0x4787C62A);
    c = _FF(c, d, a, b, x[k + 6], S13, 0xA8304613);
    b = _FF(b, c, d, a, x[k + 7], S14, 0xFD469501);
    a = _FF(a, b, c, d, x[k + 8], S11, 0x698098D8);
    d = _FF(d, a, b, c, x[k + 9], S12, 0x8B44F7AF);
    c = _FF(c, d, a, b, x[k + 10], S13, 0xFFFF5BB1);
    b = _FF(b, c, d, a, x[k + 11], S14, 0x895CD7BE);
    a = _FF(a, b, c, d, x[k + 12], S11, 0x6B901122);
    d = _FF(d, a, b, c, x[k + 13], S12, 0xFD987193);
    c = _FF(c, d, a, b, x[k + 14], S13, 0xA679438E);
    b = _FF(b, c, d, a, x[k + 15], S14, 0x49B40821);
    a = _GG(a, b, c, d, x[k + 1], S21, 0xF61E2562);
    d = _GG(d, a, b, c, x[k + 6], S22, 0xC040B340);
    c = _GG(c, d, a, b, x[k + 11], S23, 0x265E5A51);
    b = _GG(b, c, d, a, x[k + 0], S24, 0xE9B6C7AA);
    a = _GG(a, b, c, d, x[k + 5], S21, 0xD62F105D);
    d = _GG(d, a, b, c, x[k + 10], S22, 0x2441453);
    c = _GG(c, d, a, b, x[k + 15], S23, 0xD8A1E681);
    b = _GG(b, c, d, a, x[k + 4], S24, 0xE7D3FBC8);
    a = _GG(a, b, c, d, x[k + 9], S21, 0x21E1CDE6);
    d = _GG(d, a, b, c, x[k + 14], S22, 0xC33707D6);
    c = _GG(c, d, a, b, x[k + 3], S23, 0xF4D50D87);
    b = _GG(b, c, d, a, x[k + 8], S24, 0x455A14ED);
    a = _GG(a, b, c, d, x[k + 13], S21, 0xA9E3E905);
    d = _GG(d, a, b, c, x[k + 2], S22, 0xFCEFA3F8);
    c = _GG(c, d, a, b, x[k + 7], S23, 0x676F02D9);
    b = _GG(b, c, d, a, x[k + 12], S24, 0x8D2A4C8A);
    a = _HH(a, b, c, d, x[k + 5], S31, 0xFFFA3942);
    d = _HH(d, a, b, c, x[k + 8], S32, 0x8771F681);
    c = _HH(c, d, a, b, x[k + 11], S33, 0x6D9D6122);
    b = _HH(b, c, d, a, x[k + 14], S34, 0xFDE5380C);
    a = _HH(a, b, c, d, x[k + 1], S31, 0xA4BEEA44);
    d = _HH(d, a, b, c, x[k + 4], S32, 0x4BDECFA9);
    c = _HH(c, d, a, b, x[k + 7], S33, 0xF6BB4B60);
    b = _HH(b, c, d, a, x[k + 10], S34, 0xBEBFBC70);
    a = _HH(a, b, c, d, x[k + 13], S31, 0x289B7EC6);
    d = _HH(d, a, b, c, x[k + 0], S32, 0xEAA127FA);
    c = _HH(c, d, a, b, x[k + 3], S33, 0xD4EF3085);
    b = _HH(b, c, d, a, x[k + 6], S34, 0x4881D05);
    a = _HH(a, b, c, d, x[k + 9], S31, 0xD9D4D039);
    d = _HH(d, a, b, c, x[k + 12], S32, 0xE6DB99E5);
    c = _HH(c, d, a, b, x[k + 15], S33, 0x1FA27CF8);
    b = _HH(b, c, d, a, x[k + 2], S34, 0xC4AC5665);
    a = _II(a, b, c, d, x[k + 0], S41, 0xF4292244);
    d = _II(d, a, b, c, x[k + 7], S42, 0x432AFF97);
    c = _II(c, d, a, b, x[k + 14], S43, 0xAB9423A7);
    b = _II(b, c, d, a, x[k + 5], S44, 0xFC93A039);
    a = _II(a, b, c, d, x[k + 12], S41, 0x655B59C3);
    d = _II(d, a, b, c, x[k + 3], S42, 0x8F0CCC92);
    c = _II(c, d, a, b, x[k + 10], S43, 0xFFEFF47D);
    b = _II(b, c, d, a, x[k + 1], S44, 0x85845DD1);
    a = _II(a, b, c, d, x[k + 8], S41, 0x6FA87E4F);
    d = _II(d, a, b, c, x[k + 15], S42, 0xFE2CE6E0);
    c = _II(c, d, a, b, x[k + 6], S43, 0xA3014314);
    b = _II(b, c, d, a, x[k + 13], S44, 0x4E0811A1);
    a = _II(a, b, c, d, x[k + 4], S41, 0xF7537E82);
    d = _II(d, a, b, c, x[k + 11], S42, 0xBD3AF235);
    c = _II(c, d, a, b, x[k + 2], S43, 0x2AD7D2BB);
    b = _II(b, c, d, a, x[k + 9], S44, 0xEB86D391);
    a = addUnsigned(a, AA);
    b = addUnsigned(b, BB);
    c = addUnsigned(c, CC);
    d = addUnsigned(d, DD);
  }

  var temp = wordToHex(a) + wordToHex(b) + wordToHex(c) + wordToHex(d);

  return temp.toLowerCase();
}



/*
	Javascript Error Logging
*/

if (typeof(JL) == "function") {
	JL.setOptions({
		"enabled": true,
		"defaultAjaxUrl": APIHOST + "/users/logging/",
	    "requestId": new Date()
	});
		// setup error logging
	window.onerror = function (errorMsg, url, lineNumber, column, errorObj) {
   	
	    // Send object with all data to server side log, using severity fatal, 
	    // from logger "onerrorLogger"
	    JL("onerrorLogger").fatalException({
	        "msg": "Exception", 
	        "errorMsg": errorMsg, "url": url, 
	        "line number": lineNumber, "column": column
	    }, errorObj);
		
	    // Tell browser to run its own error handler as well   
	    return false;
	}
}



app.initialize();






